/*
 * Copyright 2004-2009 ISP RAS (http://www.ispras.ru), UniTESK Lab (http://www.unitesk.com)
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
header
{
    package ru.ispras.redverst.sscl;    
    import java.io.InputStream;
	import java.io.Reader;
	import java.util.Hashtable;
    import java.util.HashMap;
	import antlr.ANTLRHashString;
	import antlr.ByteBuffer;
	import antlr.CharBuffer;
	import antlr.CharStreamException;
	import antlr.CharStreamIOException;
	import antlr.InputBuffer;
	import antlr.LexerSharedInputState;
	import antlr.NoViableAltForCharException;
	import antlr.RecognitionException;
	import antlr.Token;
	import antlr.TokenStream;
	import antlr.TokenStreamException;
	import antlr.TokenStreamIOException;
	import antlr.TokenStreamRecognitionException;
	import antlr.TokenStreamSelector;
	import antlr.collections.impl.BitSet;

    import java.util.ArrayList;
	import java.util.List;
	import ru.ispras.redverst.stg.semobj.HorizontalSyntComb;
	import ru.ispras.redverst.stg.semobj.SyntacticCombination;

	import ru.ispras.redverst.stg.semrel.SemanticRelation;
	import antlr.NoViableAltException;
	import antlr.ParserSharedInputState;
	import antlr.TokenBuffer;
}
class SSCL_Lexer extends Lexer;
options
{
 // k = 2;
  testLiterals = true;
  charVocabulary='\u0003'..'\uFFFE';
  charVocabulary = '\3'..'\377';
  importVocab = CODE;
}

tokens
{
	NODE = "node";
	SSCONSTRAINT = "ssconstraint";
	COMMENT = "comment";
    LANG = "lang";
    ANSIC = "ansic";
    JAVA = "java";
    CSHARP = "csharp";
    FORBIDDEN = "forbidden";
    MANDATORY = "mandatory";
    ANCESTOR = "ancestor";    
    DESCENDENT = "descendent";    
    IRRELEVANT = "irrelevant";
    RELEVANT = "relevant";
    HORIZONTAL = "horizontal";
    VERTICAL = "vertical";
    DEPTH = "depth";
}
{
    protected TokenStreamSelector selector;
  
    public void setSelector( TokenStreamSelector selector )
    {
        this.selector = selector;
    }
}

WS : (   ' ' 
       | '\t' 
       | '\f' 
       | (                                                               
            /*                                                           
             * '\r' '\n' can be matched in one alternative or by matching
             * '\r' and then in the next token.  The language            
             * that allows both "\r\n" and "\r" and "\n" to all be valid 
             * newline is ambiguous.  Consequently, the resulting grammar
             * must be ambiguous.  I'm shutting this warning off.        
             */                                                          
             options                                                     
             {                                                           
               generateAmbigWarnings=false;                              
             } :                                                         
          /*   '\r' '\n'                                                   
           |*/ '\r'                                                        
           | '\n'                                                        
         )                                                               
         { newline(); }                                                  
       )+ ;

SCOMMENT : '/' ({LA(1)=='/'}?(~'\n')* '\n' {newline();} || {LA(1)=='*'}? (  { LA(2)!='/' }? '*'
																            | ('\n' { newline(); })
																            | ~('*'|'\n')
																         )*
																         "*/");
protected
HEX_DIGIT : ( '0'..'9' | 'A'..'F' | 'a'..'f' ) ;

protected
ESC : '\\'
      (   'n'
        | 'r'
        | 't'
        | 'b'
        | 'f'
        | '"'
        | '\''
        | '\\'
        | ('u')+ HEX_DIGIT HEX_DIGIT HEX_DIGIT HEX_DIGIT 
        | ('0'..'3')
          (
            options
            {
              warnWhenFollowAmbig = false;
            } :
              ('0'..'7')
              (    
                options
                {
                  warnWhenFollowAmbig = false;
                } :
                '0'..'7'
              )?
          )?
        | ('4'..'7')
          (
            options
            {
              warnWhenFollowAmbig = false;
            } :
            ('0'..'9')
          )?
      )
    ;

STRING_LITERAL : '"' (ESC | ~( '"' | '\\' ))* '"' ;
protected
CHARACTER_LITERAL : '\'' ( ESC | ~'\'' ) '\'' ;

protected
LETTER : 'A'..'Z' | 'a'..'z' | '_' ;

protected
DIGIT : '0'..'9' ; 

INT_LITERAL : ( '-' )? ( DIGIT )+ ;

ID 
: LETTER ( LETTER | DIGIT )* 
  /*{
    _ttype = testLiteralsTable( _ttype );

    if(    _ttype == DEFINE
        || _ttype == SYNCHRONIZE
        || _ttype == FILTER        
      )
    {
        selector.push( "code" );
    }
  }*/
;

/*ASTERISK  : '*' ;
COLON     : ':' ;*/
COMMA     : ',' ;
/*DOT       : '.' ;
EQUAL     : '=' ;
PLUS      : '+' ;
SEMICOLON : ';' ;
QUESTION  : '?' ;
UP_ARROW  : '^' ;*/
 
LC        : '{' ;
RC        : '}' ;

LSB       : '[' ;
RSB       : ']' ;
LB        : '(' ;
RB        : ')' ;
/*
protected
OTHER_TOKEN : ( options { greedy = true; } : 
                ~( '\t'|'\r'|'\f'|'\n'|' '|'/'|'"'|'\''|'{'|'}' ) 
              )+
            ;

protected
BLOCK : LC
        (   WS 
          | CHARACTER_LITERAL 
          | STRING_LITERAL 
          | SL_COMMENT 
          | ML_COMMENT 
          | OTHER_TOKEN
          | BLOCK
        )* 
        RC
      ;

CODE : ( WS )? BLOCK;
//CODE : BLOCK;*/

//==============================================================================

class SSCL_Parser extends Parser;
 options 
 {
   defaultErrorHandler=false;
 }
{
 public HashMap ssconstrMap = new HashMap(0);
 private int count = 0;
}
//-------------------------------------------
parse

:  
  ( NODE node  )*
;
//-------------------------------------------
node
{
	String nodeType = null;
	List ssconstrList = new ArrayList(0);	
    SyntacticCombination syntComb = null;
}
:
    nodeType = node_type
   LC
  	(SSCONSTRAINT  syntComb = ssconstraint {ssconstrList.add(syntComb);})+
   RC
  	{ssconstrMap.put(nodeType,ssconstrList);}	
;  
//-------------------------------------------
ssconstraint returns [SyntacticCombination syntComb]
{
	syntComb = null;
	String comment = null;
	int combType = 0;
	String ancesType = null;
    List/*String*/ irrelevantNodeList = new ArrayList(0);	
    List/*String*/ relevantNodeList = new ArrayList(0);	    
    boolean isHorizontal = false;
    String descenType = null;
    Integer depth = new Integer(-1);
    System.out.println(++count);
}
: 
(LC
  (COMMENT  comment = comment)? 
  (FORBIDDEN {combType = SyntacticCombination.FORBIDDEN;}
  | MANDATORY {combType = SyntacticCombination.MANDATORY;})
  ANCESTOR ancesType = node_type 
  (IRRELEVANT irrelevantNodeList = node_list)? 
  (RELEVANT relevantNodeList = node_list)?   
  (HORIZONTAL {isHorizontal = true;} 
  | (
     VERTICAL {isHorizontal = false;} 
     (DESCENDENT descenType = node_type)?
     (DEPTH depth = depth)?
    ))
RC)
{    System.out.println(ancesType); 
     if (!isHorizontal)
     {
     	syntComb = new SyntacticCombination(combType
	                           , ancesType
                               , descenType
                               , irrelevantNodeList
                               , relevantNodeList
                               , depth.intValue()<0 ? 10000 : depth.intValue() );
           
     }
     else
     {
     	syntComb = new HorizontalSyntComb( combType
							  , ancesType
							  , irrelevantNodeList
							  , relevantNodeList);
     }
     syntComb.setComment(comment);
}
;
//-------------------------------------------
node_type returns [String ntype]
{
	ntype = null;
}
: id:ID {ntype = id.getText();} 
;
//-------------------------------------------
depth returns [Integer depth]
{
	depth = new Integer(-1);
}
: n:INT_LITERAL {depth = new Integer(n.getText());}
;
//-------------------------------------------
comment returns [String com]
{
  com = null;
}
: t: STRING_LITERAL
  {com = t.getText();}
;
//-------------------------------------------
node_list returns [List childList]
{
	String type = null;
	childList = new ArrayList(0);
}
:	LB
	 type = node_type{childList.add(type);}
	 (COMMA type = node_type{childList.add(type);})*
	RB
;
//-------------------------------------------
//srl ::= "lang" "ansic" | "java" | "csharp" (semantic_relation)* 
//-------------------------------------------
/*
semantic_relation returns [SemanticRelation semRel]
{ 
  semRel = new SemanticRelation();
  String com = null;
  SyntacticCoordinate synCoord = null;
  String code = null;
  int type = -1;
  SyntacticCoordinate environ = new SyntacticCoordinate();
  System.out.println(++semRelCount);
}		
: LC 
	  (COMMENT  com = comment {semRel.setComment(com);})? 
      (ARBITRARY {semRel.setPrintOrder(SemanticRelation.ARBITRARY);} | SEMANTIC {semRel.setPrintOrder(SemanticRelation.SEMANTIC);})
      (CONFLICT {semRel.setEquivalent(true);})?
	  TARGET  target[semRel] 
	  (SOURCE  source[semRel])? 
	  TYPE  type = s_type {semRel.setType(type);}
	  (ENVIRONMENT  s_environment[semRel])? 
	  DEFINE  code = code {semRel.setDefineCode(new StringBuffer(code));}  
	  SYNCHRONIZE  code = code {semRel.setSynchronizeCode(new StringBuffer(code));}   
  (WS)? RC 
 {
	 System.out.println(semRel.getComment());
 }
;
//-------------------------------------------
node_type returns [String ntype]
{
	ntype = null;
}
: id:ID {ntype = id.getText();} 
;
//-------------------------------------------
target [SemanticRelation semRel]
{
	String type = null;
	String code = null;
	List childList = null;
}
: id:ID {semRel.setTrgType(id.getText());semRel.setSrcType(id.getText());}
  (CHILD childList = child {semRel.setTrgSemantDepChildList(childList);})?

  (FILTER code = code {semRel.setTrgFilterCode(new StringBuffer(code));})?
;
//-------------------------------------------
source [SemanticRelation semRel]
{
	String type = null;
	String code = null;
	List childList = null;
}
: id:ID {semRel.setSrcType(id.getText());}
  (CHILD childList = child{semRel.setSrcSemantDepChildList(childList);})?

  (FILTER code = code {semRel.setSrcFilterCode(new StringBuffer(code));})?
;
//-------------------------------------------
comment returns [String com]
{
  com = null;
}
: //COMMENT
  t: STRING_LITERAL//TEXT
  {com = t.getText();}
;
//-------------------------------------------
child returns [List childList]
{
	String type = null;
	childList = new ArrayList(0);
}
://CHILD 
	LB
	 type = node_type{childList.add(type);}
	 (COMMA type = node_type{childList.add(type);})*
	RB
;
//-------------------------------------------
s_type returns [int type]
{
 type = -1;
}
: 
(
  ONE_TO_ONE {type = SemanticRelation.ONE_TO_ONE;}
| ONE_TO_MANY {type = SemanticRelation.ONE_TO_MANY;}
| MANY_TO_MANY {type = SemanticRelation.MANY_TO_MANY;}
)

;
//-------------------------------------------
s_environment [SemanticRelation semRel]
{
	SyntacticCoordinate environ = new SyntacticCoordinate();
	String type = null;
	String code = null;
}
: //ENVIRONMENT 
  id:ID {environ.setSubTreeRootType(id.getText());} //ID type = node_type {environ.setSubTreeRootType(type);} (WS)*
  ( SAME {environ.setSubTreeKind(SyntacticCoordinate.SAME);} 
  | DIFFER {environ.setSubTreeKind(SyntacticCoordinate.OTHER);} )

  ( FILTER  code = code {semRel.setSubTreeConditionCode(new StringBuffer(code));})?  
  {
	semRel.setCoordinate(environ);
  }
 ;
//-------------------------------------------
code returns [String code]
{
    code = null;
}
: t:CODE
  {
      code = t.getText().trim();
      if( code.length() > 2 )
      {
          code = code.substring( 1, code.length() - 1 );
      } else {
          code = "";
      }
  }
;*/
