/*
 * Copyright 2004-2009 ISP RAS (http://www.ispras.ru), UniTESK Lab (http://www.unitesk.com)
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package ru.ispras.redverst.srl.parser;

import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;


public class _DescObject 
{
    private String name;
    private List/*String*/ desc;
   
    /**
    @roseuid 422457DA0167
     */
    public _DescObject() 
    {
        this.name = "";
        this.desc = new ArrayList(0);    
    }

    public _DescObject(String name, List desc) 
    {
        this.name = name;
        this.desc = desc;    
    }
    
	public List getDesc()
	{
	    return desc;
	}
	public void setDesc(List desc)
	{
	    this.desc = desc;
	}
	public String getName()
	{
	    return name;
	}
	public void setName(String name)
	{
	    this.name = name;
	}
	public StringBuffer descToStringBuffer()
	{
	    StringBuffer res = new StringBuffer();
	    for (Iterator iter = this.desc.iterator(); iter.hasNext();)
        {
            String element = (String) iter.next();
            res.append(element + "\n");
        }
	    return res;
	}
	public void replace(String oldStr, String newStr)
	{
	    name = name.replaceAll(oldStr, newStr);
	    
	    List newList = new ArrayList(this.desc.size());  
	    for (Iterator iter = this.desc.iterator(); iter.hasNext();)
        {
            String element = (String) iter.next();
            newList.add(element.replaceAll(oldStr, newStr));
        }
	    this.desc = newList;
	}	
	public void addDesc(List descList)
	{
	    this.desc.addAll(descList);
	}
	public void addDesc(String desc)
	{
	    this.desc.add(desc);
	}
	public void addDesc(StringBuffer desc)
	{
	    
	    this.desc.add(desc.toString());
	}	
	/**
     * 
     */
    public boolean contains(String str)
    {
        if (this.name.indexOf(str)>=0) return true;
        for (int i = 0; i < desc.size(); i++)
        {
            if (((String)this.desc.get(i)).indexOf(str) >= 0)
                return true;            
        }
        return false;        
    }
}
