/*
 * Copyright 2004-2009 ISP RAS (http://www.ispras.ru), UniTESK Lab (http://www.unitesk.com)
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
// Generated by tdt, version 1.4
// Source file: modl.tdt
// Date: Wed Oct 29 13:03:52 MSK 2003


//-----------------------------------------------------------------------------
// header

	package ru.ispras.redverst.stg.base;

import java.lang.reflect.Field;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.HashMap;
import java.util.Iterator;
import java.util.List;
import java.util.Set;
import java.util.StringTokenizer;

import ru.ispras.redverst.iterator.ValueIterator;
import ru.ispras.redverst.stg.base.iterators.StgNodeIterator;
import ru.ispras.redverst.stg.base.visitors.Modl_Visitor;
import ru.ispras.redverst.stg.base.visitors.VisitorAddChildToSubTree;
import ru.ispras.redverst.stg.base.visitors.VisitorAttrValueSetter;
import ru.ispras.redverst.stg.base.visitors.VisitorChangeExpressionType;
import ru.ispras.redverst.stg.base.visitors.VisitorCopierNodeWithAttachment;
import ru.ispras.redverst.stg.base.visitors.VisitorDeleteNode;
import ru.ispras.redverst.stg.base.visitors.VisitorDescenListReceiver;
import ru.ispras.redverst.stg.base.visitors.VisitorExchangeChild;
import ru.ispras.redverst.stg.base.visitors.VisitorGetChildList;
import ru.ispras.redverst.stg.base.visitors.VisitorMultiWaysAdderChild;
import ru.ispras.redverst.stg.base.visitors.VisitorNodeIteratorSeek;
import ru.ispras.redverst.stg.base.visitors.VisitorSyntaxComplete;
import ru.ispras.redverst.stg.base.visitors.VisitorTreeCreator;
import ru.ispras.redverst.stg.exceptions.RepeatedInfluenceException;
import ru.ispras.redverst.stg.exceptions.SemanticConstrViolation;
import ru.ispras.redverst.stg.exceptions.SemanticFormalizationException;
import ru.ispras.redverst.stg.exceptions.StgException;
import ru.ispras.redverst.stg.exceptions.SynchronizeContradictionException;
import ru.ispras.redverst.stg.global.GlobalProperties;
import ru.ispras.redverst.stg.global.Messages;
import ru.ispras.redverst.stg.managers.MainGenerationCycle;
import ru.ispras.redverst.stg.semobj.HorizontalSyntComb;
import ru.ispras.redverst.stg.semobj.SemanticTree;
import ru.ispras.redverst.stg.semobj.SyntacticCombination;
import ru.ispras.redverst.stg.semrel.AncesElement;
import ru.ispras.redverst.stg.semrel.EmptySemRelList;
import ru.ispras.redverst.stg.semrel.FullSemRelList;
import ru.ispras.redverst.stg.semrel.ModlSemSyntNodeConstr;
import ru.ispras.redverst.stg.semrel.SemanticRelHashMap;
import ru.ispras.redverst.stg.semrel.SemanticRelation;
import ru.ispras.redverst.stg.semrel.SemanticRelationDescriptor;
import ru.ispras.redverst.stg.tdt.StgNodeDecl;
import ru.ispras.redverst.stg.tdt.StgTree;
import ru.ispras.redverst.stg.utils.Utils;

import com.unitesk.atp.dynattrs.AttributeException;
import com.unitesk.atp.tree.Visitor;
import com.unitesk.atp.tree.TreeClass.NodeClass;
import com.unitesk.atp.treedl.TDL;
import com.unitesk.atp.treedl.TDL.Attribute;
import com.unitesk.atp.treedl.TDL.Child;
import com.unitesk.atp.treedl.TDL.FieldDescriptor;
import com.unitesk.atp.treedl.TDL.NodeDecl;
import com.unitesk.atp.treedl.TDL.NodeType;


public class BaseNode extends NodeClass
{	
	
	static final public int ORDINARY = 0; 
	static final public int SOURCE = 1; 
	static final public int TARGET = 2; 
//	static final public int CONTEXT = 3;
	static final public int SRCCONTEXT = 4; 
	static final public int TRGCONTEXT = 5; 	
	protected int keyKind = ORDINARY;
    
	protected int printOrder = -1;
    protected int level = GlobalProperties.START_NODE_LEVEL_ID; 
    protected double printOrderId = GlobalProperties.START_NODE_PRINT_ID; 
    
	protected boolean syntChecked = false;	
	public static int counter;
    //-------------------------------------------------------------------------
    static final public int DEFAULT = 6;
    static final public int SPECIAL = DEFAULT + 1;
    
    protected int created = DEFAULT;	
    protected boolean prohibitedToDelete = false;
    //-------------------------------------------------------------------------
	public final static int SYNCH = 8;
	public final static int COUNT = SYNCH + 1;
	public final static int INIT = COUNT + 1;

    //	-------------------------------------------------------------------------
    static final public int MAIN_SOURCE = INIT + 1; 
    static final public int MAIN_TARGET = MAIN_SOURCE + 1; 
    static final public int MAIN_SRCCONTEXT = MAIN_TARGET + 1; 
    static final public int MAIN_TRGCONTEXT = MAIN_SRCCONTEXT + 1;     
    
//    protected VisitorCopierNodeWithAttachment copierNodeWithAttach;
//	protected VisitorDescenListReceiver descenListReceiver;
//	protected VisitorExchangeChild childExchanger;
//	protected VisitorGetChildList childListGetter;
//	protected VisitorMultiWaysAdderChild multiWaysAdder;
//	protected VisitorNodeIteratorSeek nodeIteratorFinder;
//	protected VisitorTreeCreator treeCreator;
//	protected VisitorSyntaxComplete syntaxChecker;
	public VisitorAttrValueSetter valueSetter;
	public VisitorChangeExpressionType typeChanger;
//	public VisitorDeleteNode nodeDeleter;
	
	public void visitorsInit( /*VisitorCopierNodeWithAttachment copierNodeWithAttach,
									 VisitorDescenListReceiver descenListReceiver,
									 VisitorExchangeChild childExchanger,
									 VisitorGetChildList childListGetter,
									 VisitorMultiWaysAdderChild multiWaysAdder,
									 VisitorNodeIteratorSeek nodeIteratorFinder,
									 VisitorTreeCreator treeCreator,
	                                 VisitorSyntaxComplete syntaxChecker, 
	                                 VisitorAttrValueSetter valueSetter, 
	                                 VisitorChangeExpressionType typeChanger,
	                                 VisitorDeleteNode nodeDeleter*/)
	{
		//BaseNode.copierNodeWithAttach = copierNodeWithAttach;
//		BaseNode.descenListReceiver = descenListReceiver;
//		BaseNode.childExchanger = childExchanger;
//		BaseNode.childListGetter = childListGetter;
//		BaseNode.multiWaysAdder = multiWaysAdder;
//		BaseNode.nodeIteratorFinder = nodeIteratorFinder;
//		BaseNode.treeCreator = treeCreator;
//		BaseNode.syntaxChecker = syntaxChecker;
//		BaseNode.valueSetter = valueSetter;
//		BaseNode.typeChanger = typeChanger;
//		BaseNode.nodeDeleter = nodeDeleter;
//	    try
//        {
//            copierNodeWithAttach = (VisitorCopierNodeWithAttachment) Class
//                    .forName(
//                            "ru.ispras.redverst.stg.langdep.visitors."
//                                    + GlobalProperties.TARGET_LANGUAGE
//                                    + "VisitorCopierNodeWithAttachment")
//                    .newInstance();
//            descenListReceiver = (VisitorDescenListReceiver) Class.forName(
//                    "ru.ispras.redverst.stg.langdep.visitors."
//                            + GlobalProperties.TARGET_LANGUAGE
//                            + "VisitorDescenListReceiver").newInstance();
//            childExchanger = (VisitorExchangeChild) Class.forName(
//                    "ru.ispras.redverst.stg.langdep.visitors."
//                            + GlobalProperties.TARGET_LANGUAGE
//                            + "VisitorExchangeChild").newInstance();
//            childListGetter = (VisitorGetChildList) Class.forName(
//                    "ru.ispras.redverst.stg.langdep.visitors."
//                            + GlobalProperties.TARGET_LANGUAGE
//                            + "VisitorGetChildList").newInstance();
//            multiWaysAdder = (VisitorMultiWaysAdderChild) Class.forName(
//                    "ru.ispras.redverst.stg.langdep.visitors."
//                            + GlobalProperties.TARGET_LANGUAGE
//                            + "VisitorMultiWaysAdderChild").newInstance();
//            nodeIteratorFinder = (VisitorNodeIteratorSeek) Class.forName(
//                    "ru.ispras.redverst.stg.langdep.visitors."
//                            + GlobalProperties.TARGET_LANGUAGE
//                            + "VisitorNodeIteratorSeek").newInstance();
//            treeCreator = (VisitorTreeCreator) Class.forName(
//                    "ru.ispras.redverst.stg.langdep.visitors."
//                            + GlobalProperties.TARGET_LANGUAGE
//                            + "VisitorTreeCreator").newInstance();
//            syntaxChecker = (VisitorSyntaxComplete) Class.forName(
//                    "ru.ispras.redverst.stg.langdep.visitors."
//                            + GlobalProperties.TARGET_LANGUAGE
//                            + "VisitorSyntaxComplete").newInstance();
//            valueSetter = (VisitorAttrValueSetter) Class.forName(
//                    "ru.ispras.redverst.stg.langdep.visitors."
//                            + GlobalProperties.TARGET_LANGUAGE
//                            + "VisitorAttrValueSetter").newInstance();
//            typeChanger = (VisitorChangeExpressionType) Class.forName(
//                    "ru.ispras.redverst.stg.langdep.visitors."
//                            + GlobalProperties.TARGET_LANGUAGE
//                            + "VisitorChangeExpressionType").newInstance();
//            nodeDeleter = (VisitorDeleteNode) Class.forName(
//                    "ru.ispras.redverst.stg.langdep.visitors."
//                            + GlobalProperties.TARGET_LANGUAGE
//                            + "VisitorDeleteNode").newInstance();
//        }
//        catch (Exception e)
//        {
//            throw new IllegalStateException(e.getMessage() + e.getClass().getCanonicalName());
//        }
	}
	
    // attribute

    protected int influenceCounter;

    public int getInfluenceCounter()
    {
        return influenceCounter;
    }

    public void setInfluenceCounter( int influenceCounter )
    {
        this.influenceCounter = influenceCounter;
    }
    //-------------------------------------------------------------------------
    // attribute

    protected int synchronizeCounter;

    public int getSynchronizeCounter()
    {
        return synchronizeCounter;
    }

    public void setSynchronizeCounter( int synchronizeCounter )
    {
        this.synchronizeCounter = synchronizeCounter;
    }
    //-------------------------------------------------------------------------
    // attribute

    protected boolean synchStart;

    public boolean getSynchStart()
    {
        return synchStart;
    }

    public void setSynchStart( boolean synchStart )
    {
        this.synchStart = synchStart;
    }
    //-------------------------------------------------------------------------
    // attribute

    protected boolean synchron;

    public boolean getSynchron()
    {
        return synchron;
    }

    public void setSynchron( boolean synchron )
    {
        this.synchron = synchron;
    }
    //-------------------------------------------------------------------------
    // attribute

    protected boolean printed;

    public boolean getPrinted()
    {
        return printed;
    }

    public void setPrinted( boolean printed )
    {
        this.printed = printed;
    }
    //-------------------------------------------------------------------------
    // attribute

    protected FullSemRelList semRelList;

    public FullSemRelList getSemRelList()
    {
        return semRelList!=null ? semRelList : new FullSemRelList();
    }

    public void setSemRelList( FullSemRelList semRelList )
    {
        if( semRelList == null )
        {
            throw new NullPointerException();
        }

        this.semRelList = new FullSemRelList();
        this.semRelList.addAll(semRelList);
    }
    //-------------------------------------------------------------------------
    // attribute

    protected FullSemRelList influenceList;

    public FullSemRelList getInfluenceList()
    {
        return (influenceList != null) ? influenceList : new FullSemRelList();
    }

    public void setInfluenceList( FullSemRelList influenceList )
    {
        if( influenceList == null )
        {
            throw new NullPointerException();
        }

        this.influenceList = influenceList;
    }
    //-------------------------------------------------------------------------
    // body code

   /*     public FullSemRelList getAllChildInfluenceList() throws StgException
        {
        	VisitorGetChildList childListReceiver = new VisitorGetChildList();
        	this.visit(childListReceiver);
        	List childList = childListReceiver.getChildList();
        	FullSemRelList res = new FullSemRelList();

        	for (int i = 0; i < childList.size(); i++)
			{
				res.addAll(((BaseNode) childList.get(i)).getInfluenceList());
			}

        	return res;
        }*/

    	protected  boolean changeable;
	    protected  int setMode;
		/**
		 * @return
		 */
		public int getSetMode()
		{
			return setMode;
		}

		/**
		 * @param i
		 */
		public void setSetMode(int i)
		{
			setMode = i;
		}
		protected BaseNode( String[] childTypesList)throws StgException
		{
			//     
			this();

//			semRelList = new FullSemRelList();
//			influenceList = new FullSemRelList();
		}

	    //-------------------------------------------------------------------------
	    /**
	     *
	     */
		// deprecated
//		public void addSemRel(SemanticRelation semRel)
//		{
//			if(this.semRelList==null)this.semRelList = new FullSemRelList();
//			if(this.semRelList.contains(semRel)<0)
//			{
//				this.semRelList.add(semRel);
//			}
//		}
		//-------------------------------------------------------------------------
		/**
		 *        
		 */
//		public static void addSemRelToList(List/*BaseNode*/ nodeList,SemanticRelation semRel)
//		{
//			if(nodeList == null || semRel == null) throw new NullPointerException();
//			
//			int nodeListSize = nodeList.size();
//			for (int i = 0; i < nodeListSize; i++) 
//			{
//			  try 
//			  {
//				BaseNode currNode = (BaseNode) nodeList.get(i);
//				if(currNode.semRelList==null)currNode.semRelList = new FullSemRelList();
//				if(currNode.semRelList.containsSemRel(semRel)<0)
//				{
//					currNode.semRelList.add(semRel);
//				}				
//			
//			  } catch (ClassCastException e) 
//			  {
//				throw new IllegalArgumentException();
//			  }			  
//			} 
//
//		}	
		//-------------------------------------------------------------------------
		/**
		 *       
		 */
//		public static void addInfluenceToList(List/*BaseNode*/ nodeList,SemanticRelation semRel)
//		{
//			if(nodeList == null || semRel == null) throw new NullPointerException();
//			
//			int nodeListSize = nodeList.size();
//			for (int i = 0; i < nodeListSize; i++) 
//			{
//			  try 
//			  {
//				BaseNode currNode = (BaseNode) nodeList.get(i);
//				if(currNode.influenceList==null)currNode.influenceList = new FullSemRelList();
//				if(currNode.influenceList.containsSemRel(semRel)<0)
//				{
//					currNode.influenceList.add(semRel);
//				}				
//			
//			  } catch (ClassCastException e) 
//			  {
//				throw new IllegalArgumentException();
//			  }			  
//			} 
//
//		}	
	    //-------------------------------------------------------------------------
	    /**
	     *
	     */
		public void addInfluence(SemanticRelation semRel)
		{
			if(this.influenceList==null)this.influenceList = new FullSemRelList();
			if(this.influenceList.containsSemRel(semRel)<0)
			{
				this.influenceList.add(semRel);
			}
		}
//      -------------------------------------------------------------------------
        /**
         *
         */
        public void removeInfluence(SemanticRelation semRel)
        {
            if(this.influenceList==null)return;
            this.influenceList.getSemList().remove(semRel);
        }        
	    //-------------------------------------------------------------------------
	    /**
	     *
	     */
		public void addAllInfluence(FullSemRelList semRel)
		{
			if(this.influenceList==null)this.influenceList = new FullSemRelList();
			for (int i = 0; i < semRel.size(); i++)
            {
                this.addInfluence(semRel.getSemList(i));
            }
		}		
	    //-------------------------------------------------------------------------
	    /**
	     *
	     */
		public void addSemRel(SemanticRelation semRel)
		{
			if(this.semRelList==null)this.semRelList = new FullSemRelList();
			if(this.semRelList.containsSemRel(semRel)<0)
			{
				this.semRelList.add(semRel);
			}
		}	
//      -------------------------------------------------------------------------
        /**
         *
         */
        public void removeSemRel(SemanticRelation semRel)
        {
            if(this.semRelList==null)return;
            this.semRelList.getSemList().remove(semRel);
        }           
	    //-------------------------------------------------------------------------
	    /**
	     *
	     */
		public void addAllSemRel(FullSemRelList semRel)
		{
			if(this.semRelList==null)this.semRelList = new FullSemRelList();
			for (int i = 0; i < semRel.size(); i++)
            {
               this.addSemRel(semRel.getSemList(i));
            }
		}			
		//-------------------------------------------------------------------------
		/**
		 * @return if this has such kind ancestor
		 */
		public boolean hasAncestor(int kind)
		{
			//if(kind==null) throw new IllegalArgumentException();

			BaseNode parentNode = this;

			while (parentNode!=null)
			{
				if (parentNode.getKeyKind() == kind)
				{
					return true;
				}
				else
				{
					parentNode = (BaseNode)parentNode.getParent();
				}
			}

			return false;
		}		
		//-------------------------------------------------------------------------
		/**
		 * @return true  node   this 
		 *  this=node,  true
		 */
		public boolean hasAncestor(BaseNode node)
		{
			if(node==null) throw new IllegalArgumentException();

			BaseNode parentNode = this;

			while (parentNode!=null)
			{
				if (parentNode == node)
				{
					return true;
				}
				else
				{
					parentNode = (BaseNode)parentNode.getParent();
				}
			}

			return false;
		}
		//-------------------------------------------------------------------------
		/**
		 * @return true  node   this 
		 */
		public boolean hasAncestor(BaseNode node, int depth)
		{
			if(node==null) throw new IllegalArgumentException();

			BaseNode parentNode = this;
            
            int lcounter = 0;
            
			while (parentNode!=null && lcounter <= depth)
			{
				if (parentNode == node)
				{
					return true;
				}
				else
				{
					parentNode = (BaseNode)parentNode.getParent();
				}
				lcounter++;
			}

			return false;
		}		
		//-------------------------------------------------------------------------
		/**
		 * @return node  nodeName,   this    ,  null 
		 */
		public BaseNode hasAncestor(String nodeName)
		{
			if(nodeName.length()<=0) return null;			
            
            BaseNode parentNode = (BaseNode)this.getParent();
        
			while (parentNode != null)
			{            
				//String parentNodeName = parentNode.getClass().getName().substring(parentNode.getClass().getName().lastIndexOf(GlobalProperties.FULL_QUALIF_NAME_SEPAR)+1);            			

				//if (parentNodeName.equals(nodeName))
				try
				{
					if (Class.forName(GlobalProperties.LANG_TDT_MODEL_PACK_NAME + GlobalProperties.FULL_QUALIF_NAME_SEPAR + nodeName).isInstance(parentNode))
					{
						return parentNode;
					}
					else
					{
						parentNode = (BaseNode)parentNode.getParent();
					}					
				}
				catch (ClassNotFoundException e) 
				{
					throw  new IllegalArgumentException("Incorrect class name " + GlobalProperties.LANG_TDT_MODEL_PACK_NAME + GlobalProperties.FULL_QUALIF_NAME_SEPAR + nodeName);
				}
			}

			return null;
		}
		//-------------------------------------------------------------------------
		/**
		 * @return node  nodeName,   this    ,  null 
		 */
		public BaseNode hasAncestor(String nodeName, int depth)
		{
			if(nodeName.length()<=0) return null;			
            
			BaseNode parentNode = this;
            
            int lcounter = 0;
            
			while (parentNode != null && lcounter <= depth)
			{            
				//String parentNodeName = parentNode.getClass().getName().substring(parentNode.getClass().getName().lastIndexOf(GlobalProperties.FULL_QUALIF_NAME_SEPAR)+1);            			

				//if (parentNodeName.equals(nodeName))
				try
				{
					if (Class.forName(GlobalProperties.LANG_TDT_MODEL_PACK_NAME + GlobalProperties.FULL_QUALIF_NAME_SEPAR + nodeName).isInstance(parentNode))
					{
						return parentNode;
					}
					else
					{
						parentNode = (BaseNode)parentNode.getParent();
					}					
				}
				catch (ClassNotFoundException e) 
				{
					throw  new IllegalArgumentException("incorrect class name");
				}
				lcounter++;
			}

			return null;
		}

		//-------------------------------------------------------------------------
		/**
		 *
		 */
		public BaseNode findClosestAncestorOfType(String type)
		{
			BaseNode res = null;
            
			if(type==null || type.length()<=0) return res;

            //???
			BaseNode parentNode = /*(BaseNode)this;*/(BaseNode)this.getParent();
			//???
			while (parentNode!=null)
			{
				try
                {
                    if (Class.forName(GlobalProperties.LANG_TDT_MODEL_PACK_NAME
                                    + GlobalProperties.FULL_QUALIF_NAME_SEPAR
                                    + type).isInstance(parentNode))
                    {
                        res = (BaseNode) parentNode;
                        break;
                    }
                    else
                    {
                        parentNode = (BaseNode) parentNode.getParent();
                    }
                }
                catch (ClassNotFoundException e)
                {
                    e.printStackTrace();
                    throw new IllegalStateException("Failed to find class " + GlobalProperties.LANG_TDT_MODEL_PACK_NAME + GlobalProperties.FULL_QUALIF_NAME_SEPAR + type);
                }
			}

			return res;
		}

		//-------------------------------------------------------------------------
		/**
		 *
		 */
		public boolean synchronizeWith(BaseNode dependentNode, SemanticRelation currSemRel, SemanticTree semTree) throws StgException
		{
		   try
			{
				/*
				 *    
				 */
				if (!currSemRel.getSrd().getFunctions().isSynchronized(true, BaseNode.SYNCH, currSemRel, semTree))
				{
					/*
					 *        
					 *  isSynchronized
					 */
					/*
					 *          this-
					 */					
				    FullSemRelList infList = currSemRel.getAllInfluenceListOfSemDepAttr(currSemRel.getSrd().isOneNodeSolved()? BaseNode.TARGET : BaseNode.SOURCE, semTree);
				    for (int j = 0; j < infList.size(); j++)
					{
				        if(currSemRel == infList.getSemList(j)) continue;
				        if (!infList.getSemList(j).getSource().synchronizeWith(this, infList.getSemList(j), semTree))
						{
							throw new IllegalStateException("   ");
						}
					}
					/*
					 *            ,
					 *       dependentNode
					 *        
					 */					
//					for (int k = 0; k < this.getSemRelList().size(); k++)
				    FullSemRelList semRelList = currSemRel.getAllSemRelListOfSemDepAttr(currSemRel.getSrd().isOneNodeSolved()? BaseNode.TARGET : BaseNode.SOURCE, semTree);
				    for (int k = 0; k < semRelList.size(); k++)
				    {
				        if(currSemRel == semRelList.getSemList(k)) continue;
				        semRelList.getSemList(k).getTarget().recurringInfluence(semRelList.getSemList(k), semTree);
					}
				}
				else
				{
					/*
					 *  
					 */
				}
				return true;
			}
			catch (SynchronizeContradictionException sce)
			{
	          //  sce.printStackTrace();
	            MainGenerationCycle.STGLogger.warning(Messages.INSOL_TEST_FOUND);
	            return false;
			}
		}
		//-------------------------------------------------------------------------
		/**
		 *
		 */
	    public boolean recurringInfluence(SemanticRelation semRel, SemanticTree semTree)throws StgException
	    {
			//       target   defineTarget      
			try
			{
				if (semRel.getSrd().getFunctions().defineTarget(true, BaseNode.SYNCH, semRel, new SemanticTree.ResultContainer(Boolean.FALSE), semTree))
				{
                    FullSemRelList semRelList = semRel.getAllSemRelListOfSemDepAttr(BaseNode.TARGET, semTree); 
					for (int i = 0; i < semRelList.size();i++)
					{
						((SemanticRelation) semRelList.getSemList(i)).getTarget().recurringInfluence(semRelList.getSemList(i), semTree);
					}
                    /*
                     *   ,    x = const, ..      
                     */
                    FullSemRelList infRelList = semRel.getAllInfluenceListOfSemDepAttr(BaseNode.TARGET, semTree);
                    for (int i = 0; i < infRelList.size();i++)
                    {
                        SemanticRelation infrel = infRelList.getSemList(i);
                        
                        if (infrel.getSrcSemantDepChildList(semTree).isEmpty())
                        {
                           infrel.getTarget().recurringInfluence(infrel, semTree);    
                        }
                        else 
                        {
                            continue;
                        }
                    }
				}
				return true;
			}
			catch (RepeatedInfluenceException e)
			{
				/*
				 *          
				 *      
				 */
			    FullSemRelList semList = semRel.getAllSemRelListOfSemDepAttr(TARGET, semTree);
			    for (int i = 0; i < semList.size(); i++)
//				for (int i = 0; i < this.getSemRelList().size(); i++)
				{
//					if(((SemanticRelation)this.getSemRelList().getSemList(i)).isEqual(semRel, SemanticRelation.CHECK_ALL))
			        if(semList.getSemList(i).isEqual(semRel, SemanticRelation.CHECK_ALL))
					{
						continue;
					}
//					((SemanticRelation)this.getSemRelList().getSemList(i)).getTarget().recurringInfluence((SemanticRelation)this.getSemRelList().getSemList(i), semTree);
			        (semList.getSemList(i)).getTarget().recurringInfluence(semList.getSemList(i), semTree);
				}
			    FullSemRelList infList = semRel.getAllInfluenceListOfSemDepAttr(TARGET, semTree);
			    for (int i=0; i< infList.size(); i++)
//				for (int i=0; i< this.getInfluenceList().size(); i++)
				{
//					if(!((SemanticRelation)this.getInfluenceList().getSemList(i)).getSource().synchronizeWith(
//					    ((SemanticRelation)this.getInfluenceList().getSemList(i)).getTarget()
//					    ,(SemanticRelation)this.getInfluenceList().getSemList(i)
//						, semTree))
			        if(!infList.getSemList(i).getSource().synchronizeWith(infList.getSemList(i).getTarget(),infList.getSemList(i), semTree))			        
					{
						throw new IllegalStateException(Messages.INTERNAL_ERROR + "   "+ infList.getSemList(i).getSource()+ " c "+ infList.getSemList(i).getTarget());
					}
				}
				return true;
			}
	    }
		//-------------------------------------------------------------------------
	    /**
	     *
	     */
	    public void incInfluenceCounter()
		{
			influenceCounter++;
		}
		//-------------------------------------------------------------------------
	    /**
	     *
	     */
		public void decInfluenceCounter()
		{
			if(influenceCounter>0)
			{
				influenceCounter--;
			}
		}
		//-------------------------------------------------------------------------
	    /**
	     *
	     */
		public void incSynchronizeCounter()
		{
			synchronizeCounter++;
		}

	
		/**
		 *
		 * @param node
		 * @return 0,   ,
		 *         1,  node -  this
		 *        -1,  this -  node
		 */
		/*public int isAncestor(BaseNode node)
		{
			BaseNode ancestor = (BaseNode)this.getParent();
			while(ancestor!=null)
			{
				if(ancestor == node) return 1;
				else ancestor = (BaseNode)ancestor.getParent();
			}

			ancestor = (BaseNode)node.getParent();
			while(ancestor!=null)
			{
				if(ancestor == this) return -1;
				else ancestor = (BaseNode)ancestor.getParent();
			}

			return 0;
		}
		    */
		//-------------------------------------------------------------------------
		/**
		 *      
		 */
		/*public boolean isIncidentToRelation(SemanticRelation newRel, SemanticRelation nodeRel)
		{
		  if(nodeRel == null) throw new IllegalArgumentException();
		  List semanticDependentChildList = (nodeRel.getSource()==this) ? nodeRel.getSrcSemantDepChildList() : nodeRel.getTrgSemantDepChildList();

		  String nodeType = this.getShortClassName();

		  if(newRel.getSource()==this
		  ||  newRel.getTarget()==this
		  // this is ancestor of source and nodeRel contains source in semantic dependent child list
		  || (newRel.getSource().hasAncestor(this) && (semanticDependentChildList.contains(newRel.getSrcType())
		                                            ||semanticDependentChildList.contains(newRel.getSource().getClass().getSuperclass().getName().substring(newRel.getSource().getClass().getSuperclass().getName().lastIndexOf(GlobalProperties.FULL_QUALIF_NAME_SEPAR)+1))))
		  // source is ancestor of this and newRel contains this in semantic dependent child list
		  || (this.hasAncestor(newRel.getSource()) && (newRel.getSrcSemantDepChildList().contains(nodeType)
		                                            ||newRel.getSrcSemantDepChildList().contains(this.getClass().getSuperclass().getName().substring(this.getClass().getSuperclass().getName().lastIndexOf(GlobalProperties.FULL_QUALIF_NAME_SEPAR)+1))))
		  //   
		  // this is ancestor of source and nodeRel contains source in semantic dependent child list
		  || (newRel.getTarget().hasAncestor(this) && (semanticDependentChildList.contains(newRel.getTrgType())
		                                            ||semanticDependentChildList.contains(newRel.getTarget().getClass().getSuperclass().getName().substring(newRel.getTarget().getClass().getSuperclass().getName().lastIndexOf(GlobalProperties.FULL_QUALIF_NAME_SEPAR)+1))))
		  // source is ancestor of this and newRel contains this in semantic dependent child list
		  || (this.hasAncestor(newRel.getTarget()) && (newRel.getTrgSemantDepChildList().contains(nodeType)
		                                            ||newRel.getTrgSemantDepChildList().contains(this.getClass().getSuperclass().getName().substring(this.getClass().getSuperclass().getName().lastIndexOf(GlobalProperties.FULL_QUALIF_NAME_SEPAR)+1)))))
		  {
		  	return true;
		  }
		  else return false;
		}*/
	    protected static ModlSemSyntNodeConstr syntacticConstraintDesc;
	    public static void initSyntacticConstraintDesc(ModlSemSyntNodeConstr lsyntacticConstraintDesc)
	    {
	    	BaseNode.syntacticConstraintDesc = lsyntacticConstraintDesc;
	    }
	    //-------------------------------------------------------------------------
	    // constructor
         
	    public BaseNode()
	    {
	        super();
	        visitorsInit();
//	        try
//            {
//	            VisitorCopierNodeWithAttachment copierNodeWithAttach = (VisitorCopierNodeWithAttachment) Class
//                        .forName(
//                                "ru.ispras.redverst.stg.langdep.visitors."
//                                        + GlobalProperties.TARGET_LANGUAGE
//                                        + "VisitorCopierNodeWithAttachment")
//                        .newInstance();
//                
//            }
//            catch (Exception e)
//            {
//                throw new IllegalStateException(e.getMessage());
//            }
	        
			this.syntCombList = new ArrayList(0);
			if (BaseNode.syntacticConstraintDesc!=null)
            {
                BaseNode.syntacticConstraintDesc.setSemSyncConstr(this);                
            }	
	        
			//---------------------------------------------------------------------
	        // constructor code

			this.influenceCounter = 0;
			this.synchronizeCounter = 0;
			this.changeable = false;
			this.synchStart = false;
			this.synchron = false;
			this.setMode = BaseNode.INIT;
			this.printed = false;
//	        this.influenceList = new FullSemRelList();
//			this.semRelList = new FullSemRelList();
			this.relevantChecker = this.getRelevantChecker();
			this.keyKind = ORDINARY;

	    }
//		-------------------------------------------------------------------------
        public interface RelevantChecker
        {
			public int isSyntacticRelevantNode(BaseNode node, BaseNode parent);
        }
        /**
         *           
         */
        protected RelevantChecker relevantChecker;
        /**
         *   FORBIDDEN  - AND 
         *  MANDATORY - OR
         */
        protected List/*SyntacticCombination*/ syntCombList;        

		//-------------------------------------------------------------------------
		/**
		 * @return
		 */
		public RelevantChecker getRelevantChecker()
		{			
			if(relevantChecker == null)
			{
				relevantChecker = new RelevantChecker()
				{
					/*public int isSyntacticRelevantNode(BaseNode node, BaseNode parent)
					{
						return 1;
					}*/
					public int isSyntacticRelevantNode(BaseNode node, BaseNode parent)
					{
						List nodeList = node.getDescenList();
						nodeList.add(0, node);
						int delta = 0;
						BaseNode currParent = null;
						//check all node's descendents corresponding to parent
						for (Iterator iter = nodeList.iterator();iter.hasNext();) 
						{   //curr node's descendent 
							BaseNode element = (BaseNode) iter.next();
							
							//if (element.isSyntChecked()) continue;
							//direct parent of current descendent
							currParent = (BaseNode)element.getParent();
							if (currParent == null)
							{
								currParent = parent;							
							}
							delta = BaseNode.getPath(element, node).size()-1 ;// TODO ??? + 1;
							//check all semantic grammar constraints for current descendent 
							int mandCount = 0;
							for (Iterator iterator = element.getSyntCombList().iterator();iterator.hasNext();) 
							{							
								SyntacticCombination synComb = (SyntacticCombination) iterator.next();
								
								//TODO    parent  currParent -  ...
								if(synComb.matchCombination(element, parent, currParent,  delta))
								{
									if(synComb.getCombType() == SyntacticCombination.FORBIDDEN)
									{
										//TODO screen comment
									/*	MainGenerationCycle.STGLogger.info(Messages.SYNTHESIS_MESSAGE 
														 + " match synt comb: " 
														 + " ancestor type - " + synComb.getAncestorType()
														 + " curr node type - " + element.getShortClassName());*/
										return -1;
									}
									else
									{
										mandCount++;
									}
								}
							}
							// at least one mandatory combination should be matched
							if (element.hasMandatorySyntComb()!=0 && mandCount==0)
							{
								//TODO screen comment
								MainGenerationCycle.STGLogger.info(Messages.SYNTHESIS_MESSAGE 
												 + " element " + element.getShortClassName() + " has mandatory combinations not matched");								
								return -1;
							} 
						}
						//node.setSyntChecked(true); 	
						return 1;
					}				
				};				
			}
			return relevantChecker;
		}
		//-------------------------------------------------------------------------
		/**
		 * @param checker
		 */
		public void setRelevantChecker(RelevantChecker checker) {
			relevantChecker = checker;
		}
//		-------------------------------------------------------------------------

		/**
		 *   ( BaseNode)     NodeDecl
		 *
		 * @param node
		 * @return     
		 */
		public BaseNode createInstance(NodeDecl node)
		{
			return createInstance(node.getName().getValue());
		}
		
		public BaseNode createInstance(NodeDecl node, int flagCreated)
		{
            BaseNode res = createInstance(node.getName().getValue());
			res.setCreated(flagCreated);
			return res;
			
		}		
//		-------------------------------------------------------------------------

		/**
		 *   ( BaseNode)     NodeDecl
		 *
		 * @param node
		 * @return     
		 */
		public BaseNode createInstance(String nodeName)
		{
			BaseNode currNode=null;						
			try
			{
			    TDL.NodeDecl nodeDecl = StgTree.getNodeDecl(nodeName, SemanticTree.gramTree);
			    if(!nodeDecl.getIsAbstract())
			    {
			        currNode =(BaseNode) Class.forName(GlobalProperties.LANG_TDT_MODEL_PACK_NAME + GlobalProperties.FULL_QUALIF_NAME_SEPAR + nodeName).newInstance();    
			    }
			    else
			    {
			        NodeDecl desc = StgNodeDecl.getNotAbstractDescendent(nodeDecl, new ArrayList(0));
			        currNode =(BaseNode) Class.forName(GlobalProperties.LANG_TDT_MODEL_PACK_NAME + GlobalProperties.FULL_QUALIF_NAME_SEPAR + desc.getName().getValue()).newInstance();
			    }
			}
			catch(InstantiationException inExc)
			{
                inExc.printStackTrace();
				throw new IllegalStateException(Messages.INTERNAL_ERROR + " impossible instance creation " + GlobalProperties.LANG_TDT_MODEL_PACK_NAME + GlobalProperties.FULL_QUALIF_NAME_SEPAR + nodeName);
			}
			catch(IllegalAccessException iaExc)
			{
                iaExc.printStackTrace();
				throw new IllegalStateException(Messages.INTERNAL_ERROR + " illegal access to " + GlobalProperties.LANG_TDT_MODEL_PACK_NAME + GlobalProperties.FULL_QUALIF_NAME_SEPAR + nodeName);
			}
			catch(ClassNotFoundException cnfExc)
			{
                cnfExc.printStackTrace();
				throw new IllegalStateException(Messages.INTERNAL_ERROR + " class not found " + GlobalProperties.LANG_TDT_MODEL_PACK_NAME + GlobalProperties.FULL_QUALIF_NAME_SEPAR + nodeName);
			}

			if(currNode == null) throw new IllegalArgumentException("impossible to create the node of specified type");
			
			return currNode;
		}
//		-------------------------------------------------------------------------
        /**
         *    NodeClass setParent     
         */
        public boolean setStgParent(BaseNode parent)
        {
        	if(this.relevantChecker == null
			|| this.relevantChecker.isSyntacticRelevantNode(this, parent)>=0)
        	{
                if(this.getParent()!=parent)
                {
                    this.setParent(parent);
                }
                this.setLevel(parent.level+1);
                this.setPrintOrderId(this.nextId(parent.printOrderId, parent.level));                
        		                
        		return true;
        	}
        	else
        	{
        		return false;
        	}
        }
//		-------------------------------------------------------------------------
		/**
		 *    NodeClass makeChild     
		 */
	/*	public boolean makeStgChild(BaseNode child, String childName)
		{
			if(child == null )
			{
				if(childName.startsWith("opt"))
				{
					return true;
				}
				else
				{
					return false; 
				}				 
			} 
			
			if(child.relevantChecker == null
			|| child.relevantChecker.isSyntacticRelevantNode(child, this)>=0)
			{
				makeChild(childName);
				return true;
			}
			else
			{
				return false;
			}
		}*/
        /**
         *         
         *  
         */
        public boolean isPossibleToConnect(String childType)
        {
            List childList = StgNodeDecl.getChildList(StgTree.getNodeDecl(this.getShortClassName(), SemanticTree.gramTree));
            for (Iterator iter = childList.iterator(); iter.hasNext();)
            {
                Child child = (Child) iter.next();
                String lChildType = ((TDL.NodeType)child.getType()).getName().getName().getValue();
                String lChildName = child.getName().getValue();
                /*
                 *     child     childType  childType  
                 *    
                 *       
                 *     ,     null
                 *      
                 */
                if ((lChildType.equals(childType)
                    || StgTree.isInherited(childType, lChildType, SemanticTree.gramTree))
                 && ( this.isChildList(lChildName) 
                      || this.getAttribute(lChildName) == null 
                      || (this.getAttribute(lChildName) != null 
                          && this.getAttribute(lChildName) instanceof BaseNode 
                          && ((BaseNode)this.getAttribute(lChildName)).isDefault()))
                )
                {
                    return true;
                }                
            }
            return false;
        }
//		-------------------------------------------------------------------------
       /**
        *   set<>2    
        *      sscl
        */
	   public boolean isCandidateRelevant(BaseNode newChild, String childName)
	   {
			//if call was made to delete default memeber value by changing to null their values then always true			
		String ldeleteMemberName = new String(this.getShortClassName().trim() + "." + childName.trim());
					
		if (this.deleteMemberName!= null
		 && this.deleteMemberName.equals(ldeleteMemberName)
		 && this.deleteMemberFlag.equals(Boolean.TRUE)) return true;
				
			if(newChild == null )
			{
			/*	String prefix = new String("opt");
				if(!childName.startsWith(prefix))
				{
					return false; 
				}
				else
				{
					return true;				 
				}*/
				return true;
			} 
				
			if(newChild.relevantChecker != null)
			{
				if (newChild.relevantChecker.isSyntacticRelevantNode(newChild, this)>=0)
				{
					return true;
				}
				else
				{
					// TODO screen comment
//					MainGenerationCycle.STGLogger.info("candidate is not relevant");					
					return false;
				} 
			}
			else
			{
				return true;
			}
			
	   }		
//		-------------------------------------------------------------------------
		/**
		 *   set<>2    
         *      sscl 
		 */
       public boolean isCandidateRelevant(List/*BaseNode*/ childList, String childName)
       {
		//	boolean res = true;
		//if call was made to delete default memeber value by changing to null their values then always true
		String ldeleteMemberName = new String(this.getShortClassName().trim() + "." + childName.trim());
					
		if (this.deleteMemberName!= null
		 && this.deleteMemberName.equals(ldeleteMemberName)
		 && this.deleteMemberFlag.equals(Boolean.TRUE)) return true;
				
			if(childList == null )
			{
				/*String prefix = new String("opt");
				if(!childName.startsWith(prefix))
				{
					return false; 
				}	
				else
				{
					return true;			 
				}*/
				return true;
			}
			 		
			/*if(childList.size() == 1 )
			{
				if(childList.get(0)==null)
				{
					String prefix = new String("opt");
					if(!childName.startsWith(prefix))
					{
						return false;
					}			 
				}
			} */	
			/*int childListSize = childList.size();
	            
			for (int i = 0; i < childListSize; i++) 
			{
				if(((BaseNode)childList.get(i)).relevantChecker == null
				|| ((BaseNode)childList.get(i)).relevantChecker.isSyntacticRelevantNode((BaseNode)childList.get(i), this)>=0)
				{
					res = res && true;					
				}
				else
				{
					res = res && false;
				}				
			}		*/
			
			int childListSize = childList.size();
	            
			for (int i = 0; i < childListSize; i++) 
			{
				if(((BaseNode)childList.get(i)).relevantChecker != null)
				{
					if (((BaseNode)childList.get(i)).relevantChecker.isSyntacticRelevantNode((BaseNode)childList.get(i), this)<0)
					{
						// TODO screen comment
//						MainGenerationCycle.STGLogger.info("candidate is not relevant");
						return false;					
					}
				}				
			}					
			return true;
       }
//		-------------------------------------------------------------------------
		/**
		 *    NodeClass makeChild     
		 */
	/*	public boolean makeStgChild(List childList, String childName)
		{
			boolean res = true;
			
			if(childList == null )
			{
				if(childName.startsWith("opt"))
				{
					return true;
				}
				else
				{
					return false; 
				}				 
			} 		
			if(childList.size() == 1 )
			{
				if(childList.get(0)==null)
				{
					if(childName.startsWith("opt"))
					{
						return true;
					}
					else
					{
						return false; 
					}				 
				}
			} 	
            int childListSize = childList.size();
            
            for (int i = 0; i < childListSize; i++) 
            {
				if(((BaseNode)childList.get(i)).relevantChecker == null
				|| ((BaseNode)childList.get(i)).relevantChecker.isSyntacticRelevantNode((BaseNode)childList.get(i), this)>=0)
				{
					res = res && true;					
				}
				else
				{
					res = res && false;
				}				
			}			
			if(res)
			{
				makeChild(childName);
			}
			return res;
		}*/

			

//		-------------------------------------------------------------------------
//		/** DEPRECATED as not used
//		 *       obj 
//		 *      isEqual
//		 */
//		public static List containsEqualBaseNode(BaseNode obj, List/*BaseNode*/ list)
//		{
//			List res = new ArrayList();
//			int listSize = list.size();
//			for (int i = 0; i < listSize; i++) 
//			{
//				if(((BaseNode)list.get(i)).isEqual(obj))
//				{
//					res.add(list.get(i)); 
//				} 
//			}				
//			return res;
//		}
//		-------------------------------------------------------------------------
       public boolean isEqual(BaseNode base)
       {
       	 throw new UnsupportedOperationException();		
       }
//		-------------------------------------------------------------------------
       /**
        *      
        * @return FullSemRelList
        */
//       public static FullSemRelList getAllSemRelListFromListParams(List/*BaseNode*/ childList)
//       {
//       	FullSemRelList res = new FullSemRelList();
//       	
//       	Utils.removeNullObj(childList);
//       	int childListSize = childList.size();
//        for (int i = 0; i < childListSize; i++) 
//        {
//			try 
//			{
//				res.addAll(((BaseNode) childList.get(i)).getSemRelList());
//								
//			} catch (ClassCastException e) 
//			{
//				throw new IllegalArgumentException(Messages.INTERNAL_ERROR + " there are not BaseNode object in the list");
//			}			
//		}       	
//       	return res;	           
//       }
//	   -------------------------------------------------------------------------
	  /**
	   *      
	   * @return FullSemRelList
	   */
//	  public static FullSemRelList getAllInfluencedListFromListParams(List/*BaseNode*/ childList)
//	  {
//	   FullSemRelList res = new FullSemRelList();
//       	
//	   int childListSize = childList.size();
//	   for (int i = 0; i < childListSize; i++) 
//	   {
//		   try 
//		   {
//			   res.addAll(((BaseNode) childList.get(i)).getInfluenceList());
//								
//		   } catch (ClassCastException e) 
//		   {
//			   throw new IllegalArgumentException(Messages.INTERNAL_ERROR + " there are not BaseNode object in the list");
//		   }			
//	   }       	
//	   return res;	           
//	  }      


 
	//-------------------------------------------------------------------------
	/**
	 * @return
	 */
	public boolean isChangeable() {
		return changeable;
	}

	//-------------------------------------------------------------------------
	/**
	 * @param b
	 */
	public void setChangeable(boolean b) {
		changeable = b;
	}


	//--------------
	/**
	 * return path from childNode to parentNode if exist, empty list if not
	 * path start with child node and stop with child of parent node
	 */
	public static List/*BaseNode*/ getPath(BaseNode childNode, BaseNode parentNode)
	{
		List res = new ArrayList();
		
		//res.add(childNode);
		
		//BaseNode parent = (BaseNode)childNode.getParent();		
		BaseNode parent = childNode;
		
		while (parent!=null /*&& parent != parentNode*/) 
		{
			res.add(parent);
			parent = (BaseNode)parent.getParent();
		}
		
		return res;
	}
		//-------------------------------------------------------------------------
		/**
		 * @return
		 */
		public List getSyntCombList() {
			return syntCombList;
		}

		//-------------------------------------------------------------------------
		/**
		 * @param list
		 */
		public void setForbidSyntCombList(List list) {
			syntCombList = list;
		}
//		-------------------------------------------------------------------------
     /*   public void addSyntComb(int type
		                            , String ancestorType
									, String descendentType
									, List irrelevantNodes
									, List relevantNodes)
        {
        	
        	this.syntCombList.add(new SyntacticCombination(type
				                                         , ancestorType
	                                                     , descendentType
	                                                     , irrelevantNodes != null ? irrelevantNodes : new ArrayList(0)
	                                                     , relevantNodes != null ? relevantNodes : new ArrayList(0), 10000));
        }*/
//		-------------------------------------------------------------------------
		public void addSyntComb(int type
                              , String ancestorType
 							  , String descendentType
							  , String[] irrelevantNodes
							  , String[] relevantNodes)
		{
        	
			this.syntCombList.add(new SyntacticCombination(type
														 , ancestorType
														 , descendentType
														 , irrelevantNodes != null ? new ArrayList(Arrays.asList(irrelevantNodes)) : new ArrayList(0)
														 , relevantNodes != null ? new ArrayList(Arrays.asList(relevantNodes)) : new ArrayList(0), 10000));
		}     
//		-------------------------------------------------------------------------
		public void addSyntComb(int type
							  , String ancestorType
							  , String descendentType
							  , String[] irrelevantNodes
							  , String[] relevantNodes
							  , int depth)
		{
        	
			this.syntCombList.add(new SyntacticCombination(type
														 , ancestorType
														 , descendentType
														 , irrelevantNodes != null ? new ArrayList(Arrays.asList(irrelevantNodes)) : new ArrayList(0)
														 , relevantNodes != null ? new ArrayList(Arrays.asList(relevantNodes)) : new ArrayList(0)
														 , depth));
		}  
//		-------------------------------------------------------------------------
	/*	public void addSyntComb(int type
							  , String ancestorType
							  , String descendentType
							  , List irrelevantNodes
							  , List relevantNodes
							  , int depth)
		{
        	
			this.syntCombList.add(new SyntacticCombination(type
														 , ancestorType
														 , descendentType
														 , irrelevantNodes
														 , relevantNodes
														 , depth));
		}		*/
//		-------------------------------------------------------------------------
		public void addSyntComb(int type
							, String ancestorType
							, String descendentType)
		{
        	
			this.syntCombList.add(new SyntacticCombination(type
														 , ancestorType
														 , descendentType
														 , new ArrayList(0)
														 , new ArrayList(0)
														 , 10000));
		}
//		-------------------------------------------------------------------------
		public void addSyntComb(int type
							, String ancestorType
							, String descendentType
							, int depth)
		{
        	
			this.syntCombList.add(new SyntacticCombination(type
														 , ancestorType
														 , descendentType
														 , new ArrayList(0)
														 , new ArrayList(0)
														 , depth));
		}		
//		-------------------------------------------------------------------------
		public void addHorizSyntComb(int type
		                           , String ancestorType
		                           , String[] irrelevantNodes
		                           , String[] relevantNodes)
		{
        	
			this.syntCombList.add(new HorizontalSyntComb(type
													   , ancestorType
													   , irrelevantNodes
													   , relevantNodes));
		}		
//		-------------------------------------------------------------------------
/*		public void addHorizSyntComb(int type
		                           , String ancestorType
		                           , List irrelevantNodes
		                           , List relevantNodes)
		{
        	
			this.syntCombList.add(new HorizontalSyntComb(type
													   , ancestorType
													   , irrelevantNodes
													   , relevantNodes));
		}	*/		
//		-------------------------------------------------------------------------
		public void addHorizSyntComb(int type
		                           , String ancestorType)
		{
        	
			this.syntCombList.add(new HorizontalSyntComb(type
													   , ancestorType
													   , new ArrayList(0)
													   , new ArrayList(0)));
		}				
//		-------------------------------------------------------------------------
		public int hasMandatorySyntComb()
		{
			int res = 0;
			for (int i = 0; i < this.syntCombList.size(); i++) 
			{
				if (((SyntacticCombination)this.syntCombList.get(i)).getCombType() == SyntacticCombination.MANDATORY)
				{
					res++;
				}
			}
			return res;  
		}
	//-------------------------------------------------------------------------

     /*   public boolean hasMandatorySyntComb()
        {
        	for (int i = 0; i < this.syntCombList.size(); i++) 
        	{
				if (((SyntacticCombination)this.syntCombList.get(i)).getCombType() == SyntacticCombination.MANDATORY)
				{
					return true;
				}
			}
        	return false;  
        }*/
	//-------------------------------------------------------------------------
	/**
	 * @return
	 */
	public boolean isSyntChecked() {
		return syntChecked;
	}

	//-------------------------------------------------------------------------
	/**
	 * @param b
	 */
	public void setSyntChecked(boolean b) {
		syntChecked = b;
	}

//	-------------------------------------------------------------------------
	/**
	 * @return list of all descendents specified type
	 */
	public List hasDescen(String type, int depth)
	{
		if(type.length()<=0) return new ArrayList(0);
		List descenList = this.getDescenList(depth);
		return Utils.containsOfType(GlobalProperties.LANG_TDT_MODEL_PACK_NAME + GlobalProperties.FULL_QUALIF_NAME_SEPAR + type, descenList);
	}    
//	-------------------------------------------------------------------------
	/**
	 * @return list of all descendents specified type
	 */
	public List hasDescen(String type)
	{
		if(type.length()<=0) return new ArrayList(0);
		List descenList = this.getDescenList();
		return Utils.containsOfType(GlobalProperties.LANG_TDT_MODEL_PACK_NAME + GlobalProperties.FULL_QUALIF_NAME_SEPAR + type, descenList);
	}
//	-------------------------------------------------------------------------
	/**
	 * @return true if node is descendent of this
	 */
	public boolean hasDescen(BaseNode node)
	{
		List descenList = this.getDescenList();
		return !Utils.containsEqualObject(node, descenList).isEmpty();
	}
//	-------------------------------------------------------------------------
	/**
	 * @return true if node is descendent of this
	 */
	public boolean hasDescen(BaseNode node, int depth)
	{
		List descenList = this.getDescenList(depth);
		return !Utils.containsEqualObject(node, descenList).isEmpty();
	}
//	-------------------------------------------------------------------------
	/**
	 * @return true if node is descendent of this
	 */
	public boolean hasDescens(List nodeList)
	{
		List descenList = this.getDescenList();
		return Utils.containsAny(descenList, nodeList);
	}
//	-------------------------------------------------------------------------
	/**
	 * @return true if node is descendent of this
	 */
	public boolean hasDescens(List nodeList, int depth)
	{
		List descenList = this.getDescenList(depth);
		return Utils.containsAny(descenList, nodeList);
	}
	
	public boolean isChildList(String name)
	{
		return StgNodeDecl.isChildList(StgTree.getNodeDecl(this.getShortClassName(), SemanticTree.gramTree), name);
	}

	
	/**
	 * @return
	 */
	public int getKeyKind()
	{
		return keyKind;
	}

	/**
	 * @param i
	 */
	public void setKeyKind(int i)
	{
		switch (i)
		{
			case SOURCE    :
            case MAIN_SOURCE :
			case TARGET    :
            case MAIN_TARGET :
			case SRCCONTEXT:
            case MAIN_SRCCONTEXT:
			case TRGCONTEXT:
            case MAIN_TRGCONTEXT:
			case ORDINARY  :
			    {
			    	keyKind = i;
					break;
			    }
				
			default :
			 throw new IllegalArgumentException("keyKind " + keyKind);
		}
	}

	/**
	 * 
	 * @param kind SOURCE, TARGET, CONTEXT
	 * @return BaseNode  
	 */
	public BaseNode getKeyNode(int kind)
	{
		BaseNode res = null;
    	
		//collect all descendents
		List descendentList = this.getDescenList();
    	
		//check also this node
		descendentList.add(0, this);
    	
		//find all nodes of specified kind
		for (Iterator iter = descendentList.iterator(); iter.hasNext();)
		{
			BaseNode element = (BaseNode) iter.next();
			if(element.getKeyKind()==kind)
			{
				if (res == null)
				{
					res = element;
					break;
				}
				else
				{
					//if (res != element)
					{
						throw new IllegalStateException("BaseNode.java, line 1883 "
												  + Messages.INTERNAL_ERROR
												  + "only one key node of specified kind " 
												  + (kind == BaseNode.SOURCE ? "SOURCE " : (kind == TARGET ? "TARGET " : "CONTEXT ")) 
												  + "could exists in one syntactic tree");
					}
				}
			}
		}
		return res;
	}
//-------------------------------------
    /**
     * copy attributes from this basenode to new base node
     */
    public void copyAttributesTo(BaseNode newNode)
    {
		newNode.setKeyKind(this.getKeyKind());
		//newNode.changeable = this.changeable;
		newNode.setRelevantChecker(this.relevantChecker);
		if (this.semRelList!=null && !this.semRelList.isEmpty())
        {
            newNode.setSemRelList(this.semRelList);            
        }
		
		if (this.influenceList!=null && !this.influenceList.isEmpty())
        {
            newNode.setInfluenceList(this.influenceList);
        }
		newNode.setCreated(this.created);
		//newNode.setMode = this.setMode;	    	
    }

	/**
	 * @return
	 */
	public boolean isDefault()
	{
		return created == DEFAULT;
	}
	public boolean isSpecial()
	{
		return created == SPECIAL;
	}	

	/**
	 * @param i
	 */
	public /*synchronized*/ void setCreated(int i)
	{
		if (i!=DEFAULT && i!=SPECIAL) throw new IllegalArgumentException("BaseNode.java, line 1922");
		created = i;
	}
    /**
     * 
     * @param i
     * @param flag can be BaseNode.Special
     */
//    public /*synchronized*/ void setCreatedAll(int i)
//    {
//        if (i!=DEFAULT && i!=SPECIAL) throw new IllegalArgumentException("BaseNode.java, line 1922");
//        this.created = i;
//        BaseNode parent = (BaseNode)this.getParent();
//        if (parent !=null)
//        {
//            parent.setCreatedAll(i);
//        }
//    }    
	/**
	 * list of position subTree where this could be connected
	 * following nodes cann't be point of connection:
	 * - has all children SPECIAL created and no list child
	 * 
	 * @param subTree
	 * @param semTree TODO
	 * @return
	 */
	public HashMap getPossibleNodePositions(BaseNode subTree, String subTreeType, int lowBound, int highBound, SemanticTree semTree)
	{
		List descList = subTree.findDescendent("", lowBound > 0 ? lowBound-1 : lowBound, highBound > 0 ? highBound-1 : highBound, -1);
	    
//		descList.add(0, subTree);
		
		List candList = new ArrayList(0);

		for (int i = 0; i < descList.size(); i++)
		{
			BaseNode currNode = (BaseNode)descList.get(i);
//			cann't change any descendent of key node because it could influence on key node relevance
/*			if (currNode.hasAncestor(BaseNode.SOURCE)
			  ||currNode.hasAncestor(BaseNode.TARGET))
			  {
				tmpList.add(descList.get(i));
				continue;
			  }*/
			//check special created children
			List childObjList = StgNodeDecl.getChildList(StgTree.getNodeDecl(currNode.getShortClassName(), SemanticTree.gramTree));
            
            List ancestorsOfSpecialNodes = new ArrayList();
            
            /*         1, 
            *       currNode == subTree, 
            *   currNode.hasAncestor(subTreeType) != subTree, 
            *   currNode.hasAncestor(subTreeType) == null,      
            *  
            *   currNode.hasAncestor(subTreeType) != subTree, 
            *   currNode.hasAncestor(subTreeType) != null,  ,
            *    currNode  subTree          subTree,   
            *     currNode != subTree 
            */
            if(currNode != subTree
               && currNode.hasAncestor(subTreeType)!=null 
               && currNode.hasAncestor(subTreeType) != subTree)
            {
                ancestorsOfSpecialNodes.add(currNode);
                continue;
            }
            
			for (Iterator iter = childObjList.iterator(); iter.hasNext();)
            {
                Child child = (Child) iter.next();
                String childName = child.getName().getValue();
                Object childObj = currNode.getAttribute(childName);
                if (childObj == null || childObj instanceof List || (childObj instanceof BaseNode && !((BaseNode)childObj).isSpecial() && !((BaseNode)childObj).isProhibitedToDelete(semTree)))
                {
                    /*   currNode     ,
                     *  ,  currNode  
                     *     ,     
                     */
                    candList.add(0, currNode);
                    break;
                }
                else
                {
                    if(childObj instanceof BaseNode && (((BaseNode)childObj).isSpecial() || ((BaseNode)childObj).isProhibitedToDelete(semTree)))
                    {
                        BaseNode parent = (BaseNode)childObj;
                        while (parent!=null)
                        {
                            if (parent.getChildrenNames().size()<=1)
                            {
                                ancestorsOfSpecialNodes.add(parent);    
                            }
                            parent = (BaseNode)parent.getParent();
                        }
                    }
                }
            } 
            candList.removeAll(ancestorsOfSpecialNodes);
           
		}
//			List childList = currNode.getChildList();
//			int lcounter = 0;
//			for (int j = 0; j < childList.size(); j++)
//			{
//				BaseNode child = (BaseNode)childList.get(j);
//				List childPlaceList = currNode.getChildNames(child);
//				if(child.isSpecial())
//				{
//					//could use list children
//					boolean indexed = false;
//					for (int k = 0; k < childPlaceList.size(); k++)
//					{
//						try
//						{
//							if (currNode
//								.isIndexed((String) childPlaceList.get(k)))
//							{
//								indexed = true;
//								break;
//							}
//						}
//						catch (NullPointerException e)
//						{
//							//it could be if child named childPlaceList.get(k) is optional and null
//						}
//					}
//					if (!indexed)lcounter++;
//				}
//			}
//			if (lcounter == childList.size())
//			{
//				incorrectList.add(descList.get(i));
//			}
//			
//		}
//		descList.removeAll(incorrectList.add);
		
		HashMap placeList = new HashMap(0);
		
		int descNumber = candList.size();
		// try to join node to every node in chain
		for (int j = 0; j < descNumber; j++) 
		{
			BaseNode currNode = (BaseNode)candList.get(j);
			
			List placeNamesList = currNode.getChildNames(this);
			
			List badNodeList = new ArrayList(0);
			
			//select not special created or list place
			for (int k = 0; k < placeNamesList.size(); k++)
			{
				String currPlaceName = (String)placeNamesList.get(k);
				try
				{
					if (!currNode.isIndexed(currPlaceName)
						&& ((BaseNode) currNode.getAttribute(currPlaceName))!=null
                        && (((BaseNode) currNode.getAttribute(currPlaceName)).isSpecial() 
                                || ((BaseNode) currNode.getAttribute(currPlaceName)).isProhibitedToDelete(semTree)))
					{
					    badNodeList.add(currPlaceName);
					}
				}
				catch (NullPointerException e)
				{
					//it could be if child named childPlaceList.get(k) is optional and null
				}
				catch (AttributeException e)
				{
					//no attribute
				}						
			}			
			// remove all not list special created places
			placeNamesList.removeAll(badNodeList);
			//only not empty list
			if(!placeNamesList.isEmpty())
			{
				placeList.put(currNode
							, placeNamesList);
			} 
		}				
		return placeList;	
	}
	/**
	 * 
	 * @param createdFlag DEFAULT || SPECIAL
	 * @param nodesList
	 */
 /*   public static void setAllNodeCreated(int createdFlag, List nodesList)
    {
    	for (Iterator iter = nodesList.iterator(); iter.hasNext();)
		{
			BaseNode element = (BaseNode) iter.next();
			element.setCreated(createdFlag);
		}
    }*/
	/**
	 * 
	 * @param createdFlag DEFAULT || SPECIAL
	 * @param chain
	 */
/*	public static void setAllNodeInChainCreated(int createdFlag, BaseNode chain)
	{
		List nodesList = chain.getDescenList();
		nodesList.add(0, chain);
		for (Iterator iter = nodesList.iterator(); iter.hasNext();)
		{
			BaseNode element = (BaseNode) iter.next();
			element.setCreated(createdFlag);
		}
	}    */
	/**
	 * 
	 * @param createdFlag DEFAULT || SPECIAL
	 * @param list of chains
	 */
/*	public static void setAllChainCreated(int createdFlag, List chainList)
	{

		for (Iterator iter = chainList.iterator(); iter.hasNext();)
		{
			BaseNode element = (BaseNode) iter.next();
			BaseNode.setAllNodeInChainCreated(createdFlag, element);
		}
	} 	*/
//	-------------------------------------
    /**
     * @return attribute object typing BaseNode belonging 
     * this-node or this descendant or (late or this-semantic source) or this-ancestor 
     * @throws IllegalStateException if attribute found isn't of BaseNode type
     */
//    public List getSemanticAttribute(String name, FullSemRelList semRelList)
//    {
//        List attrList = new ArrayList(0);
//        
//    	if (name.length()<=0) return null;//throw new IllegalArgumentException();
//    	
//    	//check if late
//    	if (this.hasAttribute(name))
//    	{
//    	   if( ((TDL.FieldDescriptor)this.getNodeDecl().getFieldTable().get(name))==null
//    	       ||((TDL.FieldDescriptor)this.getNodeDecl().getFieldTable().get(name)).isLate())
//    	   {
//    	       return attrList;
//    	   }
//    	}
//    	
//    	Object attr = null;
//    	
//    	if (!name.matches("parent(.parent)*(.(\\w)+)+"))
//    	{
//    	   	// looking for in this
//    		
//    		try
//    		{
//    			attr = this.getAttribute(name);
//    		}
//    		catch (AttributeException e) 
//    		{
////    			 there is no attribute with <name> in this
//    		}
//    					
//    		if (attr != null && attr != "")
//    		{
//    			if ((!(attr instanceof BaseNode) && (!(attr instanceof List)) 
//    || (attr instanceof List && !((List)attr).isEmpty() && !(((List)attr).get(0) instanceof BaseNode))))
//    			{
//    				throw new IllegalStateException(
//    					Messages.INCORRECT_SEM_FORMALIZM
//    						+ " attribute name specified in srl child list, BaseNode.java, line  2134");
//    			}
//    			if (!attrList.contains(attr))attrList.add(attr);
//    		}
//        	
//        	// looking for in descendants
//        	List descList = this.getDescenList();
//        	for (Iterator iter = descList.iterator(); iter.hasNext();)
//    		{
//    			BaseNode currDescendant = (BaseNode) iter.next();
//    			try
//    			{
//    				attr = currDescendant.getAttribute(name);				
//    			}
//    			catch (AttributeException e)
//    			{
////    				 there is no attribute with <name> in currDescendant
//    			    continue;
//    			}
//    			
//    			if (attr != null && attr != "")
//    			{
//        			if ((!(attr instanceof BaseNode) && (!(attr instanceof List)) 
//        			        || (attr instanceof List && !((List)attr).isEmpty() && !(((List)attr).get(0) instanceof BaseNode))))
//    				{
//    					throw new IllegalStateException(
//    						Messages.INCORRECT_SEM_FORMALIZM
//    							+ " there is attribute name conflict, BaseNode.java, line  2148");
//    				}
//    				if (!attrList.contains(attr))attrList.add(attr);
//    			}		
//    		}    	    
//    	}
//    	else
//    	{
//    	    StringTokenizer st = new StringTokenizer(name, ".");
//    	    BaseNode ancestor = this;
//    	    while(st.hasMoreTokens())
//            {
//    	        String nt = st.nextToken();
//    	        if(nt.equals("parent"))
//    	        {
//	               try
//		            {
//		                ancestor = (BaseNode) ancestor.getParent();   
//		            }
//		            catch (NullPointerException e)
//		            {
//		                throw new NullPointerException(Messages.INCORRECT_SEM_FORMALIZM + " Impossible depth found: " + this.getShortClassName() + "." + name);
//		            }      	            
//    	        }
//    	        else
//    	        {
//	               try
//		            {
//		                ancestor = (BaseNode) ancestor.getAttribute(nt);   
//		            }
//		            catch (NullPointerException e)
//		            {
//		                throw new NullPointerException(Messages.INCORRECT_SEM_FORMALIZM + " Impossible depth found: " + this.getShortClassName() + "." + name);
//		            }      	            
//    	        }
//            }
//    	    if (!attrList.contains(ancestor))attrList.add(ancestor);
//    	}
//    	// looking for in semantic sources
//    	/*if (semRelList instanceof FullSemRelList && !semRelList.isEmpty())
//    	{
//    		for (Iterator iter = semRelList.getSemList().iterator(); iter.hasNext();)
//			{
//				SemanticRelation element = (SemanticRelation) iter.next();
//				if (element.getTarget()!= this) continue;
//				
//				BaseNode source = element.getSource();
//				try
//				{
//					attr = source.getAttribute(name);
//					
//				}
//				catch (AttributeException e) 
//				{
//				   // there is no attribute with <name> in source
//				    continue;
//                }
//				
//				if (attr != null && attr != "")
//				{
//					if (!(attr instanceof BaseNode) && !(attr instanceof List))
//					{
//						throw new IllegalStateException(
//							Messages.INCORRECT_SEM_FORMALIZM
//								+ " there is attribute name conflict, BaseNode.java, line  2165");
//					}
//					if (!attrList.contains(attr))attrList.add(attr);
//				}						
//			}
//    	}*/
//    	// looking for in ancestors
//	/*	BaseNode currAncestor = (BaseNode)this.getParent();
//		while (currAncestor!=null) 
//		{
//			try
//			{
//				attr = currAncestor.getAttribute(name);
//				
//			}	
//			catch (AttributeException e) {
////				 there is no attribute with <name> in this
//			}			
//			if (attr != null && attr != "")
//			{
//				if (!(attr instanceof BaseNode) && !(attr instanceof List))
//				{
//					throw new IllegalStateException(
//						Messages.INCORRECT_SEM_FORMALIZM
//							+ " there is attribute name conflict, BaseNode.java, line  2180");
//				}
//				if (!attrList.contains(attr))attrList.add(attr);
//			}				
//			currAncestor = (BaseNode)currAncestor.getParent();
//		} */	
//    	if (attrList.size() > 1) throw new IllegalArgumentException("In tdl-description there are several fields with the same name: " + name);
//    	return attrList;    
//    }
//	-------------------------------------------------------------------------
	public List getNodeAttrNameList()
	{
		NodeDecl node = StgTree.getNodeDecl(this.getShortClassName(), SemanticTree.gramTree);
		List attrList = node.getOptFieldList();
			
		List attrNamesList = new ArrayList(0);
		for (Iterator iter = attrList.iterator(); iter.hasNext();)
		{
            Object element =  iter.next();
            if (element instanceof FieldDescriptor)
            {
                TDL.FieldDescriptor currField = (TDL.FieldDescriptor) element;
                attrNamesList.add(currField.getName().getValue());
            }
		} 		  
		return attrNamesList;  	
	}
//	-------------------------------------------------------------------------    
	/**
	 * @return null means no such attribute in this
	 */
	public String getAttributeName(Object attr)
	{
		List attrNameSet = this.getNodeAttrNameList();
		for (Iterator iter = attrNameSet.iterator(); iter.hasNext();)
		{
				try
				{
					String attrName = (String) iter.next();
					Object attrByName = this.getAttribute(attrName);
					if (attrByName == attr
						|| (attrByName instanceof List
							&& ((List) attrByName).contains(attr)))
					{
						return attrName;
					}
				}
				catch (AttributeException e)
				{
					// there is no such attribute
				}
			}
		return null;
	}

//	public List getNodeAttributeList()
//	{
//		NodeDecl node = StgTree.getNodeDecl(this.getShortClassName(), SemanticTree.gramTree);
//		List attrList = node.getOptFieldList();
//		return attrList;
//	}
//	-------------------------------------------------------------------------
    protected String deleteMemberName = null;
	protected Boolean deleteMemberFlag = null;
	public /*synchronized*/ void deleteDefaultChildren()
	{
		List childList = this.getDescenList(0);
		childList.remove(this);
		for (Iterator iter = childList.iterator(); iter.hasNext();)
		{
			BaseNode child = (BaseNode) iter.next();
			if(child.isDefault())
			{
				try
				{
					String childName = this.getAttributeName(child);
					Object attr = this.getAttribute(childName);
					if(attr instanceof List)
					{
						((List)attr).clear();
						//((ArrayList)attr).trimToSize();
					}
					else
					{
						this.deleteMemberName = this.getShortClassName().trim() + "." + childName.trim();
						this.deleteMemberFlag = Boolean.TRUE;
						
						this.setSetMode(BaseNode.INIT);
						this.setAttributeSynch(childName, null);
						
						this.deleteMemberFlag = Boolean.FALSE;
					} 
				}
				catch (IllegalArgumentException e)
				{
					continue;
				}
				catch (AttributeException e) 
				{
					continue;
				}
			}
		}
	}
	public String getFullQualifiedClassName()
	{
		return this.getClass().getName();	
	}
	public String getShortClassName()
	{
        if(this.getClass().getName().indexOf(GlobalProperties.FULL_QUALIF_NAME_SEPAR)>=0)
		{
            return this.getClass().getName().substring(this.getClass().getName().lastIndexOf(GlobalProperties.FULL_QUALIF_NAME_SEPAR)+1);   
        }
        else {
            return this.getClass().getName().substring(this.getClass().getName().lastIndexOf(".")+1);
        }
	}



     

	//-------------------------------------------------------------------------
	/**
	 * @return the nearest Ancestor of this containing the child of type equals to @param childtype
	 */
	public BaseNode getNearestAncestorWithChild(String childType)
	{		
		BaseNode currAncestor = (BaseNode)this.getParent();
		while (currAncestor!=null && ((BaseNode)currAncestor).hasChild(childType).isEmpty()) 
		{
			currAncestor = (BaseNode)currAncestor.getParent();
		} 		
		return currAncestor;
	}
////	-------------------------------------------------------------------------
//	public static List getCopy(List/*BaseNode*/ oldList )
//	{
//		if (oldList == null) return null;
//		ArrayList res = new ArrayList(0);
//            
//		int oldListSize = oldList.size();
//            
//		for (int i = 0; i < oldListSize; i++) 
//		{			
//			res.add(BaseNode.getCopy((BaseNode)oldList.get(i)));	
//		}        	        	
//		return res;
//	}

//	-------------------------------------------------------------------------
	public /*synchronized*/ List getCopy(List/*BaseNode*/ oldList )
	{
		if (oldList == null) return null;
		ArrayList res = new ArrayList(0);
            
		int oldListSize = oldList.size();
            
		for (int i = 0; i < oldListSize; i++) 
		{			
			res.add(((BaseNode)oldList.get(i)).getCopy());	
		}        	        	
		return res;
	}
	
	public BaseNode copyOnlyWithAttributes()throws StgException
	{			
		//throw new UnsupportedOperationException();
		BaseNode res = createInstance(this.getShortClassName());
		
		res.setChangeable(this.changeable);
		res.setCreated(this.created);
		res.setInfluenceCounter(this.influenceCounter);
		
		if (this.influenceList != null && !this.influenceList.isEmpty())
        {
            FullSemRelList newList = new FullSemRelList();
            newList.addAll(this.influenceList);
            res.setInfluenceList(newList);
        }
		
		res.setKeyKind(this.keyKind);
		res.setPrinted(this.printed);
		res.setRelevantChecker(this.relevantChecker);
		
		if (this.semRelList != null && !this.semRelList.isEmpty())
        {
		    FullSemRelList newList = new FullSemRelList();
            newList.addAll(this.semRelList);
            res.setSemRelList(newList);
        }
		
		res.setSetMode(BaseNode.INIT);
	    
		// get java fields
		Field[] javaFields = this.getClass().getFields();
		for (int i = 0; i < javaFields.length; i++)
        {
		    String currFieldName = javaFields[i].getName();
		    
            try
            {
                if (!Class.forName("ru.ispras.redverst.stg.base.BaseNode").isInstance(res.getClass().getField(currFieldName).get(res))
                 && !Class.forName("java.util.AbstractCollection").isInstance(res.getClass().getField(currFieldName).get(res)))
                res.getClass().getField(currFieldName).set(res,
                            this.getClass().getField(currFieldName).get(this));                
            }
            catch (IllegalAccessException e)
            {
                //e.printStackTrace();
                continue;
            }
            catch (NoSuchFieldException e)
            {
                //e.printStackTrace();
                continue;
            }      
            catch (ClassNotFoundException e)
            {
                e.printStackTrace();
                continue;
            }                  
            
        }
		
		
		if (SemanticTree.gramTree !=null)
		{
			NodeDecl node = StgTree.getNodeDecl(this.getShortClassName(), SemanticTree.gramTree);
			List attrList = node.getOptFieldList();
				
			List attrNamesList = new ArrayList(0);
			for (Iterator iter = attrList.iterator(); iter.hasNext();)
			{
                Object element = iter.next();
                if (element instanceof FieldDescriptor)
                {
                    FieldDescriptor fieldDesc = (FieldDescriptor) element;
                    if (fieldDesc.getNode() instanceof Attribute)
                    {
                        attrNamesList.add(fieldDesc.getName().getValue());
                    }
                }
			} 			
			for (Iterator iter = attrNamesList.iterator(); iter.hasNext();)
			{
				String attrName = (String) iter.next();
					
				try
				{
					Object attrObject = this.getAttribute(attrName); 
					if(attrObject instanceof BaseNode && ((BaseNode)attrObject).isSpecial()
					|| !(attrObject instanceof BaseNode))
					{
						res.setSetMode(BaseNode.INIT);
						res.setAttribute(attrName, this.getAttribute(attrName));
					} 
				}
				catch (IllegalArgumentException e)
				{
					continue;
				}
				catch (AttributeException e)
				{
					continue;
				}					
			}
		}
		res.deleteDefaultChildren();
		return res;		 
	}
	//-------------------------------------------------------------------------
	/**
	 *
	 */
	public void visit( Modl_Visitor visitor )throws StgException
	{
		throw new IllegalStateException(Messages.INTERNAL_ERROR + " it is impossible to visit abstract node ");
	}
//	-------------------------------------------------------------------------	
	/**
	 *
	 */
	/* (non-Javadoc)
	 * @see ru.ispras.redverst.atp.Node#accept(ru.ispras.redverst.atp.Visitor)
	 */
	public void accept(Visitor visitor)
	{
//		throw new UnsupportedOperationException();
	//	try 
	//	{
			this.visit((Modl_Visitor)visitor);
	/*	} catch (StgException e) {
			e.printStackTrace();
		}*/
		
	}

	//-------------------------------------------------------------------------
	/**
	 *
	 * @param node 
	 * @return 
	 *         true,  nodeName -     this
	 *        false,  
	 * @throws NullPointerException if nodeName.length <= 0
	 */
	public List /*BaseNode*/ hasChild(String nodeName)
	{
        try
        {
            VisitorGetChildList childListGetter = (VisitorGetChildList) Class
                    .forName(
                            "ru.ispras.redverst.stg.langdep.visitors."
                                    + GlobalProperties.TARGET_LANGUAGE
                                    + "VisitorGetChildList").newInstance();
            if (nodeName == null)
            {
                throw new NullPointerException();
            }
            try
            {
                childListGetter.NullAttributes();
                this.visit(childListGetter);

                return Utils.containsOfType(
                        GlobalProperties.LANG_TDT_MODEL_PACK_NAME
                                + GlobalProperties.FULL_QUALIF_NAME_SEPAR
                                + nodeName, childListGetter.getChildList());
            }
            catch (StgException e)
            {
                e.printStackTrace();
                throw new IllegalStateException();
            }
        }
        catch (Exception e)
        {
            e.printStackTrace();
            throw new IllegalStateException("Failed to create instantiate " + "ru.ispras.redverst.stg.langdep.visitors."+ GlobalProperties.TARGET_LANGUAGE+ "VisitorGetChildList");
        }
	}	
//	-------------------------------------------------------------------------	
	/**
	 * 
	 * @return list of children of this
	 */
	public List /*BaseNode*/ getChildList()
	{
		try
		{
		    VisitorGetChildList childListGetter = (VisitorGetChildList) Class
	        .forName(
	                "ru.ispras.redverst.stg.langdep.visitors."
	                        + GlobalProperties.TARGET_LANGUAGE
	                        + "VisitorGetChildList").newInstance();
		    childListGetter.NullAttributes();
			this.visit(childListGetter);
                
			return childListGetter.getChildList();				
		}
		catch (StgException e)
		{
            e.printStackTrace();
			throw new IllegalStateException();
		}
		catch (Exception e) 
		{
            e.printStackTrace();
		    throw new IllegalStateException("Failed to create instantiate " + "ru.ispras.redverst.stg.langdep.visitors."+ GlobalProperties.TARGET_LANGUAGE+ "VisitorGetChildList");
        }
		
	}
//	-------------------------------------------------------------------------
	public /*synchronized*/ BaseNode getCopy(/*BaseNode origNode */)
	{
	    VisitorCopierNodeWithAttachment copierNodeWithAttach = null;
	    try
	    {
	        copierNodeWithAttach = (VisitorCopierNodeWithAttachment) Class.forName("ru.ispras.redverst.stg.langdep.visitors."+ GlobalProperties.TARGET_LANGUAGE+ "VisitorCopierNodeWithAttachment").newInstance();
	    }
	    catch (Exception e) 
	    {
            e.printStackTrace();
            throw new IllegalStateException(e + " exception was caught and copierNodeWithAttach build was failed for " + this);
        }
	    copierNodeWithAttach.setInsertInTree(false);

		copierNodeWithAttach.setMode(VisitorCopierNodeWithAttachment.COPY);
		copierNodeWithAttach.setStartNodeType(this.getClass().getName());
            
		try
		{
			List newNodeList = copierNodeWithAttach.start((BaseNode)this);
		} 
		catch (SemanticConstrViolation e)
		{
            e.printStackTrace();
			throw new IllegalStateException(Messages.INTERNAL_ERROR + " SemanticConstrViolation during BaseNode.getCopy(..) of " + this + ": " + e.getMessage());
		}
		catch (StgException e)
		{
            e.printStackTrace();
			throw new IllegalStateException(Messages.INTERNAL_ERROR + " unknown stg exception ");
		}
		BaseNode res = copierNodeWithAttach.getCopy();

/*		res.setKeyKind(origNode.getKeyKind());
		res.changeable = origNode.changeable;
		res.relevantChecker = origNode.relevantChecker;
		res.semRelList = origNode.semRelList;
		res.setMode = origNode.setMode;			
*/		
		return res;			
	}
//	-------------------------------------------------------------------------
	public static ValueIterator getNodeIterator(String type)
	{
	    StgNodeIterator.refreshIterationBorder();
		NodeDecl node = StgTree.getNodeDecl(type, SemanticTree.gramTree);
		if (node == null)
        {
            throw new IllegalStateException("There is no node of type " + type);
        }
		try 
		{
			if (node.getIsAbstract()) 
			{
				return (ValueIterator)Class.forName(
						"ru.ispras.redverst.stg.langdep.iterators.nodes.isabstract."
								+ type + "Iterator").newInstance();
			} else 
			{
				
				ValueIterator iter = (ValueIterator)Class.forName("ru.ispras.redverst.stg.langdep.iterators.nodes.notabstract."+ type + "Iterator").newInstance();
				
				return iter;
			}
		} 
		catch (Exception e) 
		{
			e.printStackTrace();
			return null;
		}		
	}
	/**
	 * @return ValueIterator this node variations iterator
	 */
//	public ValueIterator getNodeIterator()
//	{
//		String type = this.getShortClassName();
//		NodeDecl node = StgTree.getNodeDecl(type, SemanticTree.gramTree);
////        StgNodeIterator.setCheckIterationBorder(true);
//        StgNodeIterator.setInitIterationBorder(GlobalProperties.ITER_DEPTH);
//        StgNodeIterator.refreshIterationBorder();
//		try 
//		{
//			if (node.getIsAbstract()) 
//			{
//				return (ValueIterator)Class.forName(
//						"ru.ispras.redverst.stg.langdep.iterators.nodes.isabstract."
//								+ type + "Iterator").newInstance();
//			} else 
//			{
//				return (ValueIterator)Class.forName(
//						"ru.ispras.redverst.stg.langdep.iterators.nodes.notabstract."
//								+ type + "Iterator").newInstance();
//			}
//		} 
//		catch (Exception e) 
//		{
//			e.printStackTrace();
//			return null;
//		}
//		
//	  try {
//		  this.visit(nodeIteratorFinder);
//						
//	  } catch (StgException e) 
//	  {
//		  throw new IllegalStateException(Messages.INTERNAL_ERROR + " incorrect exception ");
//	  }
//				   	
//	  return nodeIteratorFinder.getIterator();      	
//	}



//	-------------------------------------------------------------------------
	/**
	 * @return list of all descendents
	 */
	public List getDescenList()
	{
		
		try 
		{
		    VisitorDescenListReceiver descenListReceiver = (VisitorDescenListReceiver) Class.forName(
                    "ru.ispras.redverst.stg.langdep.visitors."
                            + GlobalProperties.TARGET_LANGUAGE
                            + "VisitorDescenListReceiver").newInstance();
			descenListReceiver.NullAttributes();
			this.visit(descenListReceiver);
			return descenListReceiver.getChildList();
			
		} catch (StgException e) 
		{
            e.printStackTrace();
			throw new IllegalStateException(Messages.INTERNAL_ERROR + " incorrect exception ");
		}
		catch (Exception e) {
            e.printStackTrace();
            throw new IllegalStateException(" Failed to instantiate " + "ru.ispras.redverst.stg.langdep.visitors."
                    + GlobalProperties.TARGET_LANGUAGE
                    + "VisitorDescenListReceiver");
        }
    	
		
	}
//	-------------------------------------------------------------------------
	/**
	 * @return list of all descendents
	 */
	public List getDescenList(int depth)
	{
		try 
		{
		    VisitorDescenListReceiver descenListReceiver = (VisitorDescenListReceiver) Class.forName(
                    "ru.ispras.redverst.stg.langdep.visitors."
                            + GlobalProperties.TARGET_LANGUAGE
                            + "VisitorDescenListReceiver").newInstance();
		    
			descenListReceiver.NullAttributes();
			descenListReceiver.setDepth(depth);
			this.visit(descenListReceiver);
			return descenListReceiver.getChildList();	
		} catch (StgException e) 
		{
            e.printStackTrace();
			throw new IllegalStateException(Messages.INTERNAL_ERROR + " incorrect exception ");
		}
		catch (Exception e) {
            e.printStackTrace();
            throw new IllegalStateException(" Failed to instantiate " + "ru.ispras.redverst.stg.langdep.visitors."
                    + GlobalProperties.TARGET_LANGUAGE
                    + "VisitorDescenListReceiver");
        }    	
		
	}    
	

	//--------------
	/**
	 * exchanges node in the tree to new one
	 */
//	public /*synchronized*/ void exchangeNode(BaseNode oldNode, BaseNode newNode)
//	{
//		try 
//		{
//		    VisitorExchangeChild childExchanger = (VisitorExchangeChild) Class.forName(
//	                "ru.ispras.redverst.stg.langdep.visitors."
//	                        + GlobalProperties.TARGET_LANGUAGE
//	                        + "VisitorExchangeChild").newInstance();
//			//     
//			childExchanger.setNewChild(newNode);
//			childExchanger.setOldChild(oldNode);
//			((BaseNode) oldNode.getParent()).visit(childExchanger);				
//		}
//		catch (StgException e) 
//		{
//            e.printStackTrace();
//			throw new IllegalStateException();
//		}
//		catch (Exception e) {
//            e.printStackTrace();
//		    throw new IllegalStateException(" Failed to instantiate " + "ru.ispras.redverst.stg.langdep.visitors."
//                    + GlobalProperties.TARGET_LANGUAGE
//                    + "VisitorExchangeChild");
//        }
//    	
//	}
	//-------------------------------------------------------------------------
	/**
	 * @return list of string children names which can be 'child'  
	 */
	public List/*String*/ getChildNames(BaseNode child)
	{
        ArrayList res = new ArrayList();        
		try 
		{
		    VisitorMultiWaysAdderChild multiWaysAdder = (VisitorMultiWaysAdderChild) Class.forName(
                    "ru.ispras.redverst.stg.langdep.visitors."
                            + GlobalProperties.TARGET_LANGUAGE
                            + "VisitorMultiWaysAdderChild").newInstance();
			List childList = new ArrayList(1);
			childList.add(child);
            List waysList = multiWaysAdder.start(this, childList); 
            
            res.addAll(waysList);
			
		} 
		catch (StgException e) 
		{
            e.printStackTrace();
			throw new IllegalStateException(" StartNode.java, line 740: " + Messages.INTERNAL_ERROR + " incorrect exception was caught");
		}	
		catch (InstantiationException e) {
            e.printStackTrace();
		    throw new IllegalStateException(" Failed to instantiate " + "ru.ispras.redverst.stg.langdep.visitors."
                    + GlobalProperties.TARGET_LANGUAGE
                    + "VisitorMultiWaysAdderChild");
        }
        catch (IllegalAccessException e) {
            e.printStackTrace();
        }
        catch (ClassNotFoundException e) {
            e.printStackTrace();
        }
        return  res;
	}	
//	-------------------------------------
	/**
	 * add child by name to this if place is empty
	 */
	public synchronized List addChild(BaseNode child, String attrName, SemanticTree semTree)throws SemanticConstrViolation
	{
	    List res = new ArrayList(0);
		try
		{
		    VisitorTreeCreator treeCreator = (VisitorTreeCreator) Class.forName(
                    "ru.ispras.redverst.stg.langdep.visitors."
                            + GlobalProperties.TARGET_LANGUAGE
                            + "VisitorTreeCreator").newInstance();		    
			res = treeCreator.start(this, child, attrName, semTree);
		}
        catch (ClassNotFoundException e) {
            // TODO: handle exception
        }
        catch (IllegalAccessException e) {
            // TODO: handle exception
        }
        catch (InstantiationException e) {
            // TODO: handle exception
        }
//        catch (SemanticConstrViolation e) 
//        {
//            // TODO: handle exception
//        }
//		catch (StgException e) 
//		{
//            e.printStackTrace();
//			throw new IllegalStateException(" BaseNode.java, line 2900: " + Messages.INTERNAL_ERROR + " incorrect stg exception was caught");
//		}	
//		catch (Exception e) {
//            e.printStackTrace();
//		    throw new IllegalStateException(" Failed to instantiate " + "ru.ispras.redverst.stg.langdep.visitors."
//                    + GlobalProperties.TARGET_LANGUAGE
//                    + "VisitorTreeCreator");
//        }
		if (child != null) 
		{
		    if(child.getParent()!=null)return  res;
		    
		    throw new SemanticConstrViolation();
		}
		else
		{
			return res;
		}
	}
//	-------------------------------------
	/**
	 * add new node to subtree
	 */
	public List addNodeToSubtree(BaseNode child)throws SemanticConstrViolation
	{
		try
		{
		    VisitorAddChildToSubTree mainVisitor = (VisitorAddChildToSubTree) Class.forName(
                    "ru.ispras.redverst.stg.langdep.visitors."
                            + GlobalProperties.TARGET_LANGUAGE
                            + "VisitorAddChildToSubTree").newInstance();
		    mainVisitor.setOneSubtree(true);
		    mainVisitor.setSubtreeType(this);
		    mainVisitor.setTree(StgTree.getGramTree());
			return mainVisitor.start(child);
		}
		catch (StgException e) 
		{
            e.printStackTrace();
			throw new IllegalStateException(" BaseNode.java, line 2888: " + Messages.INTERNAL_ERROR + " incorrect stg exception was caught");
		}	
		catch (Exception e) {
            e.printStackTrace();
		    throw new IllegalStateException(" Failed to instantiate " + "ru.ispras.redverst.stg.langdep.visitors."
                    + GlobalProperties.TARGET_LANGUAGE
                    + "VisitorAddChildToSubTree");
        }
	}	

	

//	-------------------------------------------------------------------------

//	/**
//	 *   ( BaseNode)     NodeDecl,      
//	 *
//	 * @param node, parent 
//	 * @return     
//	 * @throws NullPointerException if parent==null
//	 */
//	public BaseNode createInstance(String nodeName, BaseNode parent)
//	{
//		if (parent == null) throw new NullPointerException();
//			
//		BaseNode currNode=null;
//			
//		try
//		{
//		    VisitorNodeIteratorSeek nodeIteratorFinder = (VisitorNodeIteratorSeek) Class.forName(
//                    "ru.ispras.redverst.stg.langdep.visitors."
//                            + GlobalProperties.TARGET_LANGUAGE
//                            + "VisitorNodeIteratorSeek").newInstance();
//			currNode =(BaseNode) Class.forName(GlobalProperties.LANG_TDT_MODEL_PACK_NAME + GlobalProperties.FULL_QUALIF_NAME_SEPAR + nodeName).newInstance();
//			try 
//			{
//				currNode.visit(nodeIteratorFinder);
//					
//			} catch (StgException e) 
//			{
//				throw new IllegalArgumentException();
//			}
//			ValueIterator nodeIter = nodeIteratorFinder.getIterator();
//				
//			if(!nodeIter.init()) throw new IllegalArgumentException("impossible to create the node of specified type");
//				
//			currNode = null;
//			do
//			{
//				currNode = (BaseNode)nodeIter.value();
//			}			    
//			while(nodeIter.next() 
//			&& currNode.getRelevantChecker().isSyntacticRelevantNode(currNode, parent) < 0);
//				
//		}
//		catch(InstantiationException inExc)
//		{
//			throw new IllegalStateException(Messages.INTERNAL_ERROR + " impossible instance creation " + GlobalProperties.LANG_TDT_MODEL_PACK_NAME + GlobalProperties.FULL_QUALIF_NAME_SEPAR + nodeName);
//		}
//		catch(IllegalAccessException iaExc)
//		{
//			throw new IllegalStateException(Messages.INTERNAL_ERROR + " illegal access to " + GlobalProperties.LANG_TDT_MODEL_PACK_NAME + GlobalProperties.FULL_QUALIF_NAME_SEPAR + nodeName);
//		}
//		catch(ClassNotFoundException cnfExc)
//		{
//			throw new IllegalStateException(Messages.INTERNAL_ERROR + " class not found " + GlobalProperties.LANG_TDT_MODEL_PACK_NAME + GlobalProperties.FULL_QUALIF_NAME_SEPAR + nodeName);
//		}
//        
//		if(currNode == null) throw new IllegalArgumentException("impossible to create the node of specified type");
//			
//		return currNode;
//	}
	/**
	 * 
	 * @throws StgException
	 */
	public static void stgExceptionGag () throws StgException
	{
	    // it's a gag 
	}
	
	/**
	 * 
	 * @param semRelList shouldn't be empty
	 * @return List of BaseNodes being descendents of this and key node of some semantic relation from @param
	 */
	public List getDescendentsSemanticInvolved(FullSemRelList semRelList)
	{
		
		List res = new ArrayList(0);
		if (semRelList.isEmpty()) return res;
		
		List descList = this.getDescenList();
		for (Iterator iter = descList.iterator(); iter.hasNext();)
		{
			BaseNode descen = (BaseNode) iter.next();
			if (!semRelList.getSemRelNumberBySrc(descen).isEmpty()
			 || !semRelList.getSemRelNumberByTrg(descen).isEmpty())
			 {
			 	res.add(descen);
			 } 
		}
		
		return res;
	}
//	-------------------------------------------------------------------------
	/**
	 * Checks if subtree headed this contains sources to nodes from subtree headed by nextNode. 
	 *     ***** Returns pairs of dependent nodes
	 * @return boolean
	 */
	public boolean checkSemanticDependence(BaseNode nextNode, FullSemRelList semRelList)
	{
	    List thisDescenNodes = this.getDescenList();
	    thisDescenNodes.add(0, this);
	    
	    List nextnodeDescenNodes = nextNode.getDescenList();
	    nextnodeDescenNodes.add(0, nextNode);
	    
	    for (Iterator iter = thisDescenNodes.iterator(); iter.hasNext();)
        {
            BaseNode currDescen = (BaseNode) iter.next();
            
            //obtains all semantic relations sourced by currDescen
            FullSemRelList currDescenSourcedSemRelList = new FullSemRelList(semRelList.getSemRelBySrc(currDescen), -1);
            
            // obtains all targets of currDescenSourcedSemRelList
            List currDescenTargetList = currDescenSourcedSemRelList.getAllKeyNodes(TARGET);
            
            // if any of targets belong to nextnodeDescenNodes then this subtree is source for next subtree
            boolean res = Utils.containsAny(currDescenTargetList, nextnodeDescenNodes);
            if (res) return true;
            else continue;
        }
	    
	    return false;
	}
	public boolean isPrintOrdered()
	{
	    return (printOrder>=0);
	}
    public int getPrintOrder()
    {
        return printOrder;
    }
    public void setPrintOrder(int printOrder)
    {
        this.printOrder = printOrder;
    }
    
    public boolean hasNotPrintOrderedDescen()
    {
        List descenList = this.getDescenList();
        for (Iterator iter = descenList.iterator(); iter.hasNext();)
        {
            BaseNode element = (BaseNode) iter.next();
            if (!element.isPrintOrdered()) return true;
        }
        return false;
    }
    
//	-----------------    
//    private static int 
    public void semanticSortNode(FullSemRelList semRelList) throws SemanticFormalizationException
    {
        if (semRelList.isEmpty()) return;
        
        List childList = this.getChildList();
        if (this.hasNotPrintOrderedDescen())
        {
            for (Iterator iter = childList.iterator(); iter.hasNext();)
            {
                BaseNode child = (BaseNode) iter.next();
                child.semanticSortNode(semRelList);
            }
        }

        {
            // if node has less or equal to 1 child than consider next node
            if (childList.size()<=1)
            {
                this.setPrintOrder(0);
                return;
            }
            else
            {
                List attrNames = this.getChildrenNames();
                for (Iterator iter = attrNames.iterator(); iter.hasNext();)
                {
                    String name = (String) iter.next();
                    Object attr = this.getAttribute(name);
                    if (attr instanceof List)
                    {
                        List listToOrder = (List) attr;
                        List printOrderChildList = this.sortChildList(listToOrder, semRelList);
//                        for (int i = 0; i < printOrderChildList.size(); i++)
//                        {
//                            BaseNode orderedChild = (BaseNode)printOrderChildList.get(i);
//                            orderedChild.setPrintOrder(i);
//                        }                        
                    }
                }
                
            }            
        }
    }  
    /**
     * 
     * @param nextNode
     * @param semRelList
     * @return -1 if this should be printed first, 0 if it's all the same, 1 if nextNode should be printed first 
     * @throws SemanticFormalizationException
     */
    public int printOrder(BaseNode nextNode, FullSemRelList semRelList)throws SemanticFormalizationException
    {
        if (this.checkSemanticDependence(nextNode, semRelList))
        {
            if (nextNode.checkSemanticDependence(this, semRelList))
            {
                throw new SemanticFormalizationException("Tree couldn't be sorted for semantic dependent printing.");
            }
            else
            {
                return -1;
            }
        }
        else
        {
            if (nextNode.checkSemanticDependence(this, semRelList))
            {
                return 1;
            }
            else
            {
                return 0;
            }
        }
    }
    /**
     * 
     * @param list
     * @throws IllegalStateException
     */
	public List/*BaseNode*/ sortChildList(List/*BaseNode*/ list, FullSemRelList semRelList)throws SemanticFormalizationException
	{		
	    if (list.isEmpty()) return list;
	     
		ArrayList res = new ArrayList(0);
		res.add(list.get(0));
		
		for (int i = 1; i < list.size(); i++)
		{
			int j = 0;
			while(j < res.size() && ((BaseNode)list.get(i)).printOrder((BaseNode)res.get(j), semRelList)>0)
			{			
				j++;
			}
				
			if(j==res.size())
			{
				res.add(list.get(i));
			}
			else
			{
				res.add(j, list.get(i));
			}			
		}		
        list.clear();
        list.addAll(res);
		return res;	
	}    
    /**
     * Sorts list in compliance with print order
     * @param list
     * @return
     */
//	public static List semanticSortList(List/*BaseNode*/ list)
//	{
//	    if (list.isEmpty()) return list;
//	    List res = new ArrayList(0);
//	    
//	    res.add(list.get(0));
//	    
//	    for (int i = 1; i < list.size(); i++)
//        {
//            int j = 0;
//			while(j < res.size() 
//			  && ((BaseNode)list.get(i)).getPrintOrder() <= ((BaseNode)res.get(j)).getPrintOrder())
//			{			
//				j++;
//			}
//				
//			if(j==res.size())
//			{
//				res.add(list.get(i));
//			}
//			else
//			{
//				res.add(j, list.get(i));
//			}	            
//        }
//        return res;
//	}
	/**
	 * Returns NodeDecl description of this node 
	 * @return
	 */
	public TDL.NodeDecl getNodeDecl()
	{
	    return StgTree.getNodeDecl(this.getShortClassName(), SemanticTree.gramTree);
	}
	/* (non-Javadoc)
     * @see java.lang.Object#equals(java.lang.Object)
     */
    public boolean equals(Object arg0)
    {
        if (arg0 instanceof BaseNode)
        {
            BaseNode node = (BaseNode) arg0;
            return node == this;
        }
        return false;
    }
    /**
     * 
     */
    public /*synchronized*/ void deleteChild(String name, BaseNode childToDelete)
    {
        try
        {
            VisitorDeleteNode nodeDeleter = (VisitorDeleteNode) Class.forName(
                    "ru.ispras.redverst.stg.langdep.visitors."
                            + GlobalProperties.TARGET_LANGUAGE
                            + "VisitorDeleteNode").newInstance();
            nodeDeleter.setName(name);
            nodeDeleter.setChild(childToDelete);
            this.accept(nodeDeleter);
        }
        catch (Exception e)
        {
            e.printStackTrace();
            throw new IllegalStateException(" Failed to instantiate " + "ru.ispras.redverst.stg.langdep.visitors."
                    + GlobalProperties.TARGET_LANGUAGE
                    + "VisitorDeleteNode");
        }
    }
    public synchronized void initSynchConst (){}
    public synchronized void dropInitConst (){}    
    /**
	 * 
	 */
	public String getChildType(String childName) 
	{
		NodeDecl nodeDecl = this.getNodeDecl();
		return StgNodeDecl.getFieldType(childName, nodeDecl);
	}
	
	/**
     * 
     */
    public List getChildrenNames()
    {
        List fieldList = this.getNodeDecl().getOptFieldList();
        List res = new ArrayList();
		
        int fieldNumber = fieldList.size();
		for (Iterator iter = fieldList.iterator(); iter.hasNext();)
        {
            Object element = (Object) iter.next();
            if (element instanceof FieldDescriptor)
            {
                FieldDescriptor currField = (FieldDescriptor) element;
    			if (currField.getKind() == FieldDescriptor.CHILD)
    			{
    				res.add(currField.getName().getValue());
    			}
            }
		}
		return res;
    }
    public /*synchronized*/ void setAttributeSynch(String name, Object child)
    {        
        if (child!=null)
        {
            synchronized (child)
            {
                if (StgNodeDecl.isChildList(StgTree.getNodeDecl(this.getShortClassName(), StgTree.getGramTree()), name))
                {
                    List childList = new ArrayList(2);
                    childList.add(child);
                    this.setAttribute(name, childList);
                }
                else 
                {
                    this.setAttribute(name, child);  
                }                
            }
        }
        else
        {
            this.setAttribute(name, null);
        }
    }	
    public static void setInfluenceList(List/*BaseNode*/ newNodeList, List/*BaseNode*/ oldNodeList)
    {
        if(newNodeList == null || oldNodeList == null) return;
        for (int i = 0; i < newNodeList.size(); i++)
        {
            if (i >= oldNodeList.size()) break;
            ((BaseNode)newNodeList.get(i)).setInfluenceList(((BaseNode)oldNodeList.get(i)).getInfluenceList());
        }
    }
    public static void setSemrelList(List/*BaseNode*/ newNodeList, List/*BaseNode*/ oldNodeList)
    {
        if(newNodeList == null || oldNodeList == null) return;
        for (int i = 0; i < newNodeList.size(); i++)
        {
            if (i >= oldNodeList.size()) break;
            ((BaseNode)newNodeList.get(i)).setSemRelList(((BaseNode)oldNodeList.get(i)).getSemRelList());
        }
    }     
    /**
     * 
     * @param type
     * @param lowBound minimum depth inclusive
     * @param highBound maximum depth inclusive
     * @param created_flag SPECIAL, ORDINARY, if -1 then any
     * @return
     */
    public List	findDescendent(String type, int lowBound, int highBound, int created_flag)
    {
        List res = findDescendent(type, lowBound, highBound, created_flag, 0);
        if (lowBound == 0)
        {
            res.add(0, this);
        }
        return res;
    }
    
    private List findDescendent(String type, int lowBound, int highBound, int created_flag, int depth_counter)
    {
        List res = new ArrayList(0);
        depth_counter++;
        List childList = this.getChildList();
        for (Iterator iter = childList.iterator(); iter.hasNext();)
        {
            BaseNode child = (BaseNode) iter.next();
            
            if(
               (
                  type.length() <= 0
               ||(type.length() > 0 && (child.getShortClassName().equals(type)))
               || StgTree.isInherited(child.getShortClassName(), type, StgTree.getGramTree())
               )
                && depth_counter <= highBound 
                && depth_counter >= lowBound 
                && (created_flag!=-1 ? child.getCreated() == created_flag : true)) 
                {
                	res.add(child);
                }
        }
       
        if (highBound >= depth_counter/* && depth_counter <= lowBound*/)
        {
            for (Iterator iter = childList.iterator(); iter.hasNext();)
            {
                BaseNode child = (BaseNode) iter.next();
                res.addAll(child.findDescendent(type, lowBound, highBound, created_flag, depth_counter));
//                if (res != null)
//                {
//                    return res;
//                }
            }
        }
        depth_counter--;
        return res;
    }
    public int getCreated()
    {
        return created;
    }
    /* (non-Javadoc)
     * @see com.unitesk.atp.dynattrs.Attributed#setAttribute(java.lang.String, java.lang.Object)
     */
    public void setAttribute(String arg0, Object arg1)
    {
        if (this.isChildList(arg0) && !(arg1 instanceof List))
        {
            List argList = new ArrayList(0);
            argList.add(arg1);
            super.setAttribute(arg0, argList);
        }
        else
        {
            super.setAttribute(arg0, arg1);
        }
    }
    /*
     *     AST,     
        ===================================================================================
           : level="    ",    level=0
          : N = 1
        : printStep = 0,1 * level
         : m = (N-printStep + printStep*childId/10*dozenId),  N- 0<=childId<=9 -      , 
        1<=dozenId -  dozenId   1,  childId   9   childId 

     */
    public static double printStep = GlobalProperties.PRINT_ID_STEP * GlobalProperties.START_NODE_LEVEL_ID;
    public int childId = 0;
    public int dozenId = 1;
    public double prevN = 1;
    public double nextId(double N, int level)
    {
//        if (N==GlobalProperties.START_NODE_PRINT_ID || prevN != N)
//        {
//            childId = 0;
//            dozenId = 1;            
//        }   
//        else 
        {
            if (childId < 9)
            {
                childId++;            
            }
            else 
            {
                dozenId = (-10)*dozenId;
                childId = 0;
            }            
        }
        prevN = N;
        printStep = GlobalProperties.PRINT_ID_STEP*level;
        

        return (N-printStep + printStep*childId/10*dozenId);
    }

    public double getPrintOrderId()
    {
        return printOrderId;
    }

    public void setPrintOrderId(double printOrderId)
    {
        if(this.printOrderId == printOrderId) return;
            
        this.printOrderId = printOrderId;
        List childrenList = this.getChildList();
        for (Iterator iter = childrenList.iterator(); iter.hasNext();)
        {
            BaseNode child = (BaseNode) iter.next();
            child.setPrintOrderId(nextId(this.printOrderId, this.level));
        }
    }

    public int getLevel()
    {
        return level;
    }

    public void setLevel(int level)
    {
        if(this.level == level) return;
        
        this.level = level;
        List childrenList = this.getChildList();
        for (Iterator iter = childrenList.iterator(); iter.hasNext();)
        {
            BaseNode child = (BaseNode) iter.next();
            child.setPrintOrderId(nextId(this.printOrderId, this.level));
        }        
        BaseNode indObj = null;
    }
    
    /***
     * Return true if this node will be printed early then node
     * @param node
     * @return
     */
    public boolean isPrintOrderLess(BaseNode node)
    {
        // find common ancestor
        BaseNode parent = (BaseNode)this;
        while (parent != null)
        {
            boolean res = node.hasAncestor(parent);
            if (res)
            {
                if (parent == this)
                {
                    return true;
                }
                else
                {
                    break;    
                }
            }
            parent = (BaseNode)parent.getParent();
        }
        if (parent ==  null)
        {
            throw new IllegalStateException();
        }
        List childList = parent.getChildList();
        BaseNode thisAnces = null;
        BaseNode nodeAnces = null;
        for (int i = 0; i < childList.size(); i++)
        {
            BaseNode child = (BaseNode)childList.get(i);
            if (nodeAnces==null && node.hasAncestor(child))
            {
//                nodeAnces = child;
                return false;
            }
            if (thisAnces==null && this.hasAncestor(child))
            {
//                thisAnces = child;
                return true;
            }
//            if (thisAnces != null && nodeAnces != null)
//            {
//                break;
//            }
        }
//        if (thisAnces == null || nodeAnces == null)
//        {
            throw new IllegalStateException();
//        }
//        return childList.indexOf(thisAnces)<childList.indexOf(nodeAnces);
    }
    
    /**
     * Returns true if this node is printed before nodes 
     * @param node
     * @return 
     */
    public boolean isPrintOrderLess(BaseNode[] nodes)
    {
        for (int i = 0; i < nodes.length; i++)
        {
            if (!isPrintOrderLess(nodes[i]))
            {
                return false;
            }
        }
        return true;
    }
    
    /**
     *    .         this. 
     * @return
     */
    public EmptySemRelList getConnectedSemRelList()
    {
        EmptySemRelList res = new EmptySemRelList();
        EmptySemRelList depSemRelList = new EmptySemRelList();

        /*
         *   ,    this
         */
        String nodeName = this.getShortClassName();
        EmptySemRelList currNodeSemRelList = (EmptySemRelList)SemanticTree.semanticMap.get(StgTree.getNodeDecl(nodeName, SemanticTree.gramTree)); 

        for (Iterator iter = currNodeSemRelList.getSemList().iterator(); iter.hasNext();)
        {
            SemanticRelationDescriptor srd = (SemanticRelationDescriptor) iter.next();
//          adding dependent relations
            depSemRelList.addAll(new EmptySemRelList(srd.getDepSrdList(), -1));
            /*
             *      
             */
            depSemRelList.addAll(new EmptySemRelList(srd.getAllBaseSemRelDesc(), -1));                      
        }

        if (currNodeSemRelList != null && !currNodeSemRelList.isEmpty()) 
        {
            res.addAll(currNodeSemRelList); 
            res.addAll(depSemRelList);  
        }              
        return res;
    }
    /**
     *  true,       newChild 
     *         GlobalProperties.RECUR_DEPTH
     * @param newChild -          this, 
     * canBeChanged -   true,        newChild    ,  - false 
     * @return
     */
    public boolean isRecursionRestrictionBrokenWithNewChild(BaseNode newChild, boolean canBeChanged)
    {
        List newNodesList = newChild.getDescenList();
        if (canBeChanged)
        {
            newNodesList.add(0, newChild);   
        }
        for (Iterator iter = newNodesList.iterator(); iter.hasNext();)
        {
            BaseNode newNode = (BaseNode) iter.next();
            
            //             ,     
            BaseNode newNodeParent = (BaseNode)newNode.getParent();
            if (newNodeParent != null)
            {
                String childName = newNodeParent.getAttributeName(newNode);

                Child childDesc = (Child) StgNodeDecl.getAttribute(StgTree
                        .getNodeDecl(newNodeParent.getShortClassName(),
                                SemanticTree.gramTree), childName);
                if (!((NodeType) childDesc.getType()).getName().getNodeDecl()
                        .getIsAbstract())
                {
                    continue;
                }
            }
            String nodeType = newNode.getShortClassName();
            int repetition = 1;
            BaseNode ancestor = newNode.findClosestAncestorOfType(nodeType);
            while (ancestor!=null)
            {
                repetition++;
                ancestor = ancestor.findClosestAncestorOfType(nodeType);
            }
            if (this.getShortClassName().equals(nodeType))
            {
                repetition++;
            }
            ancestor = this.findClosestAncestorOfType(nodeType);
            while (ancestor!=null)
            {
                repetition++;
                ancestor = ancestor.findClosestAncestorOfType(nodeType);
            }            
            if (repetition > GlobalProperties.RECUR_DEPTH)
            {
                return true;
            }
        }
        return false;
    }
    
    /**
     * Returns distance from this node to ancestor node specified
     * @param ances
     * @return
     */
    public int getDepthToAnces(BaseNode ances)
    {
        int depth = 0;
        BaseNode parent = this;
        while (parent != ances)
        {
            depth++;
            parent = (BaseNode)parent.getParent();
        }
        return depth;
    }

    public boolean isProhibitedToDelete(SemanticTree semTree)
    {
        return isSpecial() 
            || prohibitedToDelete 
            || !semTree.getFullSemRelList().getSemRelBySrc(this).isEmpty();
    }

    public void setProhibitedToDelete(boolean prohibitedToDelete)
    {
        this.prohibitedToDelete = prohibitedToDelete;
    }
}
