/*
 * Copyright 2004-2009 ISP RAS (http://www.ispras.ru), UniTESK Lab (http://www.unitesk.com)
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package ru.ispras.redverst.stg.base;

/**
 * @author maryn
 *
 * ChainElement implements the logic and functions to manage elements of node chains 
 * as prepared raw material for syntactic trees   
 */
public class ChainElement
{
    private String parentLabel;
//    private BaseNode node;
    private String childLabel;
    private String nodeType;
    private int kind;//SOURCE or TARGET or CONTEXT etc.
    /**
     * 
     */
    public ChainElement(String parentLabel, String nodeType, String childLabel, int kind)
    {
        super();
        this.parentLabel = parentLabel;
        this.nodeType = nodeType;
        this.childLabel = childLabel;
        this.kind = kind;
    }
    
    public ChainElement(ChainElement element)
    {
        super();
        this.parentLabel = element.parentLabel;
        this.nodeType = element.nodeType;
        this.childLabel = element.childLabel;
        this.kind = element.kind;
    }    
    
	public String getChildLabel()
	{
	    return childLabel;
	}
	public void setChildLabel(String childLabel)
	{
	    this.childLabel = childLabel;
	}
    public String getNodeType()
    {
        return nodeType;
    }
    public void setNodeType(String nodeType)
    {
        this.nodeType = nodeType;
    }
    public String getParentLabel()
    {
        return parentLabel;
    }
    public void setParentLabel(String parentLabel)
    {
        this.parentLabel = parentLabel;
    }
    public int getKind()
    {
        return kind;
    }
    public void setKind(int kind)
    {
        this.kind = kind;
    }
    
}
