/*
 * Copyright 2004-2009 ISP RAS (http://www.ispras.ru), UniTESK Lab (http://www.unitesk.com)
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package ru.ispras.redverst.stg.base.iterators;

import java.util.ArrayList;
import java.util.List;

import ru.ispras.redverst.iterator.ValueIterator;
import ru.ispras.redverst.stg.global.GlobalProperties;
import ru.ispras.redverst.stg.semrel.AncesElement;
import ru.ispras.redverst.stg.semrel.FieldElement;
import ru.ispras.redverst.stg.semrel.Path;
import ru.ispras.redverst.stg.semrel.PathElement;

/**
 * @author maryn
 *
 * To change the template for this generated type comment go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
public /*abstract*/ class StgNodeIterator implements ValueIterator
{
    protected static long stringCounter = 0;
    protected int privateIterationBorder;
    static protected int initIterationBorder = 1000000000;
    static protected int iterationBorder = initIterationBorder;
    static protected boolean checkIterationBorder = true;
    protected boolean usedLastValue = false;

    static public void setInitIterationBorder(int iterationBorder)
    {
        StgNodeIterator.initIterationBorder = iterationBorder;// > 0 ? iterationBorder : 1;
    }
    static public boolean isCheckIterationBorder()
    {
        return checkIterationBorder;
    }
    /**
     * 
     */
    public StgNodeIterator()
    {
        super();
        
        if (StgNodeIterator.iterationBorder > initIterationBorder)
        {
            StgNodeIterator.iterationBorder = initIterationBorder;
        }
    }

    /* (non-Javadoc)
     * @see ru.ispras.redverst.iterator.ValueIterator#init()
     */
    public boolean init()
    {
        // TODO Auto-generated method stub
        return false;
    }

    /* (non-Javadoc)
     * @see ru.ispras.redverst.iterator.ValueIterator#next()
     */
    public boolean next()
    {
        // TODO Auto-generated method stub
        return false;
    }

    /* (non-Javadoc)
     * @see ru.ispras.redverst.iterator.ValueIterator#value()
     */
    public Object value()
    {
        // TODO Auto-generated method stub
        return null;
    }

    static public void setCheckIterationBorder(boolean checkIterationBorder)
    {
        StgNodeIterator.checkIterationBorder = checkIterationBorder;//false
    }
    public int getPrivateIterationBorder()
    {
        return privateIterationBorder;
    }
    public void setPrivateIterationBorder(int privateIterationBorder)
    {
        this.privateIterationBorder = privateIterationBorder;
    }
    public static long getNextStringCounter()
    {
        return ++stringCounter;
    }
    public static void setStringCounter(long stringCounter)
    {
        StgNodeIterator.stringCounter = stringCounter;
    }
    protected boolean isRelevantRecurDepth(String name)
    {
        Throwable currThrow = new Throwable();
        StackTraceElement[] stack = currThrow.getStackTrace();
        for (int i = 0; i < stack.length; i++)
        {
            String currFileName = stack[i].getFileName();
            if(currFileName!=null && currFileName.equals(name + "Iterator.java"))
            {
                if ( i > GlobalProperties.RECUR_DEPTH) return false;
            }
        }
        return true;
    }
    public static void refreshIterationBorder()
    {
        
        if (checkIterationBorder)
        {
            StgNodeIterator.iterationBorder = GlobalProperties.ITER_DEPTH;   
        }
        else {
            StgNodeIterator.iterationBorder = initIterationBorder;
        }
    }
    
    /**
     * 
     */
//    public static void defineIterDepth(PathElement lpathElement)
//    {
//		int iterDepthBorder = GlobalProperties.ITER_DEPTH;
//        
//        if (lpathElement != null)
//        {
//            if (lpathElement instanceof FieldElement
//                    || (lpathElement instanceof AncesElement && lpathElement
//                            .getName().equals("parent")))
//            {
//                iterDepthBorder = 1;
//            }
//            if (lpathElement.getFilterParamPath() != null
//                    && lpathElement.getFilterParamPath().size() - 1 > 0
//                    && lpathElement.getFilterParamPath().size() > iterDepthBorder
//                    && lpathElement.getFilterParamPath().getElement(0) instanceof FieldElement)
//            {
//                iterDepthBorder = lpathElement.getFilterParamPath().size() - 1;
//            }
//        }
//  	    StgNodeIterator.setCheckIterationBorder(true);
//	    StgNodeIterator.setInitIterationBorder(iterDepthBorder);
//    }
}
