/*
 * Copyright 2004-2009 ISP RAS (http://www.ispras.ru), UniTESK Lab (http://www.unitesk.com)
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
/*
 * @@author <A href="mailto:maryn@@ispras.ru">Mary Naprasnikova</A>
 * @@version $Id: SemanticConstrViolation.java,v 1.1.1.1.2.4.2.1 2006/12/04 14:40:17 maryn Exp $
 */
package ru.ispras.redverst.stg.exceptions;

import java.util.List;

import ru.ispras.redverst.stg.base.BaseNode;

/**
 * @author Maryn
 *
 * throws   ,    ,   
 */
public class SemanticConstrViolation extends StgException 
{
   private BaseNode failedAddedNode = null;
   public SemanticConstrViolation()
   {
   	super();
   }
   
   public SemanticConstrViolation(String message)
   {
	super(message);
   }
   
   public SemanticConstrViolation(BaseNode causeNode)
   {
    super();
    this.failedAddedNode = causeNode;
   }
   
   public SemanticConstrViolation(List causeNode)
   {
    super();
    if (!((List)causeNode).isEmpty())
    {
        this.failedAddedNode = (BaseNode)((List)causeNode).get(0);    
    }    
   }   
   
   public BaseNode getFailedAddedNode()
   {
       return failedAddedNode;
   }   
}
