/*
 * Copyright 2004-2009 ISP RAS (http://www.ispras.ru), UniTESK Lab (http://www.unitesk.com)
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package ru.ispras.redverst.stg.global;

import java.io.File;
import java.io.FileWriter;
import java.io.IOException;

/**
 * @author maryn
 *
 * To change the template for this generated type comment go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
public class MavenProjectCreator
{

    /**
     * 
     */
    private MavenProjectCreator()
    {
        super();
        // TODO Auto-generated constructor stub
    }
    
    public static final String MAVEN_PROPERTIES = "maven.compile.source=1.5 \n maven.compile.target=1.5"; 
    private static int prj_counter = 0;
    public static String getMavenProjectText(String path)
    {
        path = ".";
        return "<?xml version=\"1.0\" encoding=\"ISO-8859-1\"?> <project> <pomVersion>3</pomVersion> <id>test" + prj_counter++ + "</id><build> <sourceDirectory>" + path + "</sourceDirectory> </build></project>";
    }
    public static boolean createMavenProject(String path)
    {
        try
        {
            File newProjectPath = new File(path);
            newProjectPath.mkdirs();
            
            FileWriter projectFileWriter = new FileWriter(new File(newProjectPath,"project.xml"));
            projectFileWriter.write(getMavenProjectText(path));
            projectFileWriter.close();
            
            FileWriter propertiesFileWriter = new FileWriter(new File(path,"project.properties"));
            propertiesFileWriter.write(MAVEN_PROPERTIES);
            propertiesFileWriter.close();
            return true;
        }
        catch (IOException e)
        {
            e.printStackTrace();
            return false;
        }
        
    }
}
