/*
 * Copyright 2004-2009 ISP RAS (http://www.ispras.ru), UniTESK Lab (http://www.unitesk.com)
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package ru.ispras.redverst.stg.iterators;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.Iterator;
import java.util.List;

import ru.ispras.redverst.iterator.DependIterator;
import ru.ispras.redverst.iterator.ListIterator;
import ru.ispras.redverst.iterator.OneObjectIterator;
import ru.ispras.redverst.iterator.ProductIterator;
import ru.ispras.redverst.iterator.ValueIterator;
import ru.ispras.redverst.stg.base.BaseNode;
import ru.ispras.redverst.stg.base.iterators.ArrayDependentIterator;
import ru.ispras.redverst.stg.base.iterators.STPairsBaseIterator;
import ru.ispras.redverst.stg.exceptions.TrgNotRelevantPathException;
import ru.ispras.redverst.stg.semobj.SemanticTree;
import ru.ispras.redverst.stg.semrel.EmptySemRelList;
import ru.ispras.redverst.stg.semrel.FullSemRelList;
import ru.ispras.redverst.stg.semrel.ManyToManySemanticRelation;
import ru.ispras.redverst.stg.semrel.MidRuleObj;
import ru.ispras.redverst.stg.semrel.SemanticRelation;
import ru.ispras.redverst.stg.semrel.SemanticRelationDescriptor;
import ru.ispras.redverst.stg.tdt.StartNode;

/**
 * @author maryn
 *
 * Iterate "source & target" pairs for semantic relations of type many-to-many
 */
public class MTMSTIterator extends STPairsBaseIterator
{
    protected List srcContextList;
    /**
     * @param semRelSet
     */
    public MTMSTIterator(List semRelSet, SemanticTree lsemTree, SemanticRelation lsr)
    {
        super(semRelSet, lsemTree, lsr);
        
        this.mainIterator = 
//        	new DependIterator
//			(
//        		new DependIterator
//			    (
                        new ListIterator(this.semRelSet);
//				        , new DependIterator.IteratorCreator()
//						{
//				            /* (non-Javadoc)
//				             * @see ru.ispras.redverst.iterator.DependIterator.IteratorCreator#create(java.lang.Object)
//				             */
//				            public ValueIterator create(Object arg)
//				            {
//				                SemanticRelation currSr = (SemanticRelation)arg;
////                                SemanticTree.waitingTargets.add(currSr.getTarget());
//                                if (currSr.getSrd().getContextDescriptor().isSingleContext())
//                                {
//                                    srcContextList = new ArrayList(Arrays.asList(currSr.getContext().getTrgContextRoot()));
//                                }
//                                else
//                                {
//    		                    	srcContextList = currSr.getSrd().getContextDescriptor().getFunctions().getSrcContextCandidates(semTree.getTree(), currSr.getSrd().getContextDescriptor().getSrcRootType(), currSr, semTree.getFullSemRelList());
//    		                    	List badSrcContext = new ArrayList();
//    		                    	for (Iterator iter = srcContextList.iterator(); iter.hasNext();) 
//    		                    	{
//    									BaseNode element = (BaseNode) iter.next();
//    									if (!currSr.getSrd().getContextDescriptor().getSrcContextPath().containsAtTheEnd(MidRuleObj.class, "target_context")
//    										&& element == currSr.getContext().getTrgContextRoot()) 
//    										{
//    										    //    	
//    											badSrcContext.add(element);
//    										}
//    								}
//    		                    	srcContextList.removeAll(badSrcContext);
//                                }
//		                        ListIterator srcContextIter = new ListIterator(srcContextList);
//		                        
//		                        OneObjectIterator srIter = new OneObjectIterator(currSr);
//		                        return new ProductIterator(new ValueIterator[]{srIter, srcContextIter});
//				            }
//				        }
//                  )
//        		, new DependIterator.IteratorCreator()
//				{
//		            /* (non-Javadoc)
//		             * @see ru.ispras.redverst.iterator.DependIterator.IteratorCreator#create(java.lang.Object)
//		             */
//		            public ValueIterator create(Object arg)
//		            {
//		                SemanticRelation currSr = (SemanticRelation)((Object[])((Object[])arg)[1])[0];
//		                BaseNode currSrcContext = (BaseNode)((Object[])((Object[])arg)[1])[1];
//		                SemanticRelation copySr = currSr.getCopy();
//		                List srcList = new ArrayList();
//						
//		                
//		                copySr.getContext().setSrcContextRoot(currSrcContext);
//	                	srcList = copySr.getSrd().getFunctions().getSrcCandidate(copySr.getContext().getSrcContextRoot(), new StartNode(copySr.getContext().getSrcContextRoot()), copySr.getSrd(), semTree.getFullSemRelList(), copySr);  
//		                ListIterator srcIter = new ListIterator(srcList);
//                        
//                        OneObjectIterator srIter = new OneObjectIterator(copySr);
//                        return new ProductIterator(new ValueIterator[]{srIter, srcIter});
//		            }
//		        }         		
//        	 );
    }
    
    /* (non-Javadoc)
     * @see ru.ispras.redverst.stg.base.iterators.STPairsBaseIterator#value()
     */
    /**
     * @return null if there is no appropriate pair "source and target"
     */
    public synchronized Object value()
    {
        SemanticRelation currSr = null;
        do
        {
            Object superRes = super.value();
            currSr = new ManyToManySemanticRelation((SemanticRelation)superRes, semTree);
            
            try
            {
//                BaseNode srcCand = (BaseNode) ((Object[]) superRes[superRes.length - 1])[1];
//
//                currSr.setSource(srcCand, null, semTree.getTree(), semTree);
//                if (currSr.getTarget() == srcCand
//                        || this.passedPairs.contains(new STPair(srcCand, currSr
//                                .getTarget()))
//                        || this.passedPairs.contains(new STPair(currSr
//                                .getTarget(), srcCand)))
//                {
//                    continue;
//                } 
//                else
                {
                    this.passedPairs.add(new STPair(currSr.getSource(), currSr.getTarget()));
                    boolean added = semTree.getFullSemRelList().add(currSr);
                    if(!added)
                    {
                        /*         
                         *       ,      
                         *    bkhm
                         */
                        List conflictingSemRelList = new ArrayList();
                        conflictingSemRelList.addAll(semTree.getFullSemRelList().getSemRelByTrg(currSr.getTarget()));
                        conflictingSemRelList.addAll(semTree.getFullSemRelList().getSemRelByTrg(currSr.getSource()));
                        conflictingSemRelList.addAll(semTree.getFullSemRelList().getSemRelBySrc(currSr.getTarget()));
                        conflictingSemRelList.addAll(semTree.getFullSemRelList().getSemRelBySrc(currSr.getSource()));
                        FullSemRelList conflictingFullSemRelList = new FullSemRelList(conflictingSemRelList, -1);
                        semTree.getFullSemRelList().removeAll(conflictingFullSemRelList);
//                        List renewTargetsList = new ArrayList();
                        for (Iterator iter = conflictingFullSemRelList.getSemList().iterator(); iter.hasNext();)
                        {
                            SemanticRelation semRel = (SemanticRelation) iter.next();
                            semTree.getSemRelList().addAll(new EmptySemRelList(semRel.getSrd().getDepSrdList(), -1));
//                            renewTargetsList.add(semRel.getTarget());
                        }
//                        semTree.getSemRelList().addAll(semTree.tdtTreeChanged(renewTargetsList, true, false));
//                        semTree.getSemRelList().addAll(new EmptySemRelList(conflictingFullSemRelList.getSRDList(), -1));
                        //  
                        semTree.getFullSemRelList().setBkhm(new FullSemRelList(semTree.getFullSemRelList().getSemList(), -1));
                    }
                    return currSr;
                }
            }
            finally
            {
                SemanticTree.removeWaitingTarget(currSr.getTarget());
            }
        }
        while (super.next());
//        return currSr;
    }    
}
