/*
 * Copyright 2004-2009 ISP RAS (http://www.ispras.ru), UniTESK Lab (http://www.unitesk.com)
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
/*
 * @@author <A href="mailto:maryn@@ispras.ru">Mary Naprasnikova</A>
 * @@version $Id: NodeIterator.java,v 1.1.1.1.2.3 2006/03/20 08:24:07 maryn Exp $
 */
package ru.ispras.redverst.stg.iterators;

import java.util.List;

import ru.ispras.redverst.iterator.ListIterator;
import ru.ispras.redverst.iterator.ValueIterator;

/**
 * @author Maryn
 */
public class NodeIterator implements ValueIterator
{
	/**
	 * 
	 */	
	private ListIterator nodeListIterator;
	private List/*NodeDecl*/ nodeList;
	public NodeIterator(List/*NodeDecl*/ nodeList )
	{
		super();
		this.nodeList = nodeList;
		this.nodeListIterator = new ListIterator(nodeList);
	}
	/* (non-Javadoc)
	 * @see ru.ispras.redverst.iterator.ValueIterator#init()
	 */
	public boolean init()
	{
		return this.nodeListIterator.init();		
	}
	/* (non-Javadoc)
	 * @see ru.ispras.redverst.iterator.ValueIterator#next()
	 */
	public boolean next()
	{		
		return this.nodeListIterator.next();
	}
	/* (non-Javadoc)
	 * @see ru.ispras.redverst.iterator.ValueIterator#value()
	 */
	public Object value()
	{		
		return this.nodeListIterator.value();
	}
	/**
	 * @return
	 */
	public List getNodeList()
	{
		return nodeList;
	}

	/**
	 * @param list
	 */
	public void setNodeList(List list)
	{
		nodeList = list;
		this.nodeListIterator = new ListIterator(nodeList);
	}
	
}
