/*
 * Copyright 2004-2009 ISP RAS (http://www.ispras.ru), UniTESK Lab (http://www.unitesk.com)
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
/*
 * @@author <A href="mailto:maryn@@ispras.ru">Mary Naprasnikova</A>
 * @@version $Id: NodeListIterator.java,v 1.1.2.1.2.1 2006/09/18 15:07:11 maryn Exp $
 */
package ru.ispras.redverst.stg.iterators;

import java.util.List;

import com.unitesk.atp.treedl.TDL.NodeDecl;

import ru.ispras.redverst.iterator.ListIterator;
import ru.ispras.redverst.iterator.ValueIterator;

/**
 * @author Maryn
 */
public class NodeListIterator implements ValueIterator
{
	/**
	 * 
	 */	
	private ListIterator nodeListIterator;
	private List/*NodeDecl*/ nodeList;
	public NodeListIterator(List/*NodeDecl*/ nodeList )
	{
		super();
		this.nodeList = nodeList;
		this.nodeListIterator = new ListIterator(nodeList);
	}
	/* (non-Javadoc)
	 * @see ru.ispras.redverst.iterator.ValueIterator#init()
	 */
    private static volatile int nodeCounter = 0;
	public boolean init()
	{
        boolean res = this.nodeListIterator.init();
        if (res)
        {
            System.out.println("Node " + ++nodeCounter + ((NodeDecl)this.value()).getName().getValue());
        }
        return res;
	}
	/* (non-Javadoc)
	 * @see ru.ispras.redverst.iterator.ValueIterator#next()
	 */
	public boolean next()
	{		
        boolean res = this.nodeListIterator.next();
        if (res)
        {
            System.out.println("Node " + ++nodeCounter + ((NodeDecl)this.value()).getName().getValue());
        }
        return res;
	}
	/* (non-Javadoc)
	 * @see ru.ispras.redverst.iterator.ValueIterator#value()
	 */
	public Object value()
	{		
		return this.nodeListIterator.value();
	}
	/**
	 * @return
	 */
	public List getNodeList()
	{
		return nodeList;
	}

	/**
	 * @param list
	 */
	public void setNodeList(List list)
	{
		nodeList = list;
		this.nodeListIterator = new ListIterator(nodeList);
	}
	
}
