/*
 * Copyright 2004-2009 ISP RAS (http://www.ispras.ru), UniTESK Lab (http://www.unitesk.com)
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
/*
 * @@author <A href="mailto:maryn@@ispras.ru">Mary Naprasnikova</A>
 * @@version $Id: SemanticRelationListIterator.java,v 1.1.1.1.2.3.2.1 2006/09/18 15:07:11 maryn Exp $
 */
package ru.ispras.redverst.stg.iterators;

import com.unitesk.atp.treedl.TDL.NodeDecl;

import ru.ispras.redverst.iterator.ListIterator;
import ru.ispras.redverst.iterator.ValueIterator;
import ru.ispras.redverst.stg.semrel.EmptySemRelList;
import ru.ispras.redverst.stg.semrel.SemanticRelationDescriptor;

/**
 * @author Maryn
 */
public class SemanticRelationListIterator implements ValueIterator
{
	/** 
	 * 
	 */
	private ListIterator semRelListIterator;
	private EmptySemRelList semRelList; 
	public SemanticRelationListIterator(EmptySemRelList semRelList)
	{
		super();
		this.semRelList = semRelList;
		this.semRelListIterator = new ListIterator(this.semRelList.getSemList());
	}
	/* (non-Javadoc)
	 * @see ru.ispras.redverst.iterator.ValueIterator#init()
	 */
    private static volatile int relCounter = 0;
	public boolean init()
	{				
		boolean res = this.semRelListIterator.init();
		if (res)
        {
            System.out.println("Relation decriptor " + ++relCounter + ((SemanticRelationDescriptor)this.value()).getId());
        }
		return res;		
	}
	/* (non-Javadoc)
	 * @see ru.ispras.redverst.iterator.ValueIterator#next()
	 */
	public boolean next()
	{	
        boolean res = this.semRelListIterator.next();
        if (res)
        {
            System.out.println("Relation decriptor " + ++relCounter + ((SemanticRelationDescriptor)this.value()).getId());
        }
        return res;     
	}
	/* (non-Javadoc)
	 * @see ru.ispras.redverst.iterator.ValueIterator#value()
	 */
	public Object value()
	{		
		return this.semRelListIterator.value();
	}
	/**
	 * @return
	 */
	public EmptySemRelList getSemRelList()
	{
		return semRelList;
	}

	/**
	 * @param list
	 */
	public void setSemRelList(EmptySemRelList list)
	{
		if (list != null) 
		{
			semRelList = list;
		} 
		else
		{
		    semRelList = new EmptySemRelList();
		}
		this.semRelListIterator = new ListIterator(semRelList.getSemList());
	}
	
}
