/*
 * Copyright 2004-2009 ISP RAS (http://www.ispras.ru), UniTESK Lab (http://www.unitesk.com)
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
/*
 * @@author <A href="mailto:maryn@@ispras.ru">Mary Naprasnikova</A>
 * @@version $Id: HorizontalSyntComb.java,v 1.1.1.1.2.2 2006/01/23 08:32:42 maryn Exp $
 */
package ru.ispras.redverst.stg.semobj;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;

import ru.ispras.redverst.stg.base.BaseNode;
import ru.ispras.redverst.stg.global.GlobalProperties;

/**
 * @author Maryn
 *
 * To change the template for this generated type comment go to
 * Window>Preferences>Java>Code Generation>Code and Comments
 */
public class HorizontalSyntComb extends SyntacticCombination {
     	
	/**
	 * @param type
	 * @param ancestorType
	 * @param descendentType
	 * @param irrelevantNodes
	 * @param relevantNodes
	 */
	public HorizontalSyntComb(  int type
							  , String parentType
							  , String[] irrelevantNodes
							  , String[] relevantNodes) 
	{
		super(
			type,
			parentType,
			"",
			irrelevantNodes!=null ? new ArrayList(Arrays.asList(irrelevantNodes)) : new ArrayList(0),
			relevantNodes!=null ? new ArrayList(Arrays.asList(relevantNodes)) : new ArrayList(0),
			1);		
	}	
	public HorizontalSyntComb(  int type
							  , String parentType
							  , List irrelevantNodes
							  , List relevantNodes) 
	{
		super(
			type,
			parentType,
			"",
			irrelevantNodes,
			relevantNodes,
			1);		
	}		
	/*public HorizontalSyntComb(  int type
					          , String parentType
							  , String[] irrelevantNodes
							  , String[] relevantNodes
							  , int depth) 
	{
		super(
			type,
			parentType,
			"",
		    irrelevantNodes!=null ? new ArrayList(Arrays.asList(irrelevantNodes)) : new ArrayList(0),
			relevantNodes!=null ? new ArrayList(Arrays.asList(relevantNodes)) : new ArrayList(0),
			depth);		
	}*/
	
	//-------------------------------------------------------------------------
	public boolean matchCombination(BaseNode currNode, BaseNode couplingPoint, BaseNode parent, int delta)
	{
		//as horizontal syntactic combination depends on direct parent and it's child this combination related to
		// then check if currNode has parent
		
		if (currNode.getParent()!=null) return this.combType==FORBIDDEN ? false : true;
		
		
		try
		{
			if (!Class.forName(GlobalProperties.LANG_TDT_MODEL_PACK_NAME + GlobalProperties.FULL_QUALIF_NAME_SEPAR + ancestorType).isInstance(parent))
			{
				return false; 
			} 
		}
		catch (ClassNotFoundException e) 
		{
			throw new IllegalArgumentException();
		}
		
		boolean res = false;
		
		// relevant nodes     parent   
		for (int i = 0; i < this.relevantNodes.size(); i++) 
		{
			if (this.depth == 1 ? parent.hasChild((String)this.relevantNodes.get(i)).isEmpty()
			: parent.hasDescen((String)this.relevantNodes.get(i), depth).isEmpty())
			 {
				//if even one is absent
				return false;
			 }
			else
			{
				// all should exist
				res = true;
				continue;
			}
		}
		
		if (this.irrelevantNodes.isEmpty())
		{
			//res = this.combType == MANDATORY ? true : false;
		    res = true;
		}		
        // irrelevant nodes     parent   
		for (int i = 0; i < this.irrelevantNodes.size(); i++) 
		{
			List irrelevantNodes = (  this.depth == 1 
			                        ? parent.hasChild ((String)this.irrelevantNodes.get(i))
			                        : parent.hasDescen((String)this.irrelevantNodes.get(i), depth)
			                       );
			if (!irrelevantNodes.isEmpty())
			{
				/*if (this.combType == MANDATORY)
				{
					// even if one exist
					return false;
				}
				else
				{
//					 for FORBIDDEN  at least one should exist
					return true;
				}*/
			    return false;
			}
			else
			{
				//res = this.combType == MANDATORY ? true : false;
			    res = true;
			}
		} 
		return res;
	}
}
