/*
 * Copyright 2004-2009 ISP RAS (http://www.ispras.ru), UniTESK Lab (http://www.unitesk.com)
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
/*
 * @@author <A href="mailto:maryn@@ispras.ru">Mary Naprasnikova</A>
 * @@version $Id: StgTypeDescriptor.java,v 1.1.1.1.2.2 2006/01/23 08:32:42 maryn Exp $
 */
package ru.ispras.redverst.stg.semobj;

import java.util.List;

/**
 * @author Maryn
 * 
 */
public interface StgTypeDescriptor 
{
	public void changeMap(Object key, Object value);

	public final String TYPE_NAME = "type_name"; 
/*    public final String CONST = "const";
	public final String REGISTER = "register";
	public final String VOLATILE = "volatile";*/
	public final String POINTER = "pointer";
	public final String ARRAY_FIX_LENGTH = "array_fix_length";
	public final String ARRAY_VAR_LENGTH = "array_var_length";
	public final String FUNCTION = "function";
	public final String LVALUE = "lvalue";
	public final String BITFIELD = "bitfield";
	public final String INCOMPLETE = "incomplete";
	public final String MODIF_LVALUE = "modif_lvalue";
    
//	***********************
	public void setModifLValue(boolean b);	    
//	***********************
	public void setIncomplete(boolean b);			
//	***********************
	public void setBitField(boolean b);		
//	***********************
	public void setLvalue(boolean b);    
//	***********************
    /**
     * set language dependent constant for example restrict, const, volatile 
     */
    public void setLangSpecifier(String langConst, boolean b);
//	***********************
    public void setArrayFixedLength(boolean b);
//	***********************    
	public void setArrayVarLength(boolean b);
//	***********************    
	public void setFunction(boolean b);
//	***********************
	public void setPointer(boolean b);	
//	***********************
    public boolean isIncomplete();
//	***********************
	public boolean isModifLValue();    
//	***********************
	public boolean isPointer();
//	***********************
	public boolean isLvalue();	
//	***********************
	public boolean isFunction();	    
//	***********************
	public boolean isArrayFixedLength();	
//	***********************
	public boolean isArrayVarLength();
//	***********************
	public boolean isBitField();			
//	***********************   
	public boolean isLangSpec(String langConst);	
//	***********************	
	public List getLangConstNameList();
//	***********************	
	public List getLangConstValueList();
//	***********************
    public boolean isEqual(StgTypeDescriptor newTypeDesc);
}
