/*
 * Copyright 2004-2009 ISP RAS (http://www.ispras.ru), UniTESK Lab (http://www.unitesk.com)
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
/*
 * @@author <A href="mailto:maryn@@ispras.ru">Mary Naprasnikova</A>
 * @@version $Id: AbstractSemRelList.java,v 1.5.2.4.2.4 2006/12/18 10:17:18 maryn Exp $
 */
package ru.ispras.redverst.stg.semrel;

import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;

import ru.ispras.redverst.stg.semobj.SemanticTree;



/**
 * Created on 14.07.2003
 * @author Maryn
 */
abstract public class AbstractSemRelList// implements List 
{    
    //     -  ,    
    protected SemanticTree semTree;
	protected List semList = new ArrayList(0); 
	//protected int mainRelNumber;
	protected boolean changed = false;
    
	/**
	 * @return
	 */
	public List getSemList() {
		return semList;
	}
//	public boolean addAll(AbstractSemRelList newList)
//	{
//		if (semList == null) semList = new ArrayList(0);
//		if (newList == null) return false;
//		
//		for (int i = 0; i < newList.size(); i++)
//		{
//			if (newList.semList.get(i) != null && this.containsSemRel(newList.semList.get(i)) < 0)
//			{
//				semList.add(newList.semList.get(i)/*.getCopy()*/);
//			}
//		}
//		return true;
//	}
	/**
	 * 
	 * @param semRel
	 * @return -1      
	 */
	public int containsSemRel(Object semRel)
	{
		for (int i = 0; i < this.size(); i++)
		{
			if (this.semList.get(i)== semRel)
			{
			   return i;					
			}		
		}
		return -1;	
	}	
       
	/**
	 * 
	 * @return
	 */
	public int size()
	{
		return semList==null ? 0 : semList.size();
	}
	/**
	 * 
	 * @return
	 */
	public boolean isEmpty()
	{
		return semList.isEmpty();
	}	
	
	/* (non-Javadoc)
     * @see java.lang.Object#equals(java.lang.Object)
     */
    public boolean equals(Object arg0)
    {
        if (arg0 instanceof AbstractSemRelList)
        {
            AbstractSemRelList newSemList = (AbstractSemRelList) arg0;
            if (this.semList.equals(newSemList.semList))
            {
                return true;
            }
        }
        return false;
    }
	/* (non-Javadoc)
	 * @see java.util.List#lastIndexOf(java.lang.Object)
	 */
	public int lastIndexOf(Object arg0) {
		// TODO Auto-generated method stub
		return semList.lastIndexOf(arg0);
	}
    protected List stateList = new ArrayList();
    public void saveState()
    {
        stateList.clear();
        for (Iterator iter = this.semList.iterator(); iter.hasNext();)
        {
            Object element = (Object) iter.next();
            if (element != null)
            {
                stateList.add(element);
            }
        }
        ((ArrayList)stateList).trimToSize();
    }	
    /**
     * 
     */
    public boolean isStateChanged()
    {
        List newList = new ArrayList();
        for (Iterator iter = this.semList.iterator(); iter.hasNext();)
        {
            Object element = (Object) iter.next();
            if (element != null)
            {
                newList.add(element);
            }
        }
        ((ArrayList)newList).trimToSize();
        return !newList.equals(stateList);
    }

}