/*
 * Copyright 2004-2009 ISP RAS (http://www.ispras.ru), UniTESK Lab (http://www.unitesk.com)
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package ru.ispras.redverst.stg.semrel;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;

import ru.ispras.redverst.stg.iterators.SemTreeIterator;
import ru.ispras.redverst.stg.semobj.SemanticTree;


public class BaseSemanticRelationDescriptor 
{
    private String id;
    private List/*String*/ contextDescList;
    SemanticRelationDescriptor srd;
    /**
     * 
     */
    public BaseSemanticRelationDescriptor()
    {

        // TODO Auto-generated constructor stub
    }
    public BaseSemanticRelationDescriptor(String id)
    {
        this.id = id;
    }    
    /**
    @roseuid 4221C03C029F
     */
    public BaseSemanticRelationDescriptor(String id, List contexts) 
    {
        this.id = id;
        this.contextDescList = contexts;
    }
    public BaseSemanticRelationDescriptor(String id, String[] contexts) 
    {
        this.id = id;
        this.contextDescList = new ArrayList(Arrays.asList(contexts));
    }
    
	public List getContextDescList()
	{
	    return contextDescList;
	}
	public void setContextDescList(List contextDescList)
	{
	    this.contextDescList = contextDescList;
	}
	public String getId()
	{
	    return id;
	}
	public void setId(String id)
	{
	    this.id = id;
	}
    public SemanticRelationDescriptor getSrd()
    {
        return srd;
    }
    public void setSrd(SemanticRelationDescriptor srd)
    {
        this.srd = srd;
    }
    /**
     * @param semRelList 
     * 
     */
    public SemanticRelationDescriptor getBaseSrd(EmptySemRelList semRelList)
    {
        List baseSrdList = semRelList.getById(id);
        
        return baseSrdList.isEmpty() ? null : (SemanticRelationDescriptor)baseSrdList.get(0);
    }
}
