/*
 * Copyright 2004-2009 ISP RAS (http://www.ispras.ru), UniTESK Lab (http://www.unitesk.com)
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package ru.ispras.redverst.stg.semrel;

import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;

import ru.ispras.redverst.stg.base.BaseNode;
import ru.ispras.redverst.stg.global.Messages;
import ru.ispras.redverst.stg.semobj.SemanticTree;
import ru.ispras.redverst.stg.tdt.StartNode;
import ru.ispras.redverst.stg.tdt.StgNodeDecl;
import ru.ispras.redverst.stg.tdt.StgTree;

/**
 * @@author maryn
 *
 * To change the template for this generated type comment go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
public class ListFieldElement extends FieldElement
{
    /**
     * 
     */
    public ListFieldElement()
    {
        super();
        // TODO Auto-generated constructor stub
    }

    /**
     * @@param name
     * @@param functions
     * @@param setPath
     */
    public ListFieldElement(String name, Functions functions, Path setPath, boolean buildable, String type)
    {
        super(name, functions, setPath, buildable, type);
        // TODO Auto-generated constructor stub
    }

    /* (non-Javadoc)
     * @@see ru.ispras.redverst.stg.semrel.PathElement#getType(java.lang.Object, ru.ispras.redverst.stg.semrel.FullSemRelList, ru.ispras.redverst.stg.tdt.StartNode)
     */
    public String getType(Object parent, FullSemRelList semRelList,
            StartNode tree)
    {
		if (parent instanceof BaseNode) 
		{
			BaseNode node = (BaseNode) parent;
			return StgNodeDecl.getFieldType(this.name, StgTree.getNodeDecl(node.getShortClassName(), SemanticTree.gramTree));	
		}
		else
		{
			throw new IllegalArgumentException(parent.getClass().toString() + " failed to be parent of " + this.name);
		}
    }
    /**
     * 
     */
//    public int size(Object currObj, SemanticRelation sr, FullSemRelList semRelList, StartNode tree)
//    {
//        List res = this.getObjects(currObj, -1, sr, semRelList, tree);
//        if (res.size() > 1)
//        {
//            throw new IllegalStateException(Messages.INTERNAL_ERROR + " more than 1 list elements " + this.name + " were found "); 
//        }
//        if (res.isEmpty())
//        {
//            return 0;
//        }
//        else 
//        {   
//            if (res.get(0) instanceof List) 
//	        {
//	            return ((List)res.get(0)).size();
//	        }
//            else 
//            {
//	            throw new IllegalStateException(Messages.INTERNAL_ERROR + " list element " + this.name + " doesn't refer to List object ");
//	        }
//        }
//    }
    /* (non-Javadoc)
     * @@see ru.ispras.redverst.stg.semrel.PathElement#getObjects(java.lang.Object, ru.ispras.redverst.stg.semrel.SemanticRelation, ru.ispras.redverst.stg.semrel.FullSemRelList, ru.ispras.redverst.stg.tdt.StartNode)
     */
//    public List getObjects(Object currObject, SemanticRelation sr,
//            FullSemRelList semRelList, StartNode tree)
//    {
//        List res = new ArrayList();
//        List listOfList = super.getObjects(currObject, sr, semRelList, tree);
//        for (Iterator iter = listOfList.iterator(); iter.hasNext();)
//        {
//            Object element = iter.next();
//            if (element instanceof List)
//            {
//                List listChild = (List) element;
//                res.addAll(listChild);
//            }
//            else 
//            {
//                throw new IllegalStateException(Messages.INTERNAL_ERROR + " child " + this.name + " doesn't refer to a list object");
//            }
//        }
//        return res;
//    }
    /* (non-Javadoc)
     * @@see ru.ispras.redverst.stg.semrel.PathElement#getObjects(java.lang.Object, ru.ispras.redverst.stg.semrel.SemanticRelation, ru.ispras.redverst.stg.semrel.FullSemRelList, ru.ispras.redverst.stg.tdt.StartNode)
     */
    public Object getObjects(int i, Object currObject, String currObjectType, SemanticRelation sr,
            FullSemRelList semRelList, StartNode tree)
    {
        if (i<0)
        {
            throw new IllegalArgumentException();
        }
        // TODO Auto-generated method stub
        List res = super.getObjects(currObject, currObjectType, sr, semRelList, tree);
        if (res.size() > 1)
        {
            throw new IllegalStateException(Messages.INTERNAL_ERROR + " more than 1 list elements " + this.name + " were found "); 
        }
        if (res.isEmpty())
        {
            return null;
        }
        else 
        {   
            if (res.get(0) instanceof List) 
	        {
	            if (i < ((List) res.get(0)).size())
                {
                    return ((List) res.get(0)).get(i);
                }
	            else
	            {
	                return null;
	            }
	        }
            else 
            {
	            throw new IllegalStateException(Messages.INTERNAL_ERROR + " list element " + this.name + " doesn't refer to List object ");
	        }
        }        
    }
}


