/*
 * Copyright 2004-2009 ISP RAS (http://www.ispras.ru), UniTESK Lab (http://www.unitesk.com)
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package ru.ispras.redverst.stg.semrel;

import ru.ispras.redverst.iterator.ListIterator;
import ru.ispras.redverst.iterator.ValueIterator;
import ru.ispras.redverst.stg.global.Messages;
import ru.ispras.redverst.stg.semobj.SemanticTree;
import ru.ispras.redverst.stg.tdt.StartNode;


/**
 * @author Arkhipovs
 *
 * TODO To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
public class MidRule extends PathElement {

	/**
	 * 
	 */
	public MidRule() {
		super();
		this.buildable = false;
		// TODO Auto-generated constructor stub
	}
   /* (non-Javadoc)
	 * @see ru.ispras.redverst.stg.semrel.PathElement#setBuildable(boolean)
	 */
	public void setBuildable(boolean buildable)
	{
	    // TODO Auto-generated method stub
	    super.setBuildable(false);
	}
	/**
	 * @param name
	 * @param functions
	 */
	public MidRule(String name, Functions functions, Path setPath, boolean buildable) {
		super(name, functions, setPath, buildable, "SemanticRelation");
		// TODO Auto-generated constructor stub
	}

	/* (non-Javadoc)
	 * @see ru.ispras.redverst.stg.semrel.PathElement#getType(ru.ispras.redverst.stg.base.BaseNode)
	 */
	public String getType(Object parent, FullSemRelList semRelList, StartNode tree) {
		// TODO Auto-generated method stub
		return "SemanticRelation";
	}
    public PathElement getCopy()
    {
        MidRule res = new MidRule(this.getName(), this.getFunctions(), this.getSetPath()!=null ? new Path(this.getSetPath()) : null, this.isBuildable());            
        return res;
    }
    
    public DescElement toDescElement()
    {
        return null;//new DescElement(this.type, null, null, true, 1, Integer.MAX_VALUE, DescElement.INFINITY);
    }
    
    /* (non-Javadoc)
     * @see ru.ispras.redverst.stg.semrel.PathElement#ElementTypeCompute(int, ru.ispras.redverst.stg.semrel.Path)
     */
    public void ElementTypeCompute(int i, Path path, SemanticRelationDescriptor srd, EmptySemRelList semRelList, int keyNode, Path parentPath)
    {        
    }
    
    /* (non-Javadoc)
     * @see ru.ispras.redverst.stg.semrel.PathElement#createNode(java.lang.Object, ru.ispras.redverst.stg.semobj.SemanticTree, ru.ispras.redverst.stg.semrel.SemanticRelation, ru.ispras.redverst.stg.semrel.FullSemRelList, ru.ispras.redverst.stg.tdt.StartNode)
     */
    public EmptySemRelList createNode(Object prevObj, SemanticTree semTree,
            SemanticRelation sr, FullSemRelList semRelList, StartNode tree)
    {
        throw new IllegalStateException("Failed to create node by path " + this.getParentPath().toString() + " of semantic relation " + sr.getSrd().getId() + ". Probably incorrect semantic rule description or base rule are not defined.");
    }
    public boolean equals(Object arg0)
    {
        if (arg0 instanceof MidRule)
        {
            MidRule pathElem = (MidRule) arg0;
            if (this.name.equals(pathElem.name))
            {
                if (this.name.equals("this"))
                {
                    return false;
                }
                if (this.name.equals("super"))
                {
                    //TODO     , 
                    return false; 
                }
                return true;
            }
        }
        return false;
    }
   
    public boolean equalsPathElementh(Object arg0)
    {
        if (arg0 instanceof MidRule)
        {
            MidRule anotherElem = (MidRule) arg0;
            return this.name.equals(anotherElem.name);    
        }
        return false;
    }    
    
    @Override
    public ValueIterator iteratorOfNew(Object prevObj, String prevObjType, SemanticRelation sr, FullSemRelList semRelList, StartNode tree)
    {
        return new ListIterator( this.getObjects(prevObj, prevObjType, sr, semRelList, tree));
    }
    @Override
    public void stopInnerIterators()
    {
        // TODO Auto-generated method stub
        
    }
}
