/*
 * Copyright 2004-2009 ISP RAS (http://www.ispras.ru), UniTESK Lab (http://www.unitesk.com)
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package ru.ispras.redverst.stg.semrel;

import java.util.List;

import ru.ispras.redverst.stg.base.BaseNode;
import ru.ispras.redverst.stg.semobj.SemanticTree;

public class SemanticAttributeDescriptor 
{
	public interface Functions 
	{
	    public List getAttributeCandidates(BaseNode node, SemanticRelation sr, SemanticTree semTree, SemanticAttributeDescriptor attr);
	}    
   private SemanticAttributeGroupDescriptor groupDescriptor = new SemanticAttributeGroupDescriptor();
   private String name = "";
   private String type = "";
   private ValueSet valueSet = new ValueSet();
   private StringBuffer getAttributeCode = new StringBuffer("");
   private Functions functions;
   private Path attrPath;
   /**
   @roseuid 4221C03A02DE
    */
   /**
 * 
 */
	public SemanticAttributeDescriptor()
	{
	
	    // TODO Auto-generated constructor stub
	}
   public SemanticAttributeDescriptor(String name, String type, Path path, ValueSet values, Functions functions) 
   {
       this.name = name;
       this.type = type;
       this.attrPath = path;
       if(values!=null)
       {
          this.valueSet =values;
          this.valueSet.setSad(this);
       }
       this.functions = functions;
   }
   
	public StringBuffer getGetAttributeCode()
	{
	    return getAttributeCode;
	}
	public void setGetAttributeCode(StringBuffer getAttributeCode)
	{
	    this.getAttributeCode = getAttributeCode;
	}
	public String getType()
	{
	    return type;
	}
	public void setType(String type)
	{
	    this.type = type;
	}
	public void addValue(Value newValue)
	{
	    this.valueSet.add(newValue);
	}
	public void addValue(ValueGroup newValueGrp)
	{
	    this.valueSet.add(newValueGrp);
	}	
	public ValueSet getValueSet()
	{
	    return valueSet;
	}
	public void setValueSet(ValueSet values)
	{
	    this.valueSet = values;
	}
	public SemanticAttributeGroupDescriptor getGroupDescriptor()
	{
	    return groupDescriptor;
	}
	public void setGroupDescriptor(SemanticAttributeGroupDescriptor groupDescriptor)
	{
	    this.groupDescriptor = groupDescriptor;
	}
	public Functions getFunctions()
	{
	    return functions;
	}
	public String getName()
	{
	    return name;
	}
	public void setName(String name)
	{
	    this.name = name;
	}
	
	/* (non-Javadoc)
     * @see java.lang.Object#equals(java.lang.Object)
     */
    public boolean equals(Object arg0)
    {
        if (arg0 instanceof SemanticAttributeDescriptor)
        {
            SemanticAttributeDescriptor semAttrDesc = (SemanticAttributeDescriptor) arg0;
            if (this.name.equals(semAttrDesc.name))
            {
                if (this.type.equals(semAttrDesc.type))
                {
                    if (this.valueSet.equals(semAttrDesc.valueSet))
                    {
//                        if (this.getAttributeCode.equals(semAttrDesc.getAttributeCode))
                        {
                            return true;
                        }
                    }
                }
            }
        }
        return false;
    }
	/**
	 * @return Returns the attrPath.
	 */
	public Path getAttrPath() {
		return attrPath;
	}
	/**
	 * @param attrPath The attrPath to set.
	 */
	public void setAttrPath(Path attrPath) {
		this.attrPath = attrPath;
	}
}
