/*
 * Copyright 2004-2009 ISP RAS (http://www.ispras.ru), UniTESK Lab (http://www.unitesk.com)
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package ru.ispras.redverst.stg.semrel;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.Iterator;
import java.util.List;

import ru.ispras.redverst.stg.base.BaseNode;
import ru.ispras.redverst.stg.semobj.SemanticTree;


public class SemanticAttributeGroupDescriptor 
{
    	private List /*SemanticAttributesDescriptor*/ semanticAttributesDescList = new ArrayList(0);
   
   		private SemanticAttributeSetDescriptor sasd;
   
		public SemanticAttributeSetDescriptor getSasd()
		{
		    return sasd;
		}
		public void setSasd(SemanticAttributeSetDescriptor sasd)
		{
		    this.sasd = sasd;
		}
	   /**
	   @roseuid 4221C03A01F4
	    */
	   public SemanticAttributeGroupDescriptor() 
	   {
	      this.semanticAttributesDescList = new ArrayList();
	   }
	   public SemanticAttributeGroupDescriptor(SemanticAttributeSetDescriptor srd, SemanticAttributeDescriptor[] attrs)
	   {
	      this.semanticAttributesDescList = new ArrayList(Arrays.asList(attrs));
	      this.sasd = srd;
	   }
	   public SemanticAttributeGroupDescriptor(SemanticAttributeDescriptor[] attrs)
	   {
	      this.semanticAttributesDescList = new ArrayList(Arrays.asList(attrs));
	      for (Iterator iter = semanticAttributesDescList.iterator(); iter.hasNext();)
	        {
	            SemanticAttributeDescriptor element = (SemanticAttributeDescriptor) iter.next();
	            element.setGroupDescriptor(this);
	        }
	   }   
	   public void addAttrDesc(SemanticAttributeDescriptor newAttrDesc) 
	   {
	       newAttrDesc.setGroupDescriptor(this);
	      this.semanticAttributesDescList.add(newAttrDesc);
	   }
		public List getSemanticAttributesDescList()
		{
		    return semanticAttributesDescList;
		}
		public void setSemanticAttributesDescList(List semanticAttributesDescList)
		{
		    this.semanticAttributesDescList = semanticAttributesDescList;
		}
	
		public SemanticAttributeGroup getAttributeCandidates(BaseNode node, SemanticRelation sr, SemanticTree semTree)
		{
		    SemanticAttributeGroup res = new SemanticAttributeGroup();
		    res.setSagd(this);
		    res.setSemRelation(sr);
		    for (Iterator iter = this.semanticAttributesDescList.iterator(); iter.hasNext();)
	        {
	            SemanticAttributeDescriptor element = (SemanticAttributeDescriptor) iter.next();
	            try 
				{
		            List attrCand = element.getFunctions().getAttributeCandidates(node, sr, semTree, element);
	                res.addAttribute(attrCand, element.getName(), node,element);
					
				} catch (NullPointerException e) {
					e.printStackTrace();
				}
                
	        }
		    return res;
		}
		/* (non-Javadoc)
	     * @see java.lang.Object#equals(java.lang.Object)
	     */
	    public boolean equals(Object arg0)
	    {
	        if (arg0 instanceof SemanticAttributeGroupDescriptor)
	        {
	            SemanticAttributeGroupDescriptor semAttrGrpDesc = (SemanticAttributeGroupDescriptor) arg0;
	            if (this.semanticAttributesDescList.equals(semAttrGrpDesc.semanticAttributesDescList))
	            {
	                return true;
	            }
	        }
	        return false;
	    }
//	    /**
//	     * 
//	     */
//	    public boolean hasValues()
//	    {
//	        for (Iterator iter = this.semanticAttributesDescList.iterator(); iter.hasNext();)
//	        {
//	            SemanticAttributeDescriptor attr = (SemanticAttributeDescriptor) iter.next();
//	            if (!attr.getValues().isEmpty())
//	            {
//	                return true;
//	            }
//	        }
//	        return false;
//	    }    	    
	    public void pathTypeCount(Path parent, EmptySemRelList semRelList)
	    {
		    for (Iterator iter = this.semanticAttributesDescList.iterator(); iter.hasNext();)
	        {
	            SemanticAttributeDescriptor element = (SemanticAttributeDescriptor) iter.next();
	            element.getAttrPath().pathElementTypeCompute(parent, element.getGroupDescriptor().getSasd().getSrd(), semRelList, BaseNode.ORDINARY);
	        }
	    }
}
