/*
 * Copyright 2004-2009 ISP RAS (http://www.ispras.ru), UniTESK Lab (http://www.unitesk.com)
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package ru.ispras.redverst.stg.semrel;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.Iterator;
import java.util.List;

import ru.ispras.redverst.stg.base.BaseNode;
import ru.ispras.redverst.stg.semobj.SemanticTree;


/**
 * @author maryn
 *
 * To change the template for this generated type comment go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
public class SemanticAttributeSetDescriptor
{
    private List/*SemanticAttributeGroupDesc*/ sadescGroupList = new ArrayList(0);
    private SemanticRelationDescriptor srd;
    
    public List getSadescGroupList()
    {
        return sadescGroupList;
    }
    public void setSadescGroupList(List sadescGroupList)
    {
        this.sadescGroupList = sadescGroupList;
    }
    /**
     * 
     */
    public SemanticAttributeSetDescriptor(List sadGroupList, SemanticRelationDescriptor srd)
    {
        super();
        this.sadescGroupList = sadGroupList;
        this.srd = srd;
    }
    public SemanticAttributeSetDescriptor(SemanticAttributeGroupDescriptor[] grpdesc)
    {
        this.sadescGroupList = grpdesc!=null ? new ArrayList(Arrays.asList(grpdesc)) : new ArrayList(0);
        for (Iterator iter = sadescGroupList.iterator(); iter.hasNext();)
        {
            SemanticAttributeGroupDescriptor element = (SemanticAttributeGroupDescriptor) iter.next();
            element.setSasd(this);
        }
    }
    /**
     * 
     */
    public SemanticAttributeSetDescriptor()
    {
        this.sadescGroupList = new ArrayList();
    }
    
    /**
     * 
     */
    public void add(SemanticAttributeGroupDescriptor sagd)
    {
        if (sagd == null) throw new IllegalArgumentException();
        this.sadescGroupList.add(sagd);
    }
    public void addAll(List list)
    {
        if (list == null) throw new IllegalArgumentException();
        this.sadescGroupList.addAll(list);
    }    
    public SemanticAttributeSet getAttributeCandidates(BaseNode node, SemanticRelation sr, SemanticTree semTree)
    {
          List attrGrpList = new ArrayList();
	      for (Iterator iter = this.sadescGroupList.iterator(); iter.hasNext();)
	      {
	          SemanticAttributeGroupDescriptor attrGroupDesc = (SemanticAttributeGroupDescriptor) iter.next();
	          attrGrpList.add(attrGroupDesc.getAttributeCandidates(node, sr, semTree));
	      }
	      return new SemanticAttributeSet(attrGrpList, sr, this);
    }
	public SemanticRelationDescriptor getSrd()
	{
	    return srd;
	}
	public void setSrd(SemanticRelationDescriptor srd)
	{
	    this.srd = srd;
	}  
	/* (non-Javadoc)
     * @see java.lang.Object#equals(java.lang.Object)
     */
    public boolean equals(Object arg0)
    {
        if (arg0 instanceof SemanticAttributeSetDescriptor)
        {
            SemanticAttributeSetDescriptor setDesc = (SemanticAttributeSetDescriptor) arg0;
            if (this.sadescGroupList.equals(setDesc.sadescGroupList))
            {
                return true;
            }
        }
        return false;
    }
	/**
     * 
     */
    public boolean isEmpty()
    {
        if (this.sadescGroupList == null)
        {
            return true;
        }
        return this.sadescGroupList.isEmpty();
    }    
//    /**
//     * 
//     */
//    public boolean hasValues()
//    {
//        for (Iterator iter = this.sadescGroupList.iterator(); iter.hasNext();)
//        {
//            SemanticAttributeGroupDescriptor grp = (SemanticAttributeGroupDescriptor) iter.next();
//            if (grp.hasValues())
//            {
//                return true;
//            }
//        }
//        return false;
//    }
    /**
     * @param semRelList TODO
     * 
     */
    public void pathTypeCount(Path parent, EmptySemRelList semRelList)
    {
	      for (Iterator iter = this.sadescGroupList.iterator(); iter.hasNext();)
	      {
	          SemanticAttributeGroupDescriptor attrGroupDesc = (SemanticAttributeGroupDescriptor) iter.next();
	          attrGroupDesc.pathTypeCount(parent, semRelList);
	      }
    }
}
