/*
 * Copyright 2004-2009 ISP RAS (http://www.ispras.ru), UniTESK Lab (http://www.unitesk.com)
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package ru.ispras.redverst.stg.semrel;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.Iterator;
import java.util.List;
import java.util.Map;
import java.util.Set;

import ru.ispras.redverst.stg.managers.MainGenerationCycle;
import ru.ispras.redverst.stg.tdt.DependentNode;

import com.unitesk.atp.treedl.TDL;
import com.unitesk.atp.treedl.TDL.NodeDecl;
import com.unitesk.atp.treedl.TDL.TreeDesc;

/**
 * @author Maryn
 *
 * To change the template for this generated type comment go to
 * Window>Preferences>Java>Code Generation>Code and Comments
 */
public class SemanticRelHashMap extends HashMap
{
    private int maxLevelNumber = -1;
	/**
	 * @param arg0
	 * @param arg1
	 */
	public static TreeDesc gramTree;
	/**
	 * 
	 */
	public SemanticRelHashMap(TreeDesc lgramTree)
	{
		super();	
		SemanticRelHashMap.gramTree = lgramTree;			
	}
	public SemanticRelHashMap(int arg0, float arg1, TreeDesc lgramTree)
	{
		super(arg0, arg1);		
		SemanticRelHashMap.gramTree = lgramTree;	
	}
	/**
	 * @param arg0
	 */
	public SemanticRelHashMap(int arg0, TreeDesc lgramTree)
	{
		super(arg0);
		SemanticRelHashMap.gramTree = lgramTree;		
	}
	/**
	 * @param arg0
	 */
	public SemanticRelHashMap(Map arg0, TreeDesc lgramTree)
	{
		super(arg0);		
		SemanticRelHashMap.gramTree = lgramTree;	
	}
	public EmptySemRelList getSemRelList(TDL.NodeDecl node)
	{
	    EmptySemRelList res = (EmptySemRelList)this.get(node);
		return res != null ? res : new EmptySemRelList();
	}
	public void print()
	{
	    Set keys = this.keySet();
	    for (Iterator iter = keys.iterator(); iter.hasNext();)
        {
            TDL.NodeDecl element = (TDL.NodeDecl) iter.next();
            MainGenerationCycle.STGLogger.info("Node " + element.getName().getValue());
            StringBuffer sb = new StringBuffer();
            ((EmptySemRelList)this.get(element)).print(sb);
            MainGenerationCycle.STGLogger.info(sb.toString());
        }
	}	
    public int getMaxLevelNumber()
    {
        return maxLevelNumber;
    }
    public void setMaxLevelNumber(int maxLevelNumber)
    {
        this.maxLevelNumber = maxLevelNumber;
    }
    /**
     * 
     */
    public List getSemRelDescByNodeId(String name)
    {
        for (Iterator iter = this.keySet().iterator(); iter.hasNext();)
        {
            NodeDecl node = (NodeDecl) iter.next();
            EmptySemRelList semRelList = (EmptySemRelList)this.get(node);
            return semRelList.getById(name);
        }
        return new ArrayList(0);
    }
    public SemanticRelationDescriptor getSemRelDescById(String name)
    {
        for (Iterator iter = this.values().iterator(); iter.hasNext();)
        {
            EmptySemRelList semrelList = (EmptySemRelList) iter.next();
            for (Iterator iterator = semrelList.getSemList().iterator(); iterator.hasNext();)
            {
                SemanticRelationDescriptor srd = (SemanticRelationDescriptor) iterator.next();
                if(srd.getId().equals(name))return srd;
            }
        }
        return null;
    }    
    
    public EmptySemRelList getAllDependentRelations()
    {
        EmptySemRelList res = new EmptySemRelList();
        
        for (int i = 0; i < maxLevelNumber; i++)
        {
            res.addAll((EmptySemRelList)this.get(new DependentNode(i)));
        }
        return res;
    }     
    /* (non-Javadoc)
     * @see java.util.HashMap#get(java.lang.Object)
     */
//    public Object get(Object arg0)
//    {
//        Object res = super.get(arg0);
//        return (res == null ? new EmptySemRelList() : res);
//    }
}
