/*
 * Copyright 2004-2009 ISP RAS (http://www.ispras.ru), UniTESK Lab (http://www.unitesk.com)
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package ru.ispras.redverst.stg.semrel;



import ru.ispras.redverst.stg.base.BaseNode;
import ru.ispras.redverst.stg.global.GlobalProperties;
import ru.ispras.redverst.stg.global.Messages;
import ru.ispras.redverst.stg.semobj.SemanticTree;
import ru.ispras.redverst.stg.tdt.StgTree;

import com.unitesk.atp.treedl.TDL.TreeDesc;


/**
 * Created on 21.07.2003
 * @author Maryn
 */
public abstract class SyntacticContext
{
	protected SyntacticContext()
	{
	}
	protected SyntacticContextDescriptor cdesc;
	
	public SyntacticContextDescriptor getCdesc()
	{
	    return cdesc;
	}
	public void setCdesc(SyntacticContextDescriptor cdesc)
	{
	    this.cdesc = cdesc;
	}		
	public abstract BaseNode getTrgContextRoot();
	public abstract BaseNode getSrcContextRoot();
	public abstract void setSrcContextRoot(BaseNode srcContextRoot);
	public abstract void setTrgContextRoot(BaseNode trgContextRoot);	
	public abstract void setSrcContextRoot(BaseNode srcContRoot, SemanticRelation sr, SemanticTree semTree);
	public abstract void setTrgContextRoot(BaseNode trgContRoot, SemanticRelation sr, SemanticTree semTree);
	
}