/*
 * Copyright 2004-2009 ISP RAS (http://www.ispras.ru), UniTESK Lab (http://www.unitesk.com)
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
//Source file: C:\\Program Files\\Rational\\Rose\\!generated\\ru\\ispras\\redverst\\stg\\semrel\\TypeDesc.java

package ru.ispras.redverst.stg.semrel;

import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;

import ru.ispras.redverst.stg.base.BaseNode;
import ru.ispras.redverst.stg.semobj.SemanticTree;
import ru.ispras.redverst.stg.tdt.StartNode;
import ru.ispras.redverst.stg.tdt.StgTree;


public abstract class TypeDesc extends BaseNode
{
	public interface TypeDescFunctions
	{
	    public List getTypeDescElements(StartNode tree, FullSemRelList semRelList); 
	}    
    
	private String id = "";
	private String constId = "";
    public TypeDescGroup tdgr;
	private TypeDescFunctions functions;	
	private String getTypeDescCode = "";
	private boolean isConstType = false;

    public boolean isConstType()
    {
        return isConstType;
    }
    public void setConstType(boolean isConstType)
    {
        this.isConstType = isConstType;
    }
   /**
   @roseuid 4221BFE602FD
    */
   public TypeDesc() 
   {
    this.id = this.getShortClassName();
   }
   public TypeDesc(String typeId, TypeDescFunctions functions, String constName) 
   {
    this.id = typeId;
    this.functions = functions;
    this.constId = constName;
   }

   public TypeDesc(TypeDesc typeDesc) 
   {
    this.id = typeDesc.id;
    this.functions = typeDesc.functions;
    this.constId = typeDesc.constId;
   }
   
   public TypeDesc(String typeId) 
   {
    this.id = typeId;
   }      
      
   /**
    * Return true if this corresponds to the type that is declared to the left and in the same type set 
    * as the parameter type   
   @param TypeDesc
   @return boolean
   @roseuid 42219DB90167
    */
   public boolean isCompatible(TypeDesc type, SemanticRelation sr, FullSemRelList semRelList, StartNode tree) 
   {
//       return this.tdgr.tsId.equals(type.tdgr.tsId);
       List setIdList = new ArrayList(SemanticTree.typeMap.keySet());
       for (int i = 0; i < setIdList.size(); i++)
	    {
//            try
            {
                String typeSetId = (String) setIdList.get(i);
                Object obj = SemanticTree.typeMap.get(typeSetId);
                if (obj instanceof TypeSet) 
                {
					if (((TypeSet)obj).contains(type) && ((TypeSet)obj).contains(this)
							&& this.isLess(type, sr, semRelList, tree)) 
					{
						return true;
					}
				}
    	        if (obj instanceof TypeSetFamily) 
    	        {
    				TypeSetFamily setFamily = (TypeSetFamily) obj;
    				List typeSetList = setFamily.getTypeSetList(tree.getStartNode(), StgTree.getGramTreeStartNode(), sr, semRelList, tree);
    				for (int j = 0; j < typeSetList.size(); j++) 
    				{
    					if (((TypeSet)typeSetList.get(j)).contains(type) && ((TypeSet)typeSetList.get(j)).contains(this)) 
    					{
    						return true;
    					}
    				}
    			}                
            }
//            catch (Exception e)
//            {
//                e.printStackTrace();
//            }
	    }
       return false;
   }
   
   /**
	 * 
	 */
	public boolean isLess(TypeDesc type, SemanticRelation sr, FullSemRelList semRelList, StartNode tree)
	{
	   // if (this.isCompatible(type, sr, semRelList, tree))
	    {
	        return this.getTypeNum(sr, semRelList, tree)<=type.getTypeNum(sr, semRelList, tree);
	    }
	   // return false;
	}
   public boolean isEqual(TypeDesc type, SemanticRelation sr, FullSemRelList semRelList, StartNode tree)
   {
//       return this.tdgr.equals(type.tdgr);
        for (Iterator iter = SemanticTree.typeMap.keySet().iterator(); iter.hasNext();)
	    {
	        Object	obj =  iter.next();
	        if (obj instanceof TypeSet) 
	        {
	        	TypeSet set = (TypeSet)obj;
				if (set.contains(this) && set.contains(type)) 
				{
					return set.getTypeDescGroup(this).equals(
							set.getTypeDescGroup(type));
				}
			}
	        if (obj instanceof TypeSetFamily) 
	        {
				TypeSetFamily setFamily = (TypeSetFamily) obj;
				List typeSetList = setFamily.getTypeSetList(tree.getStartNode(), StgTree.getGramTreeStartNode(), sr, semRelList, tree);
				for (int j = 0; j < typeSetList.size(); j++) 
				{
					if (((TypeSet)typeSetList.get(j)).contains(type) && ((TypeSet)typeSetList.get(j)).contains(this)) 
					{
						return true;
					}
				}
			}     	        
	    }	  
        return false;
   }
   /**
	 * 
	 */
	public int getTypeNum(SemanticRelation sr, FullSemRelList semRelList, StartNode tree)
	{
//	    return this.tdgr.getTypeNum(this);
       for (Iterator iter = SemanticTree.typeMap.keySet().iterator(); iter.hasNext();)
	    {
	        String	setId = (String) iter.next();
	        Object obj = SemanticTree.typeMap.get(setId);
	        if (obj instanceof TypeSet) 
	        {
				TypeSet set = (TypeSet) obj;
				if (set.contains(this)) 
				{
					return set.getTypeNum(this);
				}
			}
	        if (obj instanceof TypeSetFamily) 
	        {
				TypeSetFamily setFamily = (TypeSetFamily) obj;
				List typeSetList = setFamily.getTypeSetList(tree.getStartNode(), StgTree.getGramTreeStartNode(), sr, semRelList, tree);
				for (int i = 0; i < typeSetList.size(); i++) 
				{
					if (((TypeSet)typeSetList.get(i)).contains(this)) 
					{
						return ((TypeSet)typeSetList.get(i)).getTypeNum(this);
					}
				}
			}
	    }	  
       return -1;
	}
	public String getId()
	{
	    return id;
	}
	public void setId(String id)
	{
	    this.id = id;
	}
	public TypeDescGroup getTdgr()
	{
	    return tdgr;
	}
	public void setTdgr(TypeDescGroup tdgr)
	{
	    this.tdgr = tdgr;
	}

    public String getGetTypeDescCode()
    {
        return getTypeDescCode;
    }
    public void setGetTypeDescCode(String getTypeDescCode)
    {
        this.getTypeDescCode = getTypeDescCode;
    }
    public TypeDescFunctions getFunctions()
    {
        return functions;
    }
    public void setFunctions(TypeDescFunctions functions)
    {
        this.functions = functions;
    }
    /* (non-Javadoc)
     * @see java.lang.Object#equals(java.lang.Object)
     */
    public boolean equals(Object arg0)
    {
        if (arg0 instanceof TypeDesc)
        {
            TypeDesc typeDesc = (TypeDesc) arg0;
            if(this.id.equals(typeDesc.id))
            {
                if(this.getTypeDescCode.equals(typeDesc.getTypeDescCode))
                {
                    return true;
                }
            }
        }
        return false;
    }
    public String getConstId()
    {
        return constId;
    }
    public void setConstId(String constId)
    {
        this.constId = constId;
    }
}
