/*
 * Copyright 2004-2009 ISP RAS (http://www.ispras.ru), UniTESK Lab (http://www.unitesk.com)
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package ru.ispras.redverst.stg.semrel;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.Iterator;
import java.util.List;


public class TypeDescGroup 
{
   public static int typeDescGroupCount = 0;
   private int id;
   private List/*TypeDesc*/ types = new ArrayList(0);
   public TypeSet tsId;
   
	public int getId()
	{
	    return id;
	}
	public void setId(int id)
	{
	    this.id = id;
	}
	public List getTypes()
	{
	    return types;
	}
	public void setTypes(List types)
	{
	    this.types = types;
	}
   
   	/**
    	@roseuid 4221C0200290
    */
   	public TypeDescGroup() 
   	{
	    types = new ArrayList();
	    id = typeDescGroupCount++;
   	}
   	public TypeDescGroup(TypeDesc typeDesc, TypeSet tsId) 
   	{
	    this();
	    this.types.add(typeDesc);
	    typeDesc.setTdgr(this);
	    this.tsId = tsId;
   	}
   	public TypeDescGroup(TypeDesc[] types) 
   	{
	    this.types = new ArrayList(Arrays.asList(types));
	    id = typeDescGroupCount++;
        for (int i = 0; i < types.length; i++)
        {
            TypeDesc typeDesc = types[i];
            typeDesc.setTdgr(this);
        }
    }   
	public TypeSet getTsId()
	{
	    return tsId;
	}
	public void setTsId(TypeSet tsId)
	{
	    this.tsId = tsId;
	}
	/**
     * 
     */
    public int getTypeNum(TypeDesc type)
    {
        return this.tsId.getTypeNum(type);
    }	
    
    /**
     * 
     */
    public void addTypeDesc(TypeDesc type)
    {
        this.types.add(type);
        type.setTdgr(this);
    }
    /* (non-Javadoc)
     * @see java.lang.Object#equals(java.lang.Object)
     */
    public boolean equals(Object arg0)
    {
        if (arg0 instanceof TypeDescGroup)
        {
            TypeDescGroup typeDescGrp = (TypeDescGroup) arg0;
            if(this.id == typeDescGrp.id)
            {
                if(this.types.equals(typeDescGrp.types))
                {
                    return true;
                }
            }
        }
        return false;    
    }
    /**
     * 
     */
    public boolean contains(TypeDesc type)
    {
        return this.types.contains(type);
    }
	public boolean isEmpty() 
	{
		return this.types.isEmpty();
	}    
}
