/*
 * Copyright 2004-2009 ISP RAS (http://www.ispras.ru), UniTESK Lab (http://www.unitesk.com)
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package ru.ispras.redverst.stg.semrel;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.Iterator;
import java.util.List;

import ru.ispras.redverst.stg.base.BaseNode;
import ru.ispras.redverst.stg.tdt.StartNode;
import ru.ispras.redverst.stg.types.TypeSetMap;


public class TypeSet//extends TypeSetFamily
{
   private String id = "";
   private int name;
   private List/*TypeDescGroup*/ types = new ArrayList(0);
   private Path path;
   /**
   @roseuid 4221C0200213
    */
   public TypeSet() 
   {
    
   }
   public TypeSet(String id, TypeDescGroup[] grp) 
   {
   		this.id = id;
   		this.types = new ArrayList(Arrays.asList(grp));
   		for (Iterator iter = getTypes().iterator(); iter.hasNext();) {
			TypeDescGroup typeGrp = (TypeDescGroup) iter.next();
			typeGrp.setTsId(this);
		}
   }   
   /**
	   @param Object obj
	   @return boolean
	   @roseuid 4221DF2201C5
    */
    public boolean contains(TypeDesc obj) 
    { 
//        TypeDesc type = (TypeDesc) obj;
//        for (Iterator iter = this.getTypes().iterator(); iter.hasNext();)
//	    {
//	        TypeDescGroup grp = (TypeDescGroup) iter.next();
//	        if (grp.contains(obj))
//	        {
//	            return true;
//	        }
//	    }
//	    return false;
        return getTypes().indexOf(getTypeDescGroup(obj))>=0;
    }
	public String getId()
	{
	    return id;
	}
	public void setId(String id)
	{
	    this.id = id;
	}
	public List getTypes()
	{
		return types;
	}
	public void setTypes(List types)
	{
	    for (Iterator iter = getTypes().iterator(); iter.hasNext();)
        {
            TypeDescGroup grp = (TypeDescGroup) iter.next();
            grp.setTsId(this);
        }
	    this.types = types;
	}
	/**
     * 
     */
    public int getTypeNum(TypeDesc type)
    {
        return getTypes().indexOf(getTypeDescGroup(type));
    }
    /**
     * 
     */
    public TypeDescGroup getTypeDescGroup(TypeDesc type	)
    {
        for (Iterator iter = this.getTypes().iterator(); iter.hasNext();)
        {
            TypeDescGroup grp = (TypeDescGroup) iter.next();
            if (grp.contains(type))
            {
                return grp;
            }
        }
        return null;
    }
    /**
	 * 
	 */
	public static boolean isOfType(TypeSetMap typeMap, String typeSetId, BaseNode obj) 
	{
		TypeSet typeSet = typeMap.getTypeSet(typeSetId);
		for (Iterator iter = typeSet.getTypes().iterator(); iter.hasNext();) {
			TypeDescGroup typeGrp = (TypeDescGroup) iter.next();
			for (Iterator iterator = typeGrp.getTypes().iterator(); iterator.hasNext();) {
				TypeDesc typeDesc = (TypeDesc) iterator.next();
				if (obj.getAttribute("type").equals(typeDesc.getId())) return true;
			}
		}
		return false;
	}
	/* (non-Javadoc)
     * @see java.lang.Object#equals(java.lang.Object)
     */
    public boolean equals(Object arg0)
    {
        if (arg0 instanceof TypeSet)
        {
            TypeSet typeSet = (TypeSet) arg0;
            if(this.id.equals(typeSet.id))
            {
                if(this.name == typeSet.name)
                {
                    if (this.getTypes().equals(typeSet.types))
                    {
                        return true;
                    }
                }
            }
        }
        return false;
    }
    /**
	 * 
	 */
	public boolean isEmpty() 
	{
		for (Iterator iter = this.getTypes().iterator(); iter.hasNext();) {
			TypeDescGroup tdg = (TypeDescGroup) iter.next();
			if (!tdg.isEmpty()) 
			{
				return false;
			}
		}
		return true;
	}
	/**
	 * @return Returns the path.
	 */
	public Path getPath() {
		return path;
	}
	/**
	 * @param path The path to set.
	 */
	public void setPath(Path path) {
		this.path = path;
	}
}
