/*
 * Copyright 2004-2009 ISP RAS (http://www.ispras.ru), UniTESK Lab (http://www.unitesk.com)
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package ru.ispras.redverst.stg.semrel;

import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;

import ru.ispras.redverst.iterator.ValueIterator;
import ru.ispras.redverst.stg.exceptions.SemanticFormalizationException;
import ru.ispras.redverst.stg.tdt.StartNode;

/**
 * @author 
 *
 * TODO To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
public class TypeSetFamily 
{
	private String id = "";
	protected Path path = new Path();
	List/*TypeSet*/ typeSetList = new ArrayList(0);
	/**
	 * 
	 */
	/**
	 * 
	 */
	public TypeSetFamily() {

		// TODO Auto-generated constructor stub
	}
	public TypeSetFamily(String id, Path p) 
	{
		super();
		this.id = id;
		this.path = p;
	}
	/**
	 * @return Returns the path.
	 */
	public Path getPath() {
		return path;
	}
	/**
	 * @param path The path to set.
	 */
	public void setPath(Path path) {
		this.path = path;
	}   		   
	
	/**
	 * @return Returns the id.
	 */
	public String getId() {
		return id;
	}
	/**
	 * @param id The id to set.
	 */
	public void setId(String id) {
		this.id = id;
	}
	/**
	 * @return Returns the typeSetList.
	 */
	public List getTypeSetList(Object prevObj, String prevObjType, SemanticRelation sr, FullSemRelList semRelList, StartNode tree) 
	{
        List resList = new ArrayList(0);
        int count = 0;
        ValueIterator iter = this.path.iterator(prevObj, prevObjType, sr, semRelList, tree);
        if (iter!=null) 
        {
			boolean flag = iter.init();
			while (flag) 
            {
				List typeDescList = (List) iter.value();
                try
                {
                    resList.add(new TypeSet(this.id + count++, new TypeDescGroup[] { new TypeDescGroup( (TypeDesc[])typeDescList.toArray(new TypeDesc[]{}))}));                   
                    
                } catch (ClassCastException e)
                {
                    throw new SemanticFormalizationException("Incorrect description of type set " + this.getId());
                }
				flag = iter.next();
			}
		}
		return resList;
//        List currTypeSetObjList = new ArrayList(0);
//        
//        if (prevObj != null)
//        {
//            currTypeSetObjList.add(prevObj);
//        }
//        else
//        {
//        	currTypeSetObjList.addAll(((PathElement) this.path.getPathElementList().get(0)).getObjects(prevObj, sr, semRelList, tree));
//        }
//        for (int j = prevObj != null ? 0 : 1; j< this.path.getPathElementList().size(); j++)
//        {
//            PathElement pathElement = (PathElement) this.path.getPathElementList().get(j);//iter.next();
//            if (!(pathElement instanceof RecurSet)) 
//            {
//                for (int i = 0; i < currTypeSetObjList.size(); i++)
//                {
//                    resList.addAll(pathElement.getObjects(currTypeSetObjList.get(i), sr, semRelList, tree));    
//                }
//                currTypeSetObjList = resList;
//                resList = new ArrayList(0);                
//			}
//            else
//            {
//            	if (pathElement instanceof RecurSet && currTypeSetObjList.size()>1)
//            	{
//            		
//            	}
//            }
//        }
//        return currTypeSetObjList;	 
	}
}
