/*
 * Copyright 2004-2009 ISP RAS (http://www.ispras.ru), UniTESK Lab (http://www.unitesk.com)
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package ru.ispras.redverst.stg.semrel;

import java.util.List;

import ru.ispras.redverst.stg.base.BaseNode;

public class Value
{
   private String value;
   private boolean wrong = false;
   private SemanticAttributeDescriptor sad;
   private ValueGroup grp;
   private StringBuffer getValueCode = new StringBuffer("");
   private Functions functions;
   private String type;
      
	/**
	 * @return Returns the type.
	 */
	public String getType() {
		return type;
	}
	/**
	 * @param type The type to set.
	 */
	public void setType(String type) {
		this.type = type;
	}
	public ValueGroup getGrp()
	{
	    return grp;
	}
	public void setGrp(ValueGroup grp)
	{
	    this.grp = grp;
	}

	public interface Functions
	{
	    public List getValues(BaseNode attr);
	}
       
   /**
   @roseuid 4224573402CE
    */
	public Value()
	{
	
	    // TODO Auto-generated constructor stub
	}
   public Value(String type, String value, boolean wrong, Functions functions) 
   {
       this.type = type;
       this.value = value;
       this.wrong = wrong;
       this.functions = functions;
   }
	public boolean isWrong()
	{
	    return wrong;
	}
	public void setWrong(boolean wrong)
	{
	    this.wrong = wrong;
	}
	public String getValue()
	{
	    return value;
	}
	public void setValue(String value)
	{
	    this.value = value;
	}
	public SemanticAttributeDescriptor getSad()
	{
	    return sad;
	}
	public void setSad(SemanticAttributeDescriptor sad)
	{
	    this.sad = sad;
	}
	/* (non-Javadoc)
	 * @see java.lang.Object#equals(java.lang.Object)
	 */
	public boolean equals(Object arg0)
	{
	    if (arg0 instanceof Value)
        {
            Value lvalue = (Value) arg0;
            if (this.value.equals(lvalue.value))
            {
                if (this.wrong == lvalue.wrong)
                {
                    return true;
                }
            }
        }
	    return false;
	}	
	
	public Functions getFunctions()
	{
	    return functions;
	}
	public void setFunctions(Functions functions)
	{
	    this.functions = functions;
	}
	public StringBuffer getGetValueCode()
	{
	    return getValueCode;
	}
	public void setGetValueCode(StringBuffer getValueCode)
	{
	    this.getValueCode = getValueCode;
	}
}
