/*
 * Copyright 2004-2009 ISP RAS (http://www.ispras.ru), UniTESK Lab (http://www.unitesk.com)
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package ru.ispras.redverst.stg.semrel;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.Iterator;
import java.util.List;

import ru.ispras.redverst.stg.base.BaseNode;

/**
 * @author maryn
 *
 * To change the template for this generated type comment go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
public class ValueGroup
{
    private ValueSet vs;
    private boolean wrong = false;
    private String type = "";
	/**
	 * @return Returns the type.
	 */
	public String getType() {
//	    if (this.getValues().size()<=0)return new String("");
		return this.type;//type;
	}
	/**
	 * @return Returns the wrong.
	 */
	public boolean isWrong() 
	{
		if (this.getValues().size()<=0) return false;
	    return ((Value)this.getValues().get(0)).isWrong();
	}
    private List/*Value*/ values = new ArrayList(0);
    
    /**
	 * 
	 */
	public ValueGroup() 
	{
		// TODO Auto-generated constructor stub
	}
    /**
     * 
     */
    public ValueGroup(Value[] values)
    {
        super();
        this.values = new ArrayList(Arrays.asList(values));
        for (Iterator iter = this.values.iterator(); iter.hasNext();) {
			Value value = (Value) iter.next();
			value.setGrp(this);
            if (value.isWrong())
            {
                this.wrong = value.isWrong();
            }
		}
    }
    
    public List getValues()
    {
        return values;
    }
    public void setValues(List values)
    {
        this.values = values;
    }
    public ValueSet getVs()
    {
        return vs;
    }
    public void setVs(ValueSet vs)
    {
        this.vs = vs;
    }
    /* (non-Javadoc)
     * @see java.lang.Object#equals(java.lang.Object)
     */
    public boolean equals(Object arg0)
    {
        if (arg0 instanceof ValueGroup)
        {
            ValueGroup grp = (ValueGroup) arg0;
            if (this.values.equals(grp.values))
            {
                return true;
            }
        }
        return false;
    }
    /**
	 * 
	 */
	public void add(Value newvalue) 
	{
		this.values.add(newvalue);
		newvalue.setGrp(this);
	}
	/**
	 * 
	 */
	public void setType(String type) 
	{
		this.type = type;
		for (Iterator iter = this.values.iterator(); iter.hasNext();) {
			Value value = (Value) iter.next();
			value.setType(type);
		}
	}
	/**
	 * 
	 * @param wrong
	 */
	public void setWrong(boolean wrong) 
	{
		this.wrong = wrong;
		for (Iterator iter = this.values.iterator(); iter.hasNext();) {
			Value value = (Value) iter.next();
			value.setWrong(wrong);
		}
	}	
	/**
	 * 
	 */
	public List getValueObjects(BaseNode attr) 
	{
		List res = new ArrayList(0);
		for (Iterator iter = this.values.iterator(); iter.hasNext();) 
		{
			Value value = (Value) iter.next();
			res.addAll(value.getFunctions().getValues(attr));
		}
		return res;
	}
	/**
	 * 
	 */
	public boolean isEmpty() 
	{
		return this.values.isEmpty();
	}
}
