/*
 * Copyright 2004-2009 ISP RAS (http://www.ispras.ru), UniTESK Lab (http://www.unitesk.com)
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package ru.ispras.redverst.stg.tdt;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;
import java.util.Properties;

import com.unitesk.atp.text.location.Position;
import com.unitesk.atp.tree.tool.antlr.LinkedToken;
import com.unitesk.atp.treedl.TDL;
import com.unitesk.atp.treedl.TDL.ID;
import com.unitesk.atp.treedl.TDL.NodeDecl;
import com.unitesk.atp.treedl.TDL.NodeID;

/**
 * @author maryn
 *
 * To change the template for this generated type comment go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
public class DependentNode extends NodeDecl
{
    private int level = 1; // 0-independent always 
    
    /**
     * 
     */
    public DependentNode(int level)
    {
        super("DependentNode", new Properties(), false, new TDL.ID(new Position(), "", new LinkedToken()), new TDL.NodeID(new TDL.ID(new Position(), "", new LinkedToken()), new TDL.ID(new Position(), "", new LinkedToken())), new ArrayList(), new ArrayList());
        this.level = level;
    }
    /**
     * @param arg0
     * @param arg1
     * @param arg2
     * @param arg3
     * @param arg4
     * @param arg5
     * @param arg6
     */
    public DependentNode(String arg0, Properties arg1, boolean arg2, ID arg3,
            NodeID arg4, List arg5, List arg6)
    {
        super(arg0, arg1, arg2, arg3, arg4, arg5, arg6);
        // TODO Auto-generated constructor stub
    }
    
    public int getLevel()
    {
        return level;
    }
    public void setLevel(int level)
    {
        this.level = level;
    }
    /* (non-Javadoc)
     * @see java.lang.Object#equals(java.lang.Object)
     */
    public boolean equals(Object arg0)
    {
        if (arg0 instanceof DependentNode)
        {
            DependentNode depNode = (DependentNode) arg0;
            return this.level == depNode.level;
        }
        return false;
    }
}
