/*
 * Copyright 2004-2009 ISP RAS (http://www.ispras.ru), UniTESK Lab (http://www.unitesk.com)
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package ru.ispras.redverst.stg.tdt;

import ru.ispras.redverst.stg.base.BaseNode;


/**
 * @author Maryn
 *
 * keep position of node in tree specified by parent name and attribute name 
 */
public class NodePosition
{
	private BaseNode node;
	private String attrName;
	public NodePosition(BaseNode parent, String attrName)
	{
		super();
		this.node = parent;
		this.attrName = attrName;
	}
	/**
	 * @return
	 */
	public String getAttrName()
	{
		return attrName;
	}

	/**
	 * @return
	 */
	public BaseNode getNode()
	{
		return node;
	}

	/**
	 * @param string
	 */
	public void setAttrName(String string)
	{
		attrName = string;
	}

	/**
	 * @param node
	 */
	public void setNode(BaseNode node)
	{
		this.node = node;
	}

}
