/*
 * Copyright 2004-2009 ISP RAS (http://www.ispras.ru), UniTESK Lab (http://www.unitesk.com)
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
/*
 * @@author <A href="mailto:maryn@@ispras.ru">Mary Naprasnikova</A>
 * @@version $Id: StgNodeDecl.java,v 1.7.2.11.2.5 2006/10/10 07:43:16 maryn Exp $
 */
package ru.ispras.redverst.stg.tdt;import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;

import ru.ispras.redverst.stg.global.Messages;
import ru.ispras.redverst.stg.managers.MainGenerationCycle;
import ru.ispras.redverst.stg.semrel.SemanticRelHashMap;
import ru.ispras.redverst.stg.utils.Utils;

import com.unitesk.atp.tree.Node;
import com.unitesk.atp.treedl.TDL;
import com.unitesk.atp.treedl.TDL.Child;
import com.unitesk.atp.treedl.TDL.Field;
import com.unitesk.atp.treedl.TDL.FieldDescriptor;
import com.unitesk.atp.treedl.TDL.Member;
import com.unitesk.atp.treedl.TDL.NodeDecl;
import com.unitesk.atp.treedl.TDL.NodeType;
import com.unitesk.atp.treedl.TDL.TreeDesc;


/**
 * @author Maryn
 * 
 * NodeDecl     Stg
 */
public class StgNodeDecl //extends NodeDecl 
{
	//private static TdtCopyLateVisitor copier = new TdtCopyLateVisitor();
//	private NodeDecl node;
//	-------------------------------------------------------------------------
/*	public  StgNodeDecl(NodeDecl node)
	{
		super(node.getOptDocomment()
			, node.getIsAbstract()
			, (ID)copier.copy(node.getName())
			, (ID)copier.copy(node.getOptParentName())
			, copier.copyList(node.getOptInterfaceList())
			, copier.copyList(node.getOptMemberList())); 

		if(node.getOptParentNode()!=null)this.setOptParentNode(node.getOptParentNode());		
		if(node.getOptFieldList()!=null)this.setOptFieldList(node.getOptFieldList());		
		if(node.getParent()!=null)this.setParent(node.getParent());	
		
		this.node = node;
	}*/
	
//	-------------------------------------------------------------------------
/*    public  StgNodeDecl(String optDocomment, boolean isAbstract, ID name, ID optParentName, List optInterfaceList, List optMemberList)
    {
    	super(optDocomment
    	    , isAbstract
    	    , name
    	    , optParentName
    	    , optInterfaceList
    	    , optMemberList);
    	    
		node = new NodeDecl(optDocomment
							, isAbstract
							, (ID)copier.copy(name)
							, (ID)copier.copy(optParentName)
							, copier.copyList(optInterfaceList)
							, copier.copyList(optMemberList));    	        	        	
    }*/
//	-------------------------------------------------------------------------	
	/**
	 *   
	 */
	public static NodeDecl getNotAbstractDescendent(NodeDecl node, List passNodes)
	{				
		passNodes.add(node);
		for (int i = 0; i < node.getOptInheritorList().size(); i++)
		{
			if(!node.getOptInheritorList(i).getIsAbstract() )
//			&& (node.getOptInheritorList(i).getOptParentList()!=null
//			    && !node.getOptInheritorList(i).getOptParentList().isEmpty()
//				&& node.getOptInheritorList(i).getOptParentList().contains(node)))
				{
					return node.getOptInheritorList(i);
				}
		}
		for (int i = 0; i < node.getOptInheritorList().size(); i++)
		{
//			if((node.getOptInheritorList(i).getOptParentList()!=null
//			&& !node.getOptInheritorList(i).getOptParentList().isEmpty()
//			&& node.getOptInheritorList(i).getOptParentList().contains(node)))
				{
					if(!passNodes.contains(node.getOptInheritorList(i)))
					{
						NodeDecl res = StgNodeDecl.getNotAbstractDescendent(node.getOptInheritorList(i), passNodes);
						if(res != null) return res;				
					}
				}
		}	
		return null;		
	}    
//	-------------------------------------------------------------------------
	/**
	 *   
	 */
	public static List getNotAbstractDescList(NodeDecl node)
	{
		ArrayList res = new ArrayList(0);
       
		List nodeList = ((TreeDesc)node.getParent()).getOptNodeList();

		for (int i = 0; i < nodeList.size(); i++)
		{
			if (((NodeDecl) nodeList.get(i)).getOptBaseName()!=null
			&&
			    ((NodeDecl) nodeList.get(i))
				.getOptBaseName()
				.getName()
				.equals(node.getName()))
			{
				if (!((NodeDecl) nodeList.get(i)).getIsAbstract())
				{
                    res.add((NodeDecl) nodeList.get(i));
                }
//				else
				{
					res.addAll(StgNodeDecl.getNotAbstractDescList((NodeDecl) nodeList.get(i)));
				}
			}
		}

		return res;
	}	
//	-------------------------------------------------------------------------
	/**
	 *    (      )
	 */
	public static List getDescList(NodeDecl node)
	{
		ArrayList res = new ArrayList(0);
       
		List nodeList = ((TreeDesc)node.getParent()).getOptNodeList();

		for (int i = 0; i < nodeList.size(); i++)
		{
			if (((NodeDecl) nodeList.get(i)).getOptParentList()!=null
			 && ((NodeDecl) nodeList.get(i)).getOptParentList().contains(node))
			{
				res.add((NodeDecl) nodeList.get(i));
				if (((NodeDecl) nodeList.get(i)).getIsAbstract())
				{
					res.addAll(StgNodeDecl.getDescList((NodeDecl) nodeList.get(i)));
				}
			}
		}

		return res;
	}		
//	-------------------------------------------------------------------------
	/**
	 *   
	 */
	public static List getDirectDescList(NodeDecl node)
	{
		ArrayList res = new ArrayList(0);
       
		List nodeList = ((TreeDesc)node.getParent()).getOptNodeList();

		for (int i = 0; i < nodeList.size(); i++)
		{
			if (((NodeDecl) nodeList.get(i)).getOptBaseName()!=null
			&&
			    ((NodeDecl) nodeList.get(i)).getOptBaseName().getName().equals(node.getName()))
			{
					res.add((NodeDecl) nodeList.get(i));
			}
		}

		return res;
	}		
//	-------------------------------------------------------------------------	
	/**
	 *   
	 */
	private static List/*NodeDeclDeclarator*/ getParents(NodeDecl node, List passNodes)
	{		
		
		if(passNodes==null) passNodes = new ArrayList(0);
		passNodes.add(node);
		List res = new ArrayList(0);
	    
		
	    
		for (int i = 0; i < node.getOptParentList().size(); i++)
		{
		    for (Iterator iter = node.getOptParentList(i).getOptFieldList().iterator(); iter.hasNext();)
            {
                Object element = (Object) iter.next();
                if (element instanceof FieldDescriptor)
                {
                    FieldDescriptor currField = (FieldDescriptor) element;
    				if(currField.getKind()==FieldDescriptor.CHILD
    				&& ((NodeType)((Child)currField.getNode()).getType()).getName().getName().getValue().equals(node.getName().getValue()))
    				{
    					if(!node.getOptParentList(i).getIsAbstract())	
    					{
    						if (!Utils.containsIdentical(res,node.getOptParentList(i)))
    						{
    							res.add(node.getOptParentList(i));						
    						}
    					}
    					else
    					{
    						List notAbstractList = getNotAbstractDescList(node.getOptParentList(i));
    						for (Iterator iter1 = notAbstractList.iterator();iter1.hasNext();) 
    						{
    							NodeDecl element1 = (NodeDecl) iter1.next();
    							if(!res.contains(element1))
    							{
    								res.add(element1);
    							}
    						}						
    					}
    				}	
                }
			}	
		
		}		
		
		if(node.getOptBaseName()!=null
		&& !passNodes.contains(node.getOptBaseName().getNodeDecl()))
		{			
			NodeDecl currNode = node.getOptBaseName().getNodeDecl();		
			if(currNode == null)return res;	
//			if (false) return res;
			List newList = StgNodeDecl.getParents(currNode, passNodes);
			for (int j = 0; j < newList.size(); j++)
			{
				if(!res.contains(newList.get(j)))
				{
					res.add(newList.get(j));
				} 					
			}
							
		}
//		
//		List inherList = node.getOptInheritorList();
//		for (Iterator iter = inherList.iterator(); iter.hasNext();)
//        {
//            NodeDecl inheritor = (NodeDecl) iter.next();
//			List newList = StgNodeDecl.getParents(inheritor, passNodes);
//			for (int j = 0; j < newList.size(); j++)
//			{
//				if(!res.contains(newList.get(j)))
//				{
//					res.add(newList.get(j));
//				} 					
//			}            
//        }
//		
		return res;
	}
    
	public static List/*NodeDeclDeclarator*/ getParents(NodeDecl node)
	{
	    return getParents(node, new ArrayList(0));
	}
//	-------------------------------------------------------------------------
	/**
	 *     -(    this  node )
	 */
	public static boolean isConnected(/*StgNodeDecl child,*/ NodeDecl ances, boolean flag, List passNodeList, NodeDecl node)
	{

		//boolean res = false;
		boolean nodeFound = false;
		boolean firstStepFinished = false;
		 
		
		passNodeList.add(node);
		
		ArrayList refList =new ArrayList(0); 
		refList.addAll(node.getOptInheritorList());
		if (node.getOptBaseName()!=null)
		{
			refList.add(node.getOptBaseName().getNodeDecl());
			
		}
		
		int i = 0;
				
		while (!refList.isEmpty() && i < refList.size())
		{
			for (i = 0; i < refList.size(); i++)
			{
				if(!firstStepFinished)
				{
					if ( (NodeDecl)refList.get(i) == ances)
					{
						if(!nodeFound)nodeFound = true;
						if(!flag)flag = true;
						else
						{
							return true;
						}
						// screen comment
						MainGenerationCycle.STGLogger.info(ances.getName().getValue() + "-" + node.getName().getValue());
						if (StgNodeDecl.isConnected( node, flag, passNodeList, ances))
						 {
							return true;					 	
						 }
					  else
						{
							return false;						
						} 
						
					}					
				}
				else
				{					
					if (!passNodeList.contains( refList.get(i)))
					{					
						if( StgNodeDecl.isConnected( ances, flag, passNodeList, (NodeDecl) refList.get(i)))
						{
							return true;						
						}
					}					
				}
				if(!firstStepFinished && i>=refList.size()-1)
				{
					firstStepFinished = true;					
					i=-1;
				}									
			}						
		}	
		return false;	
	}
//	-------------------------------------------------------------------------
	/**
	 *       ances  node 
	 */
	public static boolean isAncestor(String ances, NodeDecl node)
	{

		//boolean res = false;

        NodeDecl parent = node.getOptBaseName()!=null?node.getOptBaseName().getNodeDecl():null;
        
		while (parent!=null && !parent.getName().getValue().equals(ances)) 
		{			
			parent = parent.getOptBaseName()!=null?parent.getOptBaseName().getNodeDecl():null;
		}

		return parent!=null;	
	}	
//	-------------------------------------------------------------------------
    /**
     * define circularity: if ances is descen's ancestor we should know if descen is ancestor of ances  
     */
	public static boolean isCycling(NodeDecl ances, NodeDecl descen)
	{
		//boolean res = false;
		return StgNodeDecl.isConnected(descen, false, new ArrayList(0), ances);		
	}

//	-------------------------------------------------------------------------
    public static List/*NodeDecl*/ removeAbstractNodeFromRoute(List/*NodeDecl*/ route)
    {
    	int listSize = route.size();
    	List res = new ArrayList();
    	
        for (int i = 0; i < listSize; i++) 
        {
            if(route.get(i) instanceof String) continue;
        	NodeDecl currNode = (NodeDecl)route.get(i);
            if (!currNode.getIsAbstract()) 
            {
            	if (i == listSize-1)
                {
                    res.add(currNode);
                }
                else
                {
                    if (!StgTree.isInherited((NodeDecl)route.get(i+1), currNode))
                    {
                        res.add(currNode);
                    }
                }
			}  
            else
            {
                if (i == listSize-1)
                {
                    res.add(StgNodeDecl.getNotAbstractDescList(currNode).get(0));
                }
            }
		}    	
    	
    	return res;
    }
//	-------------------------------------------------------------------------
    /**
     * @return first not abstract ancestor of nodeDecl @param node
     */
	public static NodeDecl getClosestUnabstractAncestor(NodeDecl node)
	{
		NodeDecl currAnces = node.getOptBaseName()!=null ? node.getOptBaseName().getNodeDecl():null;		
		
		while (currAnces!=null && currAnces.getIsAbstract()) 
		{
			currAnces = currAnces.getOptBaseName().getNodeDecl();			
		}
		return currAnces;
	}
//	-------------------------------------------------------------------------
    /**
     * @return true if node contains at least one abstract type child
     */	
	public static boolean containsAbstractTypeChild(NodeDecl node)
	{
		for (Iterator iter = node.getOptFieldList().iterator(); iter.hasNext();) 
        {
            Object element = iter.next();
            if (element instanceof FieldDescriptor)
            {
                FieldDescriptor fieldDesc = (FieldDescriptor) element;
                if (fieldDesc.getKind() == FieldDescriptor.CHILD 
                &&  ((NodeType)((Child)fieldDesc.getNode()).getType()).getName().getNodeDecl().getIsAbstract())
                {
                    return true; 
                }
            }
		}
		return false;
	}
//	-------------------------------------------------------------------------
    
    public static boolean isChildList(NodeDecl node, String childName)
    {
        List memberList = new ArrayList();
        memberList.addAll(node.getOptFieldList());
        memberList.addAll(node.getOptMemberList());
       for (Iterator iter = memberList.iterator(); iter.hasNext();)
       {
            Object element =  iter.next();
            if (element instanceof FieldDescriptor)
            {
                TDL.FieldDescriptor currField = (TDL.FieldDescriptor) element;
                if (currField.getName().getValue().equals(childName))
                {
                    return currField.isList();
                }
            }
            if (element instanceof Field)
            {
                if (((Field)element).getName().getValue().equals(childName))
                {
                    if (element instanceof Child)
                    {
                        Child child = (Child)element;
                        return child.getField().isList();
                    }
                    else
                    {
                        return false;
                    }
                }
            }
		}	
		throw new IllegalArgumentException(Messages.INTERNAL_ERROR + "StgNodeDecl.java, line 357, node " + node.getName().getValue() + " has not any child with name '" + childName + "'");
    }
//	-------------------------------------------------------------------------
    static final public int PATH = 0;
	static final public int BRANCHING = 1;
	static final public int SEM_RELATION = 2;
	/**
	 * 
	 * @return list of nodeDecl sorted by shortest path, min branching or min semantics relations
	 */
    public static List sort(List /*NodeDecl*/ nodesList, int mode, SemanticRelHashMap semMap)
    {
    	if (nodesList.isEmpty())throw new IllegalArgumentException("StgNodeDecl.java, line 365 " + Messages.INTERNAL_ERROR + " empty nodes list specified ");
    	switch (mode)
		{
			case PATH :
				return sortByPath(nodesList);
				
			case BRANCHING :
				return sortByBranching(nodesList);
				
			case SEM_RELATION :
				return sortByMinSemaRel(nodesList, semMap);
												
			default :
				throw new IllegalArgumentException("StgNodeDecl.java, line 365 " + Messages.INTERNAL_ERROR + " incorrect mode specified ");
		}
    }
    
    /**
     * sorting by min descendents
     * @param nodesList
     * @return
     */
	private static List sortByPath(List nodesList)
	{
		List newList = new ArrayList(nodesList.size());
    	
		for (int i = 0; i < nodesList.size(); i++)
		{
			if (newList.isEmpty())
			{
				newList.add(nodesList.get(i));
				continue;
			}
						
			int childListSize = getNotAbstractNodesBelow((NodeDecl)nodesList.get(i)).size();
			
			int j = 0;
			for (j = 0; j < newList.size(); j++)
			{
				int newNodeChildListSize = getNotAbstractNodesBelow((NodeDecl)newList.get(j)).size(); 
				if(childListSize < newNodeChildListSize)
				{
					break;
				}
			}
			newList.add(j, nodesList.get(i));
		}
		return newList;	
	}    
	/**
	 * sorting by min branching
	 * @param nodesList
	 * @return
	 */
    private static List sortByBranching(List nodesList)
    {
    	List newList = new ArrayList(nodesList.size());
    	
    	for (int i = 0; i < nodesList.size(); i++)
		{
			if (newList.isEmpty())
			{
				newList.add(nodesList.get(i));
				continue;
			}
						
			int childListSize = getChildList((NodeDecl)nodesList.get(i)).size();
			
			for (int j = 0; j < newList.size(); j++)
			{
				if(childListSize < getChildList((NodeDecl)newList.get(j)).size())
				{
					newList.add(j, nodesList.get(i));
					break;
				}
			}
		}
		return newList;
    }
    /**
     * sorting by min semantic relations
     * @param nodesList
     * @return
     */
	private static List sortByMinSemaRel(List nodesList, SemanticRelHashMap semanticMap)
	{
		
		List newList = new ArrayList(nodesList.size());
    	
		for (int i = 0; i < nodesList.size(); i++)
		{
			if (newList.isEmpty())
			{
				newList.add(nodesList.get(i));
				continue;
			}
						
		// TODO	int semRelListSize = semanticMap.getSemRelList((NodeDecl)nodesList.get(i)).size();
			
			for (int j = 0; j < newList.size(); j++)
			{
		/* TODO		SemRelList list = semanticMap.getSemRelList((NodeDecl)newList.get(j));
				if(semRelListSize < list.size())
				{
					newList.add(j, nodesList.get(i));
					break;
				}*/
			}
		}
		return newList;		
	}    
//	-------------------------------------------------------------------------
	/**
     * 
     */
    public static Node getAttribute(NodeDecl node, String name)
    {
        for (Iterator iter = node.getOptFieldList().iterator(); iter.hasNext();)
        {
            Object element = iter.next();
            if (element instanceof FieldDescriptor)
            {
                TDL.FieldDescriptor fieldDesc = (TDL.FieldDescriptor) element;
                if (fieldDesc.getName().getValue().equals(name))
                {
                    return fieldDesc.getNode();
                }
            }
        }
        return null;
    }
//	-------------------------------------------------------------------------	
    /**
     * @return children list of node
     */
	public static List getChildList(NodeDecl node)
	{
		List childList = new ArrayList(0);
		
		for (Iterator iter = node.getOptFieldList().iterator(); iter.hasNext();)
        {
            Object element =  iter.next();
            if (element instanceof FieldDescriptor)
            {
                TDL.FieldDescriptor currField = (TDL.FieldDescriptor) element;

    			if (currField.getKind() == FieldDescriptor.CHILD)
    			{
    				Child child = (Child)currField.getNode();
    				childList.add(child);
    			}
            }
		}
		return childList;
	}	
//  -------------------------------------------------------------------------
    /**
     * @return list of all nodeDecl could be below node as it child or child of it's child and etc. 
     */
    public static List getNotAbstractNodesBelow(NodeDecl node)
    {
    	List res = new ArrayList();
    	
    	List childList = getChildList(node);
    	
    	for (int i = 0; i < childList.size(); i++)
		{
			NodeDecl child = ((TDL.NodeType)((Child)childList.get(i)).getType()).getName().getNodeDecl();
			
			if (child.getIsAbstract())
			{
				List notAbstractDescList = getNotAbstractDescList(child);
				for (int j = 0; j < notAbstractDescList.size(); j++)
				{
					res.add(notAbstractDescList.get(j));
					res.addAll(getNotAbstractNodesBelow((NodeDecl)notAbstractDescList.get(j)));
				}
			}
			else
			{
				res.add(child);
				res.addAll(getNotAbstractNodesBelow(child));
			}
		}
    	
    	return res;
    }
    ///-------
    /**
     * @return FieldDescriptor by name
     */
    public static Object getOptField(TDL.NodeDecl node, String name)
    {
        List descList = StgNodeDecl.getDescList(node);
        descList.add(0, node);
        
        for (Iterator iter = descList.iterator(); iter.hasNext();)
        {
            TDL.NodeDecl descNode = (TDL.NodeDecl) iter.next();
	        List fieldList = descNode.getOptFieldList();
	    	for (Iterator iter1 = fieldList.iterator(); iter1.hasNext();) 
	    	{
				Object element = iter1.next();
                if (element instanceof FieldDescriptor)
                {
                    FieldDescriptor fieldDesc = (FieldDescriptor) element;
                    if (fieldDesc.getName().getValue().equals(name))
                    {
//                      if (descNode != node)
//                        {
//                            MainGenerationCycle.STGLogger.info("Warning! Only " + descNode.getName().getValue() + " node has child with name " + name + ". Check srl-file.");
//                        }
                        return fieldDesc.getNode();
                    }
                }
				
			}
        }
    	return null;
    }
    /**
	 * 
	 */
	public static String getFieldType(String fieldName, TDL.NodeDecl node) 
	{
		String type = "";
		for (Iterator iter = node.getOptFieldList().iterator(); iter.hasNext();) 
        {
            Object element =  iter.next();
            if (element instanceof FieldDescriptor)
            {
                FieldDescriptor fieldDesc = (FieldDescriptor) element;
                if (fieldDesc.getName().getValue().equals(fieldName)) 
                {
                    TDL.Field field = (TDL.Field)fieldDesc.getNode();
                    if(field instanceof TDL.Attribute)
                    {
                        TDL.Attribute attr = (TDL.Attribute) field;
                     
                        if (attr.getType() instanceof TDL.NameType) {
                            TDL.NameType nameType = (TDL.NameType) attr.getType();
                            type = nameType.getName();
                        }
                        if (attr.getType() instanceof TDL.ConstantType) {
                            TDL.ConstantType constType = (TDL.ConstantType) attr.getType();
                            type = "Integer";
                        }
                    }
                    if (field instanceof TDL.Child) {
                        TDL.Child child = (TDL.Child) field;
                        if (child.getType() instanceof TDL.NodeType) {
                            TDL.NodeType nodeType = (TDL.NodeType) child.getType();
                            type = nodeType.getName().getName().getValue();
                        }
                    }
                }                
            }
		}
		return type;
	}

}
