/*
 * Copyright 2004-2009 ISP RAS (http://www.ispras.ru), UniTESK Lab (http://www.unitesk.com)
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
/*
 * @@author <A href="mailto:maryn@@ispras.ru">Mary Naprasnikova</A>
 * @@version $Id: StgTree.java,v 1.1.1.1.2.10.2.3 2006/10/11 13:39:06 maryn Exp $
 */
package ru.ispras.redverst.stg.tdt;

import java.util.ArrayList;
import java.util.List;

import ru.ispras.redverst.stg.global.GlobalProperties;
import ru.ispras.redverst.stg.semobj.SemanticTree;

import com.unitesk.atp.treedl.TDL.NodeDecl;
import com.unitesk.atp.treedl.TDL.TreeDesc;


/**
 * @author Maryn
 * stg   atp.Tree  
 */
public class StgTree //extends Tree 
{	
	private static TreeDesc gramTree;
//	-------------------------------------------------------------------------
	/**
	 * return NodeDecl by name
	 */
	public static NodeDecl getNodeDecl(String name, TreeDesc tree)
	{
		int nodeListSize = tree.getOptNodeList().size();
		for (int i = 0; i < nodeListSize; i++)
		{
			String str = tree.getOptNodeList(i).getName().getValue();
			if(str.equals(name))
			  return tree.getOptNodeList(i);
		}
	    throw new IllegalArgumentException("Failed to find node with name " + name);
		//return null;
	}	
//	-------------------------------------------------------------------------
	/**
	 *       
	 */
	public static boolean isAncestor(String parentName, String childName, List passNodes, TreeDesc tree)
	{
		// TODO   ,             
		// TODO  -      
		if (parentName.equals(GlobalProperties.START_NODE_TYPE)) return true;
		 
		if(passNodes==null) passNodes = new ArrayList(0);

		if(passNodes.contains(childName)) return false;
        
		passNodes.add(childName);        		
        
		List /*NodeDecl*/ parentsList = StgNodeDecl.getParents(getNodeDecl(childName, tree));
        
		for (int i = 0; i < parentsList.size(); i++)
		{
			if(((NodeDecl)parentsList.get(i)).getName().getValue().equals(parentName)) return true;
		}		
		for (int i = 0; i < parentsList.size(); i++)
		{
			if(isAncestor(parentName, ((NodeDecl)parentsList.get(i)).getName().getValue(), passNodes, tree)) return true;
		}		
		
		return false;
	}

//	-------------------------------------------------------------------------
    /**
     * @return checks if child was inherited from parent
     */
    public static boolean isInherited(NodeDecl child, NodeDecl parent)
    {
    	NodeDecl currParent = child.getOptBaseName()!=null ? child.getOptBaseName().getNodeDecl() : null;
    	while (currParent!=null) 
    	{
    	    if (currParent.equals(parent))
    	    {
    	        return true;
    	    }
			currParent = currParent.getOptBaseName()!=null ? currParent.getOptBaseName().getNodeDecl() : null;
		}
		return false;//currParent != null /*&& currParent.getOptBaseName()!=null*/;
    }
//	-------------------------------------------------------------------------
	/**
	 * @return checks if child was inherited from parent
	 */
	public static boolean isInherited(String child, String parent, TreeDesc gramTree)
	{
        NodeDecl childNode = StgTree.getNodeDecl(child, gramTree);
		NodeDecl parentNode = StgTree.getNodeDecl(parent, gramTree);
		return StgTree.isInherited(childNode, parentNode);
	}    
	//-------------------------------------------------------------------------
	/**
	 * @return
	 */
	public static TreeDesc getGramTree() {
		return gramTree;
	}

	//-------------------------------------------------------------------------
	/**
	 * @param tree
	 */
	public static void setGramTree(TreeDesc tree) {
		gramTree = tree;
	}
	
    public static String getGramTreeStartNode()
    {
        return SemanticTree.gramTree.getProperty("startnode.name");
    }
}
