/*
 * Copyright 2004-2009 ISP RAS (http://www.ispras.ru), UniTESK Lab (http://www.unitesk.com)
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package ru.ispras.redverst.stg.utils;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.HashMap;
import java.util.HashSet;
import java.util.Iterator;
import java.util.List;
import java.util.Map;
import java.util.Set;

import ru.ispras.redverst.stg.global.Messages;
import ru.ispras.redverst.stg.semrel.FullSemRelList;
import ru.ispras.redverst.stg.semrel.SemanticRelation;

/**
 * @author maryn
 *
 * To change the template for this generated type comment go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
public class BinKeyHashMap extends HashMap
{
    private Map classIdToSrContainer = new HashMap(); 
	public class HashMapPairKey
	{
		/**
		 * @return Returns the key.
		 */
		public Integer[] getKey() {
			return key;
		}
		private Integer key[];
		/**
		 * 
		 */
		public HashMapPairKey(int keyLeft, int keyRight) 
		{
			this.key = new Integer[]{new Integer(keyLeft), new Integer(keyRight)};
		}
		/* (non-Javadoc)
		 * @see java.lang.Object#equals(java.lang.Object)
		 */
		public boolean equals(Object arg0) 
		{
			if (arg0 instanceof HashMapPairKey) {
				HashMapPairKey newKey = (HashMapPairKey) arg0;
				if(newKey.getKey()[0].equals(this.key[0]) && newKey.getKey()[1].equals(this.key[1]) 
				|| newKey.getKey()[0].equals(this.key[1]) && newKey.getKey()[1].equals(this.key[0]))
				{
					return true;
				}
			}
			return false;
		}
		/**
		 * 
		 */
		public void replace(int index, int value) 
		{
			if (index !=0 && index !=1) 
			{
				throw new IllegalArgumentException();
			} 
			else 
			{
				this.key[index] = new Integer(value);
			}
		}
		
		/**
		 * 
		 */
		public int contains(int value) 
		{
			if(this.key[0].intValue()==value) return 0;
			if(this.key[1].intValue()==value) return 1;
			return -1;
		}
	}
    protected HashMap classRelationArray = new HashMap();//new boolean[GlobalProperties.SYSTEM_SIZE][GlobalProperties.SYSTEM_SIZE]; 
    /**
     * 
     */
    public BinKeyHashMap()
    {
    	super();
    }
    /**
     * 
     */
    public Object put(Object key, Object value) 
    {
        throw new UnsupportedOperationException();
    }
    
    public int getKey(Object obj)
    {
        List collectionSet = new ArrayList(this.keySet());
        for (Iterator iter = collectionSet.iterator(); iter.hasNext();)
        {
            Integer nextKey = (Integer) iter.next();
            CollectionWithFlag nextColl = (CollectionWithFlag) this.get(nextKey);
            if (nextColl.containsObj(obj)) return nextColl.getId();
        }
        return -1;
    }
    
    public Object getValue(Object key)
    {
        List collectionSet = new ArrayList(this.keySet());
        for (Iterator iter = collectionSet.iterator(); iter.hasNext();)
        {
            Integer nextKey = (Integer) iter.next();
            if (nextKey.equals(key))
            {
               return   this.get(nextKey);
            }
        }
        return -1;
    }    
    
    /**
     * put new values to one class with new CollectionWithFlag building fot them
     * @param value
     * @param flag TODO
     * @param sr TODO
     */
    public Integer put(List value, long flag, SemanticRelation sr)
    {
        ArrayList list = new ArrayList(value.size());
        list.addAll(value);
        
        Integer newKey = this.genNextId();
        
        if (flag > 0)
        {
            super.put(newKey, new CollectionWithFlag(flag, list, newKey.intValue()));
        }
        else
        {
            super.put(newKey, new CollectionWithFlag(list, newKey.intValue()));   
        }
        associateSrWithClass(newKey, sr);
        return newKey;
    }
    /**
     * put new value with new CollectionWithFlag building fot it
     * @param value
     * @param flag TODO
     * @param newSemRel TODO
     * @param contrClassId TODO
     * @param contrRel TODO
     * @return
     */
    public Integer put(Object value, long flag/*, long contrClassId, boolean contrRel*/, SemanticRelation newSemRel)
    {        
        ArrayList list = new ArrayList(1);
        list.add(value);
        
        Integer newKey = this.genNextId();
        
        if (flag > 0)
        {
            super.put(newKey, new CollectionWithFlag(flag, list, newKey.intValue()));
        }
        else 
        {
            super.put(newKey, new CollectionWithFlag(list, newKey.intValue()));
        }
        associateSrWithClass(newKey, newSemRel);
        return newKey;
    }
    
    /**
     * put new value to exisitng CollectionWithFlag
     * @param key
     * @param value
     * @param flag TODO
     * @param newSemRel TODO
     */
    public void put(int key, Object value, long flag, SemanticRelation newSemRel)
    {
        this.put(new Integer(key), value, flag, newSemRel);
    }
    /**
     * put new value to exisitng CollectionWithFlag
     * @param key
     * @param value
     * @param flag TODO
     * @param newSemRel TODO
     */
    public void put(Integer key, Object value, long flag, SemanticRelation newSemRel) 
    {
        CollectionWithFlag res = (CollectionWithFlag)this.get(key);
        res.add(value);    
        associateSrWithClass(key, newSemRel);
    }
    
    public Integer genNextId()
    {
        List keySet = new ArrayList(this.keySet());
        Integer[] keyArray = new Integer[keySet.size()];
        keySet.toArray(keyArray);
        Arrays.sort(keyArray);
        
        Integer max = keySet.size() > 0 ? keyArray[keyArray.length-1] : new Integer(1);
        return new Integer(max.intValue()+1/**2*/);
    }
    /**
     * Combines two collection if it is allowed by flags 
     * @param key1
     * @param key2
     * @param newSemRel TODO
     * @return
     */
    public CollectionWithFlag union(Integer key1, Integer key2, SemanticRelation newSemRel)
    {
        Integer newKey = this.genNextId();
        
        CollectionWithFlag res = ((CollectionWithFlag)this.get(key1)).concat(((CollectionWithFlag)this.get(key2)), newKey.intValue());
        
        if (res == null) return res;
        
        super.remove(key1);
        super.remove(key2);
        super.put(newKey, res);
        
        reassociateSrWithClass(key1, newKey, newSemRel);
        reassociateSrWithClass(key2, newKey, newSemRel);
        
        List keyList = new ArrayList(this.classRelationArray.keySet());
        for (Iterator iter = keyList.iterator(); iter.hasNext();)
        {
        	HashMapPairKey key = (HashMapPairKey) iter.next();
        	int index1 = key.contains(key1.intValue());
        	int index2 = key.contains(key2.intValue());
        	if(index1 != -1)
        	{
        		this.classRelationArray.remove(key);
        		key.replace(index1, newKey.intValue());
        		this.putClassRelationFlag(key.key[0].intValue(), key.key[1].intValue(), EquationModel.UNEQ);
        	}
        	if(index2 != -1)
        	{
        		this.classRelationArray.remove(key);
        		key.replace(index2, newKey.intValue());
        		this.putClassRelationFlag(key.key[0].intValue(), key.key[1].intValue(), EquationModel.UNEQ);
        	}

        }
        return res;
    }
    /**
     * Replaces reference in flag on @param oldKey with @param newKey 
     * @param oldKey
     * @param newKey
     */
//    public void replace(Integer oldKey, Integer newKey)
//    {
//        List depenList = this.getCollectionsByFlag(oldKey.longValue());
//        for (Iterator iter = depenList.iterator(); iter.hasNext();)
//        {
//            CollectionWithFlag element = (CollectionWithFlag) iter.next();
////            element.setFlag((element.getFlag() - oldKey.longValue()) + newKey.longValue());
//        }
//    }
    
//    public List getCollectionsByFlag(long flag)
//    {
//        List res = new ArrayList(0);
//        List values = new ArrayList(this.values());
//        for (Iterator iter = values.iterator(); iter.hasNext();)
//        {
//            CollectionWithFlag element = (CollectionWithFlag) iter.next();
//            if((element.getFlag() & flag) == flag) res.add(element);
//        }
//        
//        return res;
//    }
    
    /**
     * Fill relation between two classes. If variables are in the relation of UNEQ than their classes cann't be combined.
     */
    public void putClassRelationFlag(int leftClassId, int rightClassId, int sign)
    {
        if (!this.keySet().contains(new Integer(leftClassId)) || !this.keySet().contains(new Integer(rightClassId)))
        {
            throw new IllegalArgumentException();
        }
        if (sign == EquationModel.UNEQ)
        {
            if (leftClassId == rightClassId) throw new InternalError("BinKeyHashMap: classes division.");
            this.classRelationArray.put(new HashMapPairKey(leftClassId, rightClassId), Boolean.FALSE);
        }
        
        if (sign == EquationModel.EQ) 
        {
        	throw new IllegalArgumentException("Classes must be combined!");
        }
    }
    
    /**
     * 
     */
    public boolean canCombine(int key1, int key2)
    {
        List keys = new ArrayList(this.getClassRelationArray().keySet());
        for (Iterator iter = keys.iterator(); iter.hasNext();)
        {
            HashMapPairKey element = (HashMapPairKey) iter.next();
            if (element.equals(new HashMapPairKey(key1, key2)))
            {
                return false;
            }
        }
        return true;
    }
    
   
    public boolean containsInValueSet(Object value)
    {
        boolean res = false; 
        List values = new ArrayList(this.values());
        for (Iterator iter = values.iterator(); iter.hasNext();)
        {
            CollectionWithFlag element = (CollectionWithFlag) iter.next();
            if (element.contains(value))
            {
                res = true;
                break;
            }
        }
        return res;
    }
    public HashMap getClassRelationArray()
    {
        return classRelationArray;
    }
    public boolean isBkhmConsistent()
    {
        boolean res = true;
        List keys = new ArrayList(this.getClassRelationArray().keySet());
        for (Iterator iter = keys.iterator(); iter.hasNext();)
        {
            HashMapPairKey element = (HashMapPairKey) iter.next();
            if (!this.keySet().contains(element.getKey()[0]) || !this.keySet().contains(element.getKey()[1]))
            {
                return false;
            }
        }
        return res;
    }    
    /**
     * Allow to associate semantic relation with class with which its arguments are connected
     * @param classId
     * @param sr
     */
    private void associateSrWithClass(int classId, SemanticRelation sr)
    {
//        if (classId>= this.classIdToSrContainer.size())
//        {
//            Set newList = new HashSet();
//            newList.add(sr);
//            this.classIdToSrContainer.ensureCapacity(classId+1);
//            this.classIdToSrContainer.add(classId, newList);            
//        }
//        else
//        {
            Object srCollection = this.classIdToSrContainer.get(classId);
            if (srCollection != null)
            {
                if (srCollection instanceof Set)
                {
                    Set srList = (Set) srCollection;
                    srList.add(sr);
                }
                else
                {
                    throw new IllegalStateException();
                }
            }
            else
            {
                Set newList = new HashSet();
                newList.add(sr);
                this.classIdToSrContainer.put(classId, newList);
            }
//        }
    }
    
    /**
     * Allow to associate semantic relation with class with which its arguments are connected
     * @param classId
     * @param sr
     */
    private void reassociateSrWithClass(int oldClassId, int newClassId, SemanticRelation sr)
    {
        Object srCollection = this.classIdToSrContainer.get(oldClassId);
        if (srCollection != null)
        {
            if (srCollection instanceof Set)
            {
                ((Set)srCollection).remove(sr);
            }
            else
            {
                throw new IllegalStateException();
            }
        }
        else
        {
            throw new IllegalStateException();
        }

        associateSrWithClass(newClassId, sr);
    }    
    /**
     * Returns semantic relation list associated with class specified by id 
     * @param classId
     * @return
     */
    public FullSemRelList getSemRelListAssociatedWith(int classId)
    {
        Object list = this.classIdToSrContainer.get(classId);
        
        if (list != null )
        {
            if (list instanceof Set)
            {
                return new FullSemRelList(new ArrayList((Set)list), -1);
            }
            else {
                throw new IllegalStateException();
            }
        }
        return new FullSemRelList();
    }
}
