/*
 * Copyright 2004-2009 ISP RAS (http://www.ispras.ru), UniTESK Lab (http://www.unitesk.com)
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package ru.ispras.redverst.stg.utils;

import java.util.ArrayList;
import java.util.Collection;
import java.util.Iterator;
import java.util.List;

/**
 * @author maryn
 *
 * To change the template for this generated type comment go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
public class CollectionWithFlag implements Collection
{
    private int id = 1;
//    private long flag = 0; 
    private List collection = null;
    /**
     * 
     */
    public CollectionWithFlag(Collection collection, int id)
    {
        super();
        
        String binStr = Integer.toBinaryString(id); 
//        if (!binStr.matches("(0)*1(0)*")) throw new IllegalArgumentException("Collection id must be power of 2");
        
        this.id = id;
        this.collection = new ArrayList(collection);
    }
    public CollectionWithFlag(long flag, Collection collection, int id)
    {
        super();
        
        String binStr = Integer.toBinaryString(id); 
//        if (!binStr.matches("(0)*1(0)*")) throw new IllegalArgumentException("Collection id must be power of 2");        

        this.id = id;
//        this.flag = flag;
        this.collection = new ArrayList(collection);
    }
    /* (non-Javadoc)
     * @see java.util.Collection#size()
     */
    public int size()
    {
        return this.collection.size();
    }

    /* (non-Javadoc)
     * @see java.util.Collection#clear()
     */
    public void clear()
    {
//        this.flag = 0;
        this.collection.clear();
    }

    /* (non-Javadoc)
     * @see java.util.Collection#isEmpty()
     */
    public boolean isEmpty()
    {
        return this.collection.isEmpty();
    }

    /* (non-Javadoc)
     * @see java.util.Collection#toArray()
     */
    public Object[] toArray()
    {
        return this.collection.toArray();
    }

    /* (non-Javadoc)
     * @see java.util.Collection#add(java.lang.Object)
     */
    public boolean add(Object arg0)
    {
        return this.collection.add(arg0);
    }
    /**
     * 
     * @param arg0
     * @param flag  
     * @return
     */
    public boolean add(Object arg0, long lflag)
    {
//        this.flag = this.flag | lflag;
        return this.collection.add(arg0);
    }
    
    /* (non-Javadoc)
     * @see java.util.Collection#contains(java.lang.Object)
     */
    public boolean containsObj(Object arg0)
    {
        for (int i = 0; i < this.collection.size(); i++)
        {
            Object element = (Object) this.collection.get(i);
            if (element == arg0) return true;   
        }
        return false;
    }
    public boolean contains(Object arg0)
    {
        return Utils.containsIdentical(this.collection, arg0);
    }
    /* (non-Javadoc)
     * @see java.util.Collection#remove(java.lang.Object)
     */
    public boolean remove(Object arg0)
    {
        return this.collection.remove(arg0);
    }

    /* (non-Javadoc)
     * @see java.util.Collection#addAll(java.util.Collection)
     */
    public boolean addAll(Collection arg0)
    {
        return this.collection.addAll(arg0);
    }
    /**
     * Concatenate two collection if it is possible, else return null
     * @param arg0
     * @param newId
     * @return
     */
    public CollectionWithFlag concat(CollectionWithFlag arg0, int newId)
    {
        
        String binStr = Integer.toBinaryString(newId); 
//        if (!binStr.matches("(0)*1(0)*")) throw new IllegalArgumentException("Collection id must be power of 2");        
        
//        if ((this.flag & arg0.id) == arg0.id || (arg0.flag & this.id) == this.id)
//        {
//            return null; 
//        }
        CollectionWithFlag res = new CollectionWithFlag(/*this.flag | arg0.flag*/0, this.collection, newId);
        res.addAll(arg0);
        return res;
    }    
    
    /* (non-Javadoc)
     * @see java.util.Collection#containsAll(java.util.Collection)
     */
    public boolean containsAll(Collection arg0)
    {
        return this.collection.containsAll(arg0);
    }

    /* (non-Javadoc)
     * @see java.util.Collection#removeAll(java.util.Collection)
     */
    public boolean removeAll(Collection arg0)
    {
        return this.collection.removeAll(arg0);
    }

    /* (non-Javadoc)
     * @see java.util.Collection#retainAll(java.util.Collection)
     */
    public boolean retainAll(Collection arg0)
    {
        return this.collection.retainAll(arg0);
    }

    /* (non-Javadoc)
     * @see java.util.Collection#iterator()
     */
    public Iterator iterator()
    {
        return this.collection.iterator();
    }

    /* (non-Javadoc)
     * @see java.util.Collection#toArray(java.lang.Object[])
     */
    public Object[] toArray(Object[] arg0)
    {
        return this.collection.toArray(arg0);
    }

    public int getId()
    {
        return id;
    }
//    public void setFlag(long flag)
//    {
//        this.flag = flag;
//    }
//    public void changeFlag(long delta)
//    {
//        this.flag = this.flag + delta;
//    }    
//    public long getFlag()
//    {
//        return flag;
//    }
}
