/*
 * Copyright 2004-2009 ISP RAS (http://www.ispras.ru), UniTESK Lab (http://www.unitesk.com)
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
/*
 * @@author <A href="mailto:maryn@@ispras.ru">Mary Naprasnikova</A>
 * @@version $Id: AbstractNodeIteratorGenerator.java,v 1.3.2.11 2006/05/22 13:55:34 maryn Exp $
 */
package ru.ispras.redverst.stg.generator.iters;

import java.util.List;

import ru.ispras.redverst.stg.tdt.StgNodeDecl;

import com.unitesk.atp.tree.TreeClass.NodeClass;
import com.unitesk.atp.tree.generation.TextGeneratorVisitor;
import com.unitesk.atp.treedl.TDL;
import com.unitesk.atp.treedl.TDL.Attribute;
import com.unitesk.atp.treedl.TDL.BaseTree;
import com.unitesk.atp.treedl.TDL.Body;
import com.unitesk.atp.treedl.TDL.Cardinality;
import com.unitesk.atp.treedl.TDL.Child;
import com.unitesk.atp.treedl.TDL.ConstantType;
import com.unitesk.atp.treedl.TDL.Constructor;
import com.unitesk.atp.treedl.TDL.Field;
import com.unitesk.atp.treedl.TDL.FieldDescriptor;
import com.unitesk.atp.treedl.TDL.ID;
import com.unitesk.atp.treedl.TDL.Member;
import com.unitesk.atp.treedl.TDL.NameType;
import com.unitesk.atp.treedl.TDL.NodeDecl;
import com.unitesk.atp.treedl.TDL.NodeID;
import com.unitesk.atp.treedl.TDL.QID;
import com.unitesk.atp.treedl.TDL.TDL_Visitor;
import com.unitesk.atp.treedl.TDL.TreeBody;
import com.unitesk.atp.treedl.TDL.TreeCode;
import com.unitesk.atp.treedl.TDL.TreeDesc;
import com.unitesk.atp.treedl.TDL.Type;
import com.unitesk.atp.treedl.TDL.Typedef;

/**
 * @author Maryn
 *
 * To change the template for this generated type comment go to
 * Window>Preferences>Java>Code Generation>Code and Comments
 */
public class AbstractNodeIteratorGenerator
	extends TextGeneratorVisitor
	implements TDL_Visitor {

	/**
	 * 
	 */
	public AbstractNodeIteratorGenerator() {
		super();
		// TODO Auto-generated constructor stub
	}

	//-------------------------------------------------------------------------
	/* (non-Javadoc)
	 * @see ru.ispras.redverst.atp.tdt.TDT_Visitor#visitTree(ru.ispras.redverst.atp.tdt.Tree)
	 */
	public void visitTreeDesc(TreeDesc node) {
		// TODO Auto-generated method stub

	}

	//-------------------------------------------------------------------------
	/* (non-Javadoc)
	 * @see ru.ispras.redverst.atp.tdt.TDT_Visitor#visitNodeDecl(ru.ispras.redverst.atp.tdt.NodeDecl)
	 */
	public void visitNodeDecl(NodeDecl node) 
	{
//			*******************************************************
			txt( "// Generated by ${.toolName}, version ${.toolVersion}" ); nl();
			txt( "// Source file: ${.sourceFileName}" ); nl();
			txt( "// Date: " + new java.util.Date() ); nl();
			txt( "// child-tree adder");nl();
			nl();
        
			txt( "package ru.ispras.redverst.stg.langdep.iterators.nodes.isabstract;" ); nl();
		
			txt("import java.util.*;");nl();		
			txt("import ru.ispras.redverst.iterator.ListIterator;import ru.ispras.redverst.iterator.SequenceIterator;");nl();
		    txt("import ru.ispras.redverst.iterator.ValueIterator;");nl();							
			txt("import ru.ispras.redverst.stg.base.BaseNode;" +
				"import ru.ispras.redverst.stg.langdep.iterators.nodes.notabstract.*;");nl();
			txt("import java.util.ArrayList;");
			txt("import java.util.List;");
			txt("import ru.ispras.redverst.stg.base.iterators.StgNodeIterator; import ru.ispras.redverst.iterator.OneObjectIterator;");
			
		    nl();	
			txt( "public class ${name}Iterator extends StgNodeIterator");nl();	
		    
		    txt( "{");nl();incIndent();
		    nl();	
		    txt(" private List iters = new ArrayList(); ");nl();
		    txt( "private SequenceIterator listIterator;"); nl();		   
		    txt("static private int counter = 0;");nl(); 
//			******************* constructor ************************************			
			txt( "public ${name}Iterator() throws IllegalAccessException, InstantiationException, ClassNotFoundException" +
				" {");nl();incIndent();
			txt( "super();");nl();
			txt( "setPrivateIterationBorder(--iterationBorder);");nl();

			txt("Throwable currThrow = new Throwable();");nl();
			txt("StackTraceElement[] stack = currThrow.getStackTrace();");nl(); 
			txt("List stackCallList = new ArrayList(stack.length); ");nl();
		        
			txt("for (int i = 0; i < stack.length; i++)");nl(); 
			txt("{");nl();
				txt("if(stack[i].getFileName()!=null)");
				incIndent();
					txt("stackCallList.add(stack[i].getFileName().substring(0, stack[i].getFileName().lastIndexOf('.')));");nl();
				popIndent();
			txt("}");nl();
			
			txt( "try");nl();
			txt("{"); incIndent();
	            txt( "initInnerIterators();");nl();
	        popIndent(); txt("}");
	        txt( "catch (IllegalAccessException e)");nl();
	        txt("{"); incIndent();
	            txt( "e.printStackTrace();");nl();
//	            txt( "return false;");nl();
	        popIndent(); txt("}");
	        txt( "catch (InstantiationException e)");nl();
	        txt("{"); incIndent();
	            txt( "e.printStackTrace();");nl();
//	            txt( "return false;");nl();
	        popIndent(); txt("}");
	        txt( "catch (ClassNotFoundException e)");nl();
	        txt("{"); incIndent();
	            txt( "e.printStackTrace();");nl();
//	            txt( "return false;");nl();
	        popIndent(); txt("}");
			popIndent();txt( "}");nl();
			
//          ********************* initInnerIters ***************************************
			nl();txt("private void initInnerIterators()  throws IllegalAccessException, InstantiationException, ClassNotFoundException");
			nl();
			txt("{");nl();
			incIndent();
			
				List notAbstractDescList = StgNodeDecl.getNotAbstractDescList(node);
			    
				for (int i=0; i < notAbstractDescList.size(); i++)
				{
				    NodeDecl element = (NodeDecl) notAbstractDescList.get(i);
				    txt( "if (checkIterationBorder && getPrivateIterationBorder()>0 && this.isRelevantRecurDepth(\"" + element.getName().getValue() + "\"))");nl();
			        txt("{"); incIndent();nl();
			        txt("iters.add( new " + element.getName().getValue() + "Iterator());");nl();
			        popIndent(); txt("}");
			        txt("else ");
			        txt("{"); incIndent();
			        txt(" iters.add(new OneObjectIterator(new BaseNode().createInstance(\"" + element.getName().getValue() + "\")));");nl();
			        popIndent(); txt("}");
			        
				}
				txt( "listIterator = new SequenceIterator((ValueIterator[])iters.toArray(new ValueIterator[]{}));");nl();
			popIndent();
			txt("}");
//			******************* init ************************************			
			txt( "public /*synchronized*/ boolean init() {");nl();incIndent();		        			
//			txt( "try");nl();
//			txt("{"); incIndent();
//	            txt( "initInnerIterators();");nl();
//	        popIndent(); txt("}");
//	        txt( "catch (IllegalAccessException e)");nl();
//	        txt("{"); incIndent();
//	            txt( "e.printStackTrace();");nl();
//	            txt( "return false;");nl();
//	        popIndent(); txt("}");
//	        txt( "catch (InstantiationException e)");nl();
//	        txt("{"); incIndent();
//	            txt( "e.printStackTrace();");nl();
//	            txt( "return false;");nl();
//	        popIndent(); txt("}");
//	        txt( "catch (ClassNotFoundException e)");nl();
//	        txt("{"); incIndent();
//	            txt( "e.printStackTrace();");nl();
//	            txt( "return false;");nl();
//	        popIndent(); txt("}");
			txt( "return listIterator.init();");nl();
			popIndent();txt( "}");nl();
//			******************* next ************************************			
			txt( "public  /*synchronized*/ boolean next() {");nl();incIndent();
			
			txt( "	// TODO Auto-generated method stub");nl();
			
			txt( "return listIterator.next();");nl();
			popIndent();txt( "}");nl();
//			******************* value ************************************			
			txt( "public  /*synchronized*/ Object value() {");nl();incIndent();
			
		//	txt( "BaseNode newNode = new BaseNode().createInstance((String)listIterator.value());");nl();
			txt( "return listIterator.value();");nl();
		//	txt( "return newNode;");nl();
			popIndent();txt( "}");nl();
			
/*			
			if(node.getIsAbstract())
			{
//				******************Abstract node iterator*************************************
            	
			}
			else
			{
//				******************NotAbstract node iterator*************************************            	
			}
*/
            popIndent();txt( "}");nl();
	}

	//-------------------------------------------------------------------------
	/* (non-Javadoc)
	 * @see ru.ispras.redverst.atp.tdt.TDT_Visitor#visitMember(ru.ispras.redverst.atp.tdt.Member)
	 */
	public void visitMember(Member node) {
		// TODO Auto-generated method stub

	}

	//-------------------------------------------------------------------------
	/* (non-Javadoc)
	 * @see ru.ispras.redverst.atp.tdt.TDT_Visitor#visitField(ru.ispras.redverst.atp.tdt.Field)
	 */
	public void visitField(Field node) {
		// TODO Auto-generated method stub

	}

	//-------------------------------------------------------------------------
	/* (non-Javadoc)
	 * @see ru.ispras.redverst.atp.tdt.TDT_Visitor#visitAttribute(ru.ispras.redverst.atp.tdt.Attribute)
	 */
	public void visitAttribute(Attribute node) {
		// TODO Auto-generated method stub

	}

	//-------------------------------------------------------------------------
	/* (non-Javadoc)
	 * @see ru.ispras.redverst.atp.tdt.TDT_Visitor#visitChild(ru.ispras.redverst.atp.tdt.Child)
	 */
	public void visitChild(Child node) {
		// TODO Auto-generated method stub

	}

	//-------------------------------------------------------------------------
	/* (non-Javadoc)
	 * @see ru.ispras.redverst.atp.tdt.TDT_Visitor#visitBody(ru.ispras.redverst.atp.tdt.Body)
	 */
	public void visitBody(Body node) {
		// TODO Auto-generated method stub

	}

	//-------------------------------------------------------------------------
	/* (non-Javadoc)
	 * @see ru.ispras.redverst.atp.tdt.TDT_Visitor#visitConstructor(ru.ispras.redverst.atp.tdt.Constructor)
	 */
	public void visitConstructor(Constructor node) {
		// TODO Auto-generated method stub

	}

	//-------------------------------------------------------------------------
	/* (non-Javadoc)
	 * @see ru.ispras.redverst.atp.tdt.TDT_Visitor#visitTypedef(ru.ispras.redverst.atp.tdt.Typedef)
	 */
	public void visitTypedef(Typedef node) {
		// TODO Auto-generated method stub

	}

	//-------------------------------------------------------------------------
	/* (non-Javadoc)
	 * @see ru.ispras.redverst.atp.tdt.TDT_Visitor#visitType(ru.ispras.redverst.atp.tdt.Type)
	 */
	public void visitType(Type node) {
		// TODO Auto-generated method stub

	}

	//-------------------------------------------------------------------------
	/* (non-Javadoc)
	 * @see ru.ispras.redverst.atp.tdt.TDT_Visitor#visitNameType(ru.ispras.redverst.atp.tdt.NameType)
	 */
	public void visitNameType(NameType node) {
		// TODO Auto-generated method stub

	}

	//-------------------------------------------------------------------------
	/* (non-Javadoc)
	 * @see ru.ispras.redverst.atp.tdt.TDT_Visitor#visitConstantType(ru.ispras.redverst.atp.tdt.ConstantType)
	 */
	public void visitConstantType(ConstantType node) {
		// TODO Auto-generated method stub

	}

	//-------------------------------------------------------------------------
	/* (non-Javadoc)
	 * @see ru.ispras.redverst.atp.tdt.TDT_Visitor#visitID(ru.ispras.redverst.atp.tdt.ID)
	 */
	public void visitID(ID node) {
		txt("${value}");

	}

	//-------------------------------------------------------------------------
	/* (non-Javadoc)
	 * @see ru.ispras.redverst.atp.tdt.TDT_Visitor#visitFieldDescriptor(ru.ispras.redverst.atp.tdt.FieldDescriptor)
	 */
	public void visitFieldDescriptor(FieldDescriptor node) {
		// TODO Auto-generated method stub

	}
	public void visitNodeClass(NodeClass node)
	{
		
	}
	public void visitNodeID(NodeID node)
	{
		txt("${name}");
	}	
	public void visitTreeBody(TreeBody node)
	{
		
	}
	public void visitCardinality(Cardinality node)
	{
		
	}	
	public void visitTreeCode(TreeCode node)
	{
		
	}	
	public void visitBaseTree(BaseTree node)
	{
		
	}	
	public void visitQID(QID node)
	{
		
	}		
	public void visitTreeHeader(TDL.TreeHeader node)
	{
		
	}	
	public void visitNodeType(TDL.NodeType node)
	{
		txt("${name}");
	}
	public void visitPredefinedType(TDL.PredefinedType node)
	{
		
	}	
}
