/*
 * Copyright 2004-2009 ISP RAS (http://www.ispras.ru), UniTESK Lab (http://www.unitesk.com)
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
/*
 * @@author <A href="mailto:maryn@@ispras.ru">Mary Naprasnikova</A>
 * @@version $Id: NodeIteratorGenerator.java,v 1.6.2.12.2.9 2007/01/24 10:01:12 maryn Exp $
 */
package ru.ispras.redverst.stg.generator.iters;

import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;

import ru.ispras.redverst.iterator.ValueIterator;
import ru.ispras.redverst.stg.generator.StgNodeIteratorGenerateAction;

import com.unitesk.atp.tree.Node;
import com.unitesk.atp.tree.TreeClass.NodeClass;
import com.unitesk.atp.tree.generation.TextGeneratorVisitor;
import com.unitesk.atp.treedl.TDL;
import com.unitesk.atp.treedl.TDL.Attribute;
import com.unitesk.atp.treedl.TDL.BaseTree;
import com.unitesk.atp.treedl.TDL.Body;
import com.unitesk.atp.treedl.TDL.Cardinality;
import com.unitesk.atp.treedl.TDL.Child;
import com.unitesk.atp.treedl.TDL.ConstantType;
import com.unitesk.atp.treedl.TDL.Constructor;
import com.unitesk.atp.treedl.TDL.Field;
import com.unitesk.atp.treedl.TDL.FieldDescriptor;
import com.unitesk.atp.treedl.TDL.ID;
import com.unitesk.atp.treedl.TDL.Member;
import com.unitesk.atp.treedl.TDL.NameType;
import com.unitesk.atp.treedl.TDL.NodeDecl;
import com.unitesk.atp.treedl.TDL.NodeID;
import com.unitesk.atp.treedl.TDL.NodeType;
import com.unitesk.atp.treedl.TDL.QID;
import com.unitesk.atp.treedl.TDL.TDL_Visitor;
import com.unitesk.atp.treedl.TDL.TreeBody;
import com.unitesk.atp.treedl.TDL.TreeCode;
import com.unitesk.atp.treedl.TDL.TreeDesc;
import com.unitesk.atp.treedl.TDL.Type;
import com.unitesk.atp.treedl.TDL.Typedef;

/**
 * @author Maryn
 *
 * To change the template for this generated type comment go to
 * Window>Preferences>Java>Code Generation>Code and Comments
 */
public class NodeIteratorGenerator
	extends TextGeneratorVisitor
	implements TDL_Visitor {

	/**
	 * 
	 */
	public NodeIteratorGenerator() {
		super();
		// TODO Auto-generated constructor stub
	}

	//-------------------------------------------------------------------------
	/* (non-Javadoc)
	 * @see ru.ispras.redverst.atp.tdt.TDT_Visitor#visitTree(ru.ispras.redverst.atp.tdt.Tree)
	 */
	public void visitTreeDesc(TreeDesc node) {
		// TODO Auto-generated method stub

	}

	//-------------------------------------------------------------------------
	/* (non-Javadoc)
	 * @see ru.ispras.redverst.atp.tdt.TDT_Visitor#visitNodeDecl(ru.ispras.redverst.atp.tdt.NodeDecl)
	 */
	private List valueIterNameList = new ArrayList();
	private List constrParamList = new ArrayList();
	private String nodeName = ""; 
	
	private boolean initializedIters = false;
	public void visitNodeDecl(NodeDecl node) 
	{
		    nodeName = node.getName().getValue();
//			*******************************************************
			txt( "// Generated by ${.toolName}, version ${.toolVersion}" ); nl();
			txt( "// Source file: ${.sourceFileName}" ); nl();
			txt( "// Date: " + new java.util.Date() ); nl();
			txt( "// child-tree adder");nl();
			nl();
        
			txt( "package ru.ispras.redverst.stg.langdep.iterators.nodes.notabstract;" ); nl();
		    txt("import java.util.Arrays;"); nl();
		    txt("import java.util.*;"); nl();
		    txt("import ru.ispras.redverst.stg.langdep.iterators.nodes.notabstract.optchild.*;");nl();	
			txt("import ru.ispras.redverst.stg.langdep.iterators.nodes.isabstract.optchild.*;");nl();
			txt("import ru.ispras.redverst.stg.langdep.iterators.nodes.isabstract.*;");nl();
		    txt("import ru.ispras.redverst.stg.langdep.modl.${parent.treeNameShort}.*;");nl();
		    txt("import ru.ispras.redverst.iterator.ProductIterator;");nl();
		    txt("import ru.ispras.redverst.iterator.ValueIterator;");nl();
		    txt("import ru.ispras.redverst.stg.base.iterators.StgNodeIterator;");nl();		
		    txt("import ru.ispras.redverst.iterator.OneObjectIterator;	");nl();
		    txt("import ru.ispras.redverst.stg.base.BaseNode;" );nl();				
		    txt("import ru.ispras.redverst.stg.langdep.iterators.nodes.constant.*;" +
                "import ru.ispras.redverst.stg.langdep.iterators.nodes.childlist.*;");nl();
		    txt("import ru.ispras.redverst.stg.semrel.TypeDesc;");nl();
			txt("import java.util.ArrayList;");
			txt("import java.util.List;");
			
		    nl();	
                       
			txt( "public class ${name}Iterator extends StgNodeIterator");nl();	
		    
		    txt( "{");nl();incIndent();
		    nl();	
		    txt( "private ProductIterator mainIterator;");nl();
            
            txt("private static int uniqueValueCounter = 0;"); nl();
            
			list( "i"
				, 0
				, node.getOptFieldList().size()
				, "${optFieldList[i]}"
				, "" 
				);				    			    
//			******************* constructor ************************************			
			txt( "public ${name}Iterator()  throws IllegalAccessException, InstantiationException, ClassNotFoundException");nl();
			txt("{");nl();incIndent();
			txt( "super();");nl();
			txt( "setPrivateIterationBorder(--iterationBorder);");nl();
			txt( "try");nl();
			txt("{"); incIndent();
	            txt( "initInnerIterators();");nl();
	        popIndent(); txt("}");
	        txt( "catch (IllegalAccessException e)");nl();
	        txt("{"); incIndent();
	            txt( "e.printStackTrace();");nl();
//	            txt( "return false;");nl();
	        popIndent(); txt("}");
	        txt( "catch (InstantiationException e)");nl();
	        txt("{"); incIndent();
	            txt( "e.printStackTrace();");nl();
//	            txt( "return false;");nl();
	        popIndent(); txt("}");
	        txt( "catch (ClassNotFoundException e)");nl();
	        txt("{"); incIndent();
	            txt( "e.printStackTrace();");nl();
//	            txt( "return false;");nl();
	        popIndent(); txt("}");		
			popIndent();txt( "}");nl();
//          ********************* initInnerIters ***************************************
			txt("private void initInnerIterators()  throws IllegalAccessException, InstantiationException, ClassNotFoundException");nl();
			txt("{");nl();
			incIndent();
				initializedIters = true;
			    iter_counter = 0;
				list( "i"
					, 0
					, node.getOptFieldList().size()
					, "${optFieldList[i]}"
					, "iterationBorder = getPrivateIterationBorder();\n" 
					);				
//				txt( "if (iters.isEmpty()) throw new IllegalStateException(\"Recursion depth is overdraw. Try to change tdl-file.\");");nl();
				txt( " this.mainIterator = new ProductIterator(new ValueIterator[]{"); nl();
				for (int i=0; i < this.valueIterNameList.size(); i++) 
				{
					String element = (String) this.valueIterNameList.get(i);
					txt(element);
					if (i < valueIterNameList.size()-1) txt(", ");
				}
			popIndent();
			txt("});");nl();
			
			txt("}");nl();
//			******************* init ************************************			
			txt( "public  /*synchronized*/ boolean init() {");nl();incIndent();
//				txt( "try");nl();
//				txt("{"); incIndent();
//		            txt( "initInnerIterators();");nl();
//		        popIndent(); txt("}");
//		        txt( "catch (IllegalAccessException e)");nl();
//		        txt("{"); incIndent();
//		            txt( "e.printStackTrace();");nl();
//		            txt( "return false;");nl();
//		        popIndent(); txt("}");
//		        txt( "catch (InstantiationException e)");nl();
//		        txt("{"); incIndent();
//		            txt( "e.printStackTrace();");nl();
//		            txt( "return false;");nl();
//		        popIndent(); txt("}");
//		        txt( "catch (ClassNotFoundException e)");nl();
//		        txt("{"); incIndent();
//		            txt( "e.printStackTrace();");nl();
//		            txt( "return false;");nl();
//		        popIndent(); txt("}");			
				txt( "boolean res = this.mainIterator.init();");nl();
				txt( "if(!res ) return false;");nl();
				txt( "while(!getNextNode())");nl();
				txt( "{");nl();incIndent();
					txt( "if(!this.mainIterator.next()) return false;");nl();
				popIndent();txt( "}");nl();
				
				txt( "return true;");nl();
				
			popIndent();txt( "}");nl();
//			******************* next ************************************
            txt( "private ${name} nextNode ;");nl();			
			txt( "public  /*synchronized*/ boolean next() {");nl();incIndent();
				txt("if (checkIterationBorder && getPrivateIterationBorder()< 0)");nl();
				txt("{");nl();
				txt("return false;");nl();
//				    txt("	nextNode = new ${name}();");nl();
//					txt("if(usedLastValue)");nl();
//					txt("{");nl();
//					txt("return false;");nl();
//					txt("}");nl();
//					txt("else");nl();
//					txt("{");nl();
//					txt("usedLastValue = true;");nl();
//					txt("return true;");nl();
//					txt("}");nl();
				txt("}");nl();
				
				txt( "do {");nl();incIndent();
					txt( "if(!this.mainIterator.next()) return false;");nl();
				txt( "} while(!getNextNode());");nl();
						
				txt( "return true;");nl();
			popIndent();txt( "}");nl();
//			******************* get nextNode ************************************					
			txt( "public  /*synchronized*/ boolean getNextNode() {");nl();incIndent();
			txt("");nl();
			List constructorParamList = new ArrayList();
			txt("Object[] res = (Object[])this.mainIterator.value();");nl();		    
			txt("/*synchronized (res)*/{");nl();incIndent();
			List standardTypeParameters  = new ArrayList(0);
			for (int i = 0; i < this.valueIterNameList.size(); i++) 
			{
				// define parameter type
				String paramIter = (String) this.valueIterNameList.get(i);
				Node paramNode =   ((FieldDescriptor)this.constrParamList.get(i)).getNode();
				String paramType = null;
				if (paramNode instanceof Child )
				{
						NodeType new_name = (NodeType) ((Child)paramNode).getType();
						paramType = new_name.getName().getName().getValue();
				}
				if (paramNode instanceof Attribute )
				{
				   Type type = ((Attribute)paramNode).getType();
				   
				   if (type instanceof TDL.NameType)
				   {
					   paramType = ((TDL.NameType)type).getName();
				   }
				   if (type instanceof ConstantType)
				   {
					   paramType = "int";
				   }
				}
					                   
				int indexOfType = StgNodeIteratorGenerateAction.javaPrimitiveTypesList.indexOf(paramType);
				if(indexOfType >= 0)
				{
					constructorParamList.add(paramType); 
					standardTypeParameters.add(new Integer(i));
				} 
				else
				{
				    indexOfType = StgNodeIteratorGenerateAction.javaReferenceTypesList.indexOf(paramType);
					if(indexOfType >= 0)
					{
						constructorParamList.add(paramType); 
						standardTypeParameters.add(new Integer(i));
					}				    
				}
				
				FieldDescriptor field = ((FieldDescriptor)this.constrParamList.get(i));
				if (!field.isList())
				{
				    if (field.getKind() == TDL.FieldDescriptor.ATTRIBUTE 
		            && ((TDL.Attribute)field.getNode()).getType() instanceof TDL.NameType 
		            && ((NameType)((TDL.Attribute)field.getNode()).getType()).getName().equals("TypeDesc"))
				    {
				        txt(paramType + " param" + i + " = (TypeDesc)" + "res[" + i + "];");
				    }	
				    else
				    {
						if(!standardTypeParameters.contains(new Integer(i)))
						{
							txt(paramType + " param" + i + " = (res[" + i + "]!=null)?(" + paramType + ")" + "((BaseNode)res[" + i + "]).getCopy():null;");
						}
						else
						{
						    int paramTypeIndex = StgNodeIteratorGenerateAction.javaPrimitiveTypesList.indexOf(paramType);
						    paramType = paramTypeIndex >=0 ? (String)StgNodeIteratorGenerateAction.javaReferenceTypesList.get(paramTypeIndex) : paramType;
							txt(paramType + " param" + i + " = (" + paramType + ")" + "res[" + i + "];"); 
						}				        
				    }									
				}
				else
				{
					txt("List param" + i + " = null;");nl();
//					txt("if (res[" + i + "]!=null)");nl();
//					txt("{");nl();
					txt(" param" + i + " = new ArrayList(0);");nl(); 
//					if(!standardTypeParameters.contains(new Integer(i)))
//					{
						//getCopy because iterator should every time return node with parent null
                        txt("try {");nl();
						txt("       param" + i + "= (List)res[" + i + "];");
                        txt("}");nl();
                        txt("catch(Exception e){");nl();
                        txt("param" + i + ".add(res[" + i + "]" + ");");
                        txt("}");nl();
//					}
//					else
//					{
//						txt("param" + i + ".add(res[" + i + "]" + ");");
//					}		
//					txt("}");nl();
				}
				nl();
			} 
			txt("try {"); nl(); incIndent();
				txt(" nextNode = new ${name}(");
				for (int i=0; i < this.valueIterNameList.size(); i++) 
				{
					txt(" param" + i);
					int indexOfParam = standardTypeParameters.indexOf(new Integer(i));
					if (indexOfParam >=0 && StgNodeIteratorGenerateAction.javaPrimitiveTypesList.contains(constructorParamList.get(indexOfParam)))
					{
					    txt((String)StgNodeIteratorGenerateAction.javaCastTypes.get(StgNodeIteratorGenerateAction.javaPrimitiveTypesList.indexOf(constructorParamList.get(indexOfParam))));
					}
					if (i < valueIterNameList.size()-1) txt(", ");
				}
				txt(");");nl();		    
			popIndent(); txt("} catch(IllegalArgumentException ilArgExc){ return false; }"); nl();
			List listParamNumbers = new ArrayList(0);
		    
			int brack_counter = 0;
			boolean prevList = false;
			txt("boolean listRes = true;");nl();
			for (int i=0; i < this.valueIterNameList.size(); i++)
			{
				if(standardTypeParameters.contains(new Integer(i)))continue;

				if (!((FieldDescriptor)this.constrParamList.get(i)).isList())
				{
					txt("if(param" + i + " != null){");nl();incIndent();
						txt("if(param" + i + ".getRelevantChecker() == null");nl();
						txt("|| (param" + i + ".getRelevantChecker() != null && param" + i + ".getRelevantChecker().isSyntacticRelevantNode(param" + i + ", nextNode)>=0))");nl();
						txt("{");nl();incIndent();
							txt(" listRes = listRes && true;");nl();	
						popIndent();txt("}");nl();
						txt("else {");nl();incIndent();
							txt("listRes = listRes && false;");nl();
							txt("return listRes;");nl();		
						popIndent();txt("}");nl();	
					popIndent();txt("}");nl();	
				}
				else
				{	
					listParamNumbers.add(new Integer(i));	    		
					txt("for(int j" + listParamNumbers.size() + " = 0; param" + i + " != null ? j" + listParamNumbers.size() + "< param" + i + ".size(): false; j" + listParamNumbers.size() + "++)");
					txt("{");nl();incIndent();
						txt("if(((BaseNode)param" + i + ".get(j" + listParamNumbers.size() + "))!=null){");nl();incIndent();
							txt("if((((BaseNode)param" + i + ".get(j" + listParamNumbers.size() + ")).getRelevantChecker() == null");nl();
							txt("|| (((BaseNode)param" + i + ".get(j" + listParamNumbers.size() + ")).getRelevantChecker() != null && ((BaseNode)param" + i + ".get(j" + listParamNumbers.size() + ")).getRelevantChecker().isSyntacticRelevantNode(((BaseNode)param" + i + ".get(j" + listParamNumbers.size() + ")), nextNode)>=0)))");nl();
							txt("{");nl();incIndent();
								txt("listRes = listRes && true;");nl();
							popIndent();txt("}");nl();
							txt("else {");nl();incIndent();
								txt("listRes = listRes && false;");nl();
								txt("return listRes;");nl();
							popIndent();txt("}");nl();		
						popIndent();txt("}");nl();
					popIndent();txt("}");nl();				    								
				}				
			}

			txt("return listRes;");nl();
			popIndent();txt( "}");nl();
			popIndent();txt( "}");nl();
//			******************* value ************************************			
			txt( "public  /*synchronized*/ Object value() {");nl();incIndent();
		     

			txt( "return nextNode;");nl();
			popIndent();txt( "}");nl();
			
			popIndent();txt( "}");nl();            
	}


	//-------------------------------------------------------------------------
	/* (non-Javadoc)
	 * @see ru.ispras.redverst.atp.tdt.TDT_Visitor#visitMember(ru.ispras.redverst.atp.tdt.Member)
	 */
	public void visitMember(Member node) {
		// TODO Auto-generated method stub

	}

	//-------------------------------------------------------------------------
	/* (non-Javadoc)
	 * @see ru.ispras.redverst.atp.tdt.TDT_Visitor#visitField(ru.ispras.redverst.atp.tdt.Field)
	 */
	public void visitField(Field node) {
		// TODO Auto-generated method stub

	}

	//-------------------------------------------------------------------------
	/* (non-Javadoc)
	 * @see ru.ispras.redverst.atp.tdt.TDT_Visitor#visitAttribute(ru.ispras.redverst.atp.tdt.Attribute)
	 */
	private String constAttrName = "";
	public void visitAttribute(Attribute node) 
	{
		if (node.getType() instanceof TDL.ConstantType)
        {
            constAttrName = node.getName().getValue();
        }	    
		txt("${type}");   
	}

	//-------------------------------------------------------------------------
	/* (non-Javadoc)
	 * @see ru.ispras.redverst.atp.tdt.TDT_Visitor#visitChild(ru.ispras.redverst.atp.tdt.Child)
	 */
	private int iter_counter = 0;
	public void visitChild(Child node) 
	{		
		iter_counter++;
		Cardinality cardType = null;
		
		if ( node.getType() instanceof Cardinality )
		{    
		    cardType = (Cardinality)node.getType();
		}			
        
		if (!initializedIters)
        {
            if (((TDL.NodeType) node.getType()).getName().getNodeDecl()
                    .getIsAbstract())
            {
                switch (cardType.getCardinality())
                {
                    // *
                    case NameType.LIST | NameType.OPTIONAL:
                        txt("private ValueIterator "
                              + node.getName().getValue()  
                              + "OptionalListIterator"
                              + ";");
                        this.valueIterNameList.add(node.getName().getValue()  
                                + "OptionalListIterator");
                        break;
                    // ? not List
                    case NameType.OPTIONAL:
                        //			abstract, optional
                        txt("private ValueIterator" 
//                                + ((TDL.NodeType) node.getType()).getName().getName()
//                                .getValue()
//                                + "OptionalAbstractNodeIterator " 
                                + " optionalAbstract"
                                + ((TDL.NodeType) node.getType()).getName()
                                        .getName().getValue()
                                + "Iterator"
                                + iter_counter
                                + ";");
                        nl();
                        this.valueIterNameList.add("optionalAbstract"
                                + ((TDL.NodeType) node.getType()).getName()
                                        .getName().getValue() + "Iterator"
                                + iter_counter);
                        break;
                    // +
                    case NameType.LIST:
                    // list, not optional
                        txt("private ValueIterator "
                                + node.getName().getValue()  
                                + "NotOptionalListIterator"
                                + ";");
                        this.valueIterNameList.add(node.getName().getValue()  
                                + "NotOptionalListIterator");
                        break;
                    case 0:
                        //abstract, not optional, not list
                        txt("private ValueIterator"
//                                + ((TDL.NodeType) node.getType()).getName()
//                                        .getName().getValue()
//                                + "Iterator"
                                + " abstractNotOptional"
                                + ((TDL.NodeType) node.getType()).getName()
                                        .getName().getValue()
                                + "Iterator"
                                + iter_counter + ";");
                        nl();
                        this.valueIterNameList.add("abstractNotOptional"
                                + ((TDL.NodeType) node.getType()).getName()
                                        .getName().getValue() + "Iterator"
                                + iter_counter);
                        break;
                    default:
                        throw new IllegalArgumentException();
                }
            }
            else
            {
                // :      (  )   
                NodeDecl nodeDecl = ((TDL.NodeType) node.getType()).getName()
                        .getNodeDecl();

                boolean attrIter = true;

                for (Iterator iter = nodeDecl.getOptFieldList().iterator(); iter.hasNext();)
                {
                    Object obj = iter.next();
                    if (obj instanceof FieldDescriptor)
                    {
                        FieldDescriptor element = (FieldDescriptor) obj;
                        if (element.getNode() instanceof Child)
                        {
                            for (Iterator iter2 = ((TDL.NodeType) ((Child) element
                                    .getNode()).getType()).getName().getNodeDecl()
                                    .getOptFieldList().iterator(); iter2.hasNext();)
                            {
                                FieldDescriptor element2 = (FieldDescriptor) iter2
                                        .next();
                                if (element2.getNode() instanceof Child)
                                {
                                    attrIter = false;
                                    break;
                                }
                            }
                        }
                        if (!attrIter) break;
                    }
                }

                switch (cardType.getCardinality())
                {
                    // *
                    case NameType.LIST | NameType.OPTIONAL:
                        txt("private ValueIterator "
                                + node.getName().getValue()  
                                + "OptionalListIterator"
                                + ";");
                        this.valueIterNameList.add(node.getName().getValue()  
                                + "OptionalListIterator");
                        break;
                    // ? not List
                    case NameType.OPTIONAL:
                        //    				not abstract, optional
                        txt("private ValueIterator "
//                                + ((TDL.NodeType) node.getType()).getName()
//                                        .getName().getValue()
//                                + "OptionalIterator " 
                                + " notAbstractOptional"
                                + ((TDL.NodeType) node.getType()).getName()
                                        .getName().getValue()
                                + "Iterator"
                                + iter_counter + ";");
                        nl();
                        this.valueIterNameList.add("notAbstractOptional"
                                + ((TDL.NodeType) node.getType()).getName()
                                        .getName().getValue() + "Iterator"
                                + iter_counter);
                        break;
                    // +
                    case NameType.LIST:
                    // list, not optional
                        txt("private ValueIterator "
                                + node.getName().getValue()  
                                + "NotOptionalListIterator"
                                + ";");
                        this.valueIterNameList.add(node.getName().getValue()  
                                + "NotOptionalListIterator");
                        break;
                    case 0:
                        // not abstract, not optional not list
//                        if (attrIter)
                        {
                            txt("private ValueIterator "
//                                    + ((TDL.NodeType) node.getType()).getName()
//                                            .getName().getValue()
//                                    + "Iterator " 
                                    + "oneObject"
                                    + ((TDL.NodeType) node.getType()).getName()
                                            .getName().getValue()
                                    + "Iterator"
                                    + iter_counter + ";");
                            nl();
                            this.valueIterNameList.add("oneObject"
                                    + ((TDL.NodeType) node.getType()).getName()
                                            .getName().getValue() + "Iterator"
                                    + iter_counter);
                        }
//                        else
//                        {
//                            txt("private OneObjectIterator oneObject"
//                                    + ((TDL.NodeType) node.getType()).getName()
//                                            .getName().getValue()
//                                    + "Iterator"
//                                    + iter_counter + ";");
//                            nl();
//                            this.valueIterNameList.add("oneObject"
//                                    + ((TDL.NodeType) node.getType()).getName()
//                                            .getName().getValue() + "Iterator"
//                                    + iter_counter);
//                        }
                        break;
                    default:
                        throw new IllegalArgumentException();
                }
            }
        }
		// initialized iterators
		else 
		{
//		    txt( "if (this.isRelevantRecurDepth(\"" + ((TDL.NodeType) node.getType()).getName().getName().getValue() + "\"))");
	        txt("{"); incIndent();

            if (((TDL.NodeType) node.getType()).getName().getNodeDecl()
                    .getIsAbstract())
            {
                switch (cardType.getCardinality())
                {
                    // *
                    case NameType.LIST | NameType.OPTIONAL:
                        txt(node.getName().getValue()+ "OptionalListIterator"
                            + " = checkIterationBorder && getPrivateIterationBorder()>=0 && this.isRelevantRecurDepth(\"" + ((TDL.NodeType) node.getType()).getName()
                            .getName().getValue() + "\") || !checkIterationBorder? (ValueIterator)new "
                            + ((TDL.NodeType) node.getType()).getName().getName().getValue()
                            + "$ListIterator(true)" 
                            + ": (ValueIterator)new OneObjectIterator(new BaseNode().createInstance(\""+ ((TDL.NodeType) node.getType()).getName().getName().getValue() + "\"));");
                        break;
                    // ? not List
                    case NameType.OPTIONAL:
                        //			abstract, optional
                        txt("optionalAbstract"
                                + ((TDL.NodeType) node.getType()).getName()
                                        .getName().getValue()
                                + "Iterator"
                                + iter_counter
                                + " = checkIterationBorder && getPrivateIterationBorder()>=0 && this.isRelevantRecurDepth(\"" + ((TDL.NodeType) node.getType()).getName()
                                .getName().getValue() + "\") || !checkIterationBorder? (ValueIterator)new "
                                + ((TDL.NodeType) node.getType()).getName()
                                        .getName().getValue()
                                + "OptionalAbstractNodeIterator()" +
                                        ": (ValueIterator)new OneObjectIterator(new BaseNode().createInstance(\"" + ((TDL.NodeType) node.getType()).getName()
                                        .getName().getValue() + "\"));");
                        nl();
                        break;
                    // +
                    case NameType.LIST:
                    // list, not optional
                        txt(node.getName().getValue()+ "NotOptionalListIterator"
                                + " = checkIterationBorder && getPrivateIterationBorder()>=0 && this.isRelevantRecurDepth(\"" + ((TDL.NodeType) node.getType()).getName()
                                .getName().getValue() + "\") || !checkIterationBorder? (ValueIterator)new "
                                + ((TDL.NodeType) node.getType()).getName().getName().getValue()
                                + "$ListIterator(false)" 
                                + ": (ValueIterator)new OneObjectIterator(new BaseNode().createInstance(\""+ ((TDL.NodeType) node.getType()).getName().getName().getValue() + "\"));");                        
                        break;
                    case 0:
                        //abstract, not optional, not list
                        txt("abstractNotOptional"
                                + ((TDL.NodeType) node.getType()).getName()
                                        .getName().getValue()
                                + "Iterator"
                                + iter_counter
                                + " = checkIterationBorder && getPrivateIterationBorder()>=0 && this.isRelevantRecurDepth(\"" + ((TDL.NodeType) node.getType()).getName()
                                .getName().getValue() + "\") || !checkIterationBorder? (ValueIterator)new "
                                + ((TDL.NodeType) node.getType()).getName()
                                        .getName().getValue() + "Iterator()" +
                                        ": (ValueIterator)new OneObjectIterator(new BaseNode().createInstance(\"" + ((TDL.NodeType) node.getType()).getName()
                                        .getName().getValue() + "\"));");
                        nl();
                        break;
                    default:
                        throw new IllegalArgumentException();
                }
            }
            else
            {
                // :      (  )   
                NodeDecl nodeDecl = ((TDL.NodeType) node.getType()).getName()
                        .getNodeDecl();

                boolean attrIter = true;

                for (Iterator iter = nodeDecl.getOptFieldList().iterator(); iter
                        .hasNext();)
                {
                    FieldDescriptor element = (FieldDescriptor) iter.next();
                    if (element.getNode() instanceof Child)
                    {
                        for (Iterator iter2 = ((TDL.NodeType) ((Child) element
                                .getNode()).getType()).getName().getNodeDecl()
                                .getOptFieldList().iterator(); iter2.hasNext();)
                        {
                            FieldDescriptor element2 = (FieldDescriptor) iter2
                                    .next();
                            if (element2.getNode() instanceof Child)
                            {
                                attrIter = false;
                                break;
                            }
                        }
                    }
                    if (!attrIter)
                        break;
                }

                switch (cardType.getCardinality())
                {
                    // *
                    case NameType.LIST | NameType.OPTIONAL:
                        txt(node.getName().getValue()+ "OptionalListIterator"
                                + " = checkIterationBorder && getPrivateIterationBorder()>=0 && this.isRelevantRecurDepth(\"" + ((TDL.NodeType) node.getType()).getName()
                                .getName().getValue() + "\") || !checkIterationBorder? (ValueIterator)new "
                                + ((TDL.NodeType) node.getType()).getName().getName().getValue()
                                + "$ListIterator(true)" 
                                + ": (ValueIterator)new OneObjectIterator(new BaseNode().createInstance(\""+ ((TDL.NodeType) node.getType()).getName().getName().getValue() + "\"));");
                        break;
                    // ? not List
                    case NameType.OPTIONAL:
                        //    				not abstract, optional
                        txt("notAbstractOptional"
                                + ((TDL.NodeType) node.getType()).getName()
                                        .getName().getValue()
                                + "Iterator"
                                + iter_counter
                                + " = checkIterationBorder && getPrivateIterationBorder()>=0 && this.isRelevantRecurDepth(\"" + ((TDL.NodeType) node.getType()).getName()
                                .getName().getValue() + "\") || !checkIterationBorder? (ValueIterator)new "
                                + ((TDL.NodeType) node.getType()).getName()
                                        .getName().getValue()
                                + "OptionalIterator()" +
                                ": (ValueIterator)new OneObjectIterator(new BaseNode().createInstance(\"" + ((TDL.NodeType) node.getType()).getName()
                                .getName().getValue() + "\"));");
                        nl();

                        break;
                    // +
                    case NameType.LIST:
                    // list, not optional
                        txt(node.getName().getValue()+ "NotOptionalListIterator"
                                + " = checkIterationBorder && getPrivateIterationBorder()>=0 && this.isRelevantRecurDepth(\"" + ((TDL.NodeType) node.getType()).getName()
                                .getName().getValue() + "\") || !checkIterationBorder? (ValueIterator)new "
                                + ((TDL.NodeType) node.getType()).getName().getName().getValue()
                                + "$ListIterator(false)" 
                                + ": (ValueIterator)new OneObjectIterator(new BaseNode().createInstance(\""+ ((TDL.NodeType) node.getType()).getName().getName().getValue() + "\"));");                        
                        break;
                    case 0:
                        // not abstract, not optional not list
//                        if (attrIter)
                        {
                            txt("oneObject"
                                    + ((TDL.NodeType) node.getType()).getName()
                                            .getName().getValue()
                                    + "Iterator"
                                    + iter_counter
                                    + " = checkIterationBorder && getPrivateIterationBorder()>=0 && this.isRelevantRecurDepth(\"" + ((TDL.NodeType) node.getType()).getName()
                                .getName().getValue() + "\") || !checkIterationBorder? (ValueIterator)new "
                                    + ((TDL.NodeType) node.getType()).getName()
                                            .getName().getValue()
                                    + "Iterator()" +
                                    ": (ValueIterator)new OneObjectIterator(new BaseNode().createInstance(\"" + ((TDL.NodeType) node.getType()).getName()
                                    .getName().getValue() + "\"));");
                            
                            nl();
                        }
//                        else
//                        {
//                            txt("oneObject"
//                                    + ((TDL.NodeType) node.getType()).getName()
//                                            .getName().getValue()
//                                    + "Iterator"
//                                    + iter_counter
//                                    + " = new OneObjectIterator(new BaseNode().createInstance(\""
//                                    + ((TDL.NodeType) node.getType()).getName()
//                                            .getName().getValue() + "\"));");
//                            nl();
//
//                        }
                        break;
                    default:
                        throw new IllegalArgumentException();
                }
            }
	        popIndent(); txt("}");
//	        txt("else ");
//	        txt("{"); incIndent();
//	        txt(" throw new IllegalStateException(\"Recursion depth is overdraw. Try to change tdl-file.\");");
//	        popIndent(); txt("}");            
        }
		
	}

	//-------------------------------------------------------------------------
	/* (non-Javadoc)
	 * @see ru.ispras.redverst.atp.tdt.TDT_Visitor#visitBody(ru.ispras.redverst.atp.tdt.Body)
	 */
	public void visitBody(Body node) {
		// TODO Auto-generated method stub

	}

	//-------------------------------------------------------------------------
	/* (non-Javadoc)
	 * @see ru.ispras.redverst.atp.tdt.TDT_Visitor#visitConstructor(ru.ispras.redverst.atp.tdt.Constructor)
	 */
	public void visitConstructor(Constructor node) {
		// TODO Auto-generated method stub

	}

	//-------------------------------------------------------------------------
	/* (non-Javadoc)
	 * @see ru.ispras.redverst.atp.tdt.TDT_Visitor#visitTypedef(ru.ispras.redverst.atp.tdt.Typedef)
	 */
	public void visitTypedef(Typedef node) {
		// TODO Auto-generated method stub

	}

	//-------------------------------------------------------------------------
	/* (non-Javadoc)
	 * @see ru.ispras.redverst.atp.tdt.TDT_Visitor#visitType(ru.ispras.redverst.atp.tdt.Type)
	 */
	public void visitType(Type node) {
		// TODO Auto-generated method stub

	}

	//-------------------------------------------------------------------------
	/* (non-Javadoc)
	 * @see ru.ispras.redverst.atp.tdt.TDT_Visitor#visitNameType(ru.ispras.redverst.atp.tdt.NameType)
	 */
	public static int idCount = 0;
	public void visitNameType(NameType node) 
	{				
		iter_counter++;
		int typeIndex = StgNodeIteratorGenerateAction.javaPrimitiveTypesList.indexOf(node.getName()); 
        
        if (!initializedIters)
        {
            if (typeIndex >= 0)
            {
//                String param = (String) StgNodeIteratorGenerateAction.javaReferenceTypesDefaultValuesList
//                        .get(typeIndex);
                txt("private OneObjectIterator oneObject${name}Iterator"
                        + iter_counter + ";");
                nl();
            }
            else
            {
                if (node.getName().equals("TypeDesc"))
                {
                    txt("private TypeDescIterator oneObject${name}Iterator"
                            + iter_counter + ";");
                    nl();
                }
                else
                {
                    typeIndex = StgNodeIteratorGenerateAction.javaReferenceTypesList
                            .indexOf(node.getName());
                    if (typeIndex >= 0)
                    {
//                        String param = (String) StgNodeIteratorGenerateAction.javaReferenceTypesDefaultValuesList
//                                .get(typeIndex);
                        txt("private OneObjectIterator oneObject${name}Iterator"
                                + iter_counter + ";");
                        nl();
                    }
                    else
                    {
                        txt("private OneObjectIterator oneObject${name}Iterator"
                                + iter_counter + ";");
                        nl();
                    }
                }
            }

            this.valueIterNameList.add("oneObject" + node.getName()
                    + "Iterator" + iter_counter); 
        }
		else 
		{
		    // initialize iters
            if (typeIndex >= 0)
            {
                String param = (String) StgNodeIteratorGenerateAction.javaReferenceTypesDefaultValuesList
                        .get(typeIndex);
                if (param.indexOf("\"")>=0)
                {
                    param = param.replaceFirst("\"", "");
                    param = param.replaceFirst(param.substring(param
                            .indexOf("\"")), "");
                }
                txt("oneObject${name}Iterator"
                        + iter_counter
                        + " = new OneObjectIterator(new "
                        + (String) StgNodeIteratorGenerateAction.javaReferenceTypesList
                                .get(typeIndex) + "(" + param + " + ++uniqueValueCounter));");
                nl();
            }
            else
            {

                if (node.getName().equals("TypeDesc"))
                {
                    txt("oneObject${name}Iterator"
                            + iter_counter + " = new TypeDescIterator();");
                    nl();
                }
                else
                {
                    typeIndex = StgNodeIteratorGenerateAction.javaReferenceTypesList
                            .indexOf(node.getName());
                    if (typeIndex >= 0)
                    {
                        String param = (String) StgNodeIteratorGenerateAction.javaReferenceTypesDefaultValuesList
                                .get(typeIndex);

                        txt("oneObject${name}Iterator"
                                + iter_counter
                                + " = new OneObjectIterator(new "
                                + node.getName() + "(" + param + " + ++uniqueValueCounter));");
                        nl();
                    }
                    else
                    {
                        txt("oneObject${name}Iterator"
                                + iter_counter
                                + " = new OneObjectIterator(new "
                                + node.getName() + "(\"\"));");
                        nl();
                    }
                }
            }
        }
	}

	//-------------------------------------------------------------------------
	/* (non-Javadoc)
	 * @see ru.ispras.redverst.atp.tdt.TDT_Visitor#visitConstantType(ru.ispras.redverst.atp.tdt.ConstantType)
	 */
	public void visitConstantType(ConstantType node) 
	{
		iter_counter++;
		if (!initializedIters)
        {
            txt("private " + this.nodeName + constAttrName
                    + "ConstIterator constIterator" + iter_counter + ";"/*+ " = new " + this.nodeName + constAttrName + "ConstIterator();"*/);
            nl();
            this.valueIterNameList.add("constIterator" + iter_counter); 
        }	
		else
		{
            txt("constIterator" + iter_counter + " = new " + this.nodeName + constAttrName + "ConstIterator();");		    
		}
	}

	//-------------------------------------------------------------------------
	/* (non-Javadoc)
	 * @see ru.ispras.redverst.atp.tdt.TDT_Visitor#visitID(ru.ispras.redverst.atp.tdt.ID)
	 */
	public void visitID(ID node) {
		txt("${value}");

	}

	//-------------------------------------------------------------------------
	/* (non-Javadoc)
	 * @see ru.ispras.redverst.atp.tdt.TDT_Visitor#visitFieldDescriptor(ru.ispras.redverst.atp.tdt.FieldDescriptor)
	 */
	public void visitFieldDescriptor(FieldDescriptor node) 
	{
		if(node.isConstructorParameter())
		{
			this.constrParamList.add(node);
			txt("${node}");
		} 
	}
	public void visitNodeClass(NodeClass node)
	{
		
	}
	public void visitNodeID(NodeID node)
	{
		txt("${name}");
	}	
	public void visitTreeBody(TreeBody node)
	{
		
	}
	public void visitCardinality(Cardinality node)
	{
		
	}	
	public void visitTreeCode(TreeCode node)
	{
		
	}	
	public void visitBaseTree(BaseTree node)
	{
		
	}	
	public void visitQID(QID node)
	{
		
	}		
	public void visitTreeHeader(TDL.TreeHeader node)
	{
		
	}	
	public void visitNodeType(TDL.NodeType node)
	{
		txt("${name}");
	}
	public void visitPredefinedType(TDL.PredefinedType node)
	{
		
	}
}
