/*
 * Copyright 2004-2009 ISP RAS (http://www.ispras.ru), UniTESK Lab (http://www.unitesk.com)
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package ru.ispras.redverst.stg.tdl_plugins;

import com.unitesk.atp.messages.NameNotFoundMessage;
import com.unitesk.atp.tree.tool.Action;
import com.unitesk.atp.treedl.TDL_Tree;


/**
 * @author <A href="mailto:maryn@ispras.ru">Maria Naprasnikova</A>
 * @version $Id: StgNodesGenerateAction.java,v 1.1.1.1 2005/03/17 10:09:45 maryn Exp $
 */
public class StgNodesGenerateAction extends Action
{
    public void process( com.unitesk.atp.tree.tool.Tree t )
    {
        TDL_Tree tree = (TDL_Tree)t;
        
        String checkAction = getProperty( "check.action", "check" );
        Object checker = getPlugin( checkAction );

        if( !(checker instanceof Action) )
        {
            mbox.fatal( new NameNotFoundMessage( null
                                               , null
                                               ,  mbox
                                                 .getStringManager()
                                                 .getString( Action.class
                                                           , "message.action"
                                                           )
                                               , checkAction 
                                               ) 
                      );
        }
        ((Action)checker).process( tree );

        String output_dir = getProperty( "output.dir", "." );

        boolean update_mode = getProperty( "update", "true" ).equals( "true" );

        StgJavaLanguageDescription language = new StgJavaLanguageDescription();

        language.translate( tree
                          , output_dir
                          , update_mode
                          );
    }

    /**
     * {@inheritDoc}
     */
    public String getVersion()
    {
        return "1.0.0";
    }
}
